/**
 * Created by douhao on 2016/4/18.
 */
angular.module('caseDetail-controller',[])
  .controller('CaseDetailCtrl',function($scope,$rootScope,$stateParams,$state,$ionicScrollDelegate,caseService,$timeout,$ionicActionSheet,$location,$ionicModal,commentService,$animate,$sce,viewService,$cordovaToast,HomeService,showAlertService,UserService,$ionicHistory){
    var caseDetailviewScroll = $ionicScrollDelegate.$getByHandle('caseDetailsScroll');
    $scope.params = {
      hasmore : true ,
      from : 1 ,
      pageSize:10,
    }
    $scope.module = "case" ;
    $ionicModal.fromTemplateUrl('templates/diagnose/authority-warn.html', {
      scope: $scope,
      animation: 'slide-in-down'
    }).then(function(modal) {
      $scope.modal = modal;
    });
    $scope.share_header = "https://open.weixin.qq.com/connect/oauth2/authorize?appid=wx6939749493987808&redirect_uri=" ;
    $scope.share_footer = "&response_type=code&scope=snsapi_userinfo#wechat_redirect" ;
    $scope.img_url = img.case_url ;
    $scope.case = null;
    $scope.answers = null ;         //答案列表
    $scope.questionType = null ;
    $scope.userAnswer = null ;
    $scope.checkLogin = null ;    //判断是否需要登录
    $scope.trueAnswer = "" ;      //正确答案
    $scope.comments = [] ;        //评论列表data
    $scope.answer = null ;        //答案
    $scope.choose = "" ;          //用户的选择
    $scope.thinking = "" ;         //答题思路
    $scope.imgListIsShow = true ;
    $scope.caseId = $stateParams.caseId ;
    //获取病历详情信息及评论
    $scope.getCaseDetail = function(){
      caseService.findByCaseId($stateParams.caseId)
        .then(function(result) {

          $scope.case = $scope.changeImgUrl(result.result)
          //console.log($scope.case.interpretation);
          //console.log($sce.trustAsHtml($scope.case.interpretation)) ;
          $scope.case.impressions = $sce.trustAsHtml($scope.case.impressions.replace(/<\/?font[^>]*>/gi,"")) ;
          $scope.case.interpretation = $sce.trustAsHtml($scope.case.interpretation.replace(/<\/?font[^>]*>/gi,"")) ;
          $scope.questionType = result.result.questionType ;
          $scope.imgList = result.result.studiesList['a1']['a1'];
          imageCount = result.result.studiesList['a1']['a1'].length;
//        console.log(result.result.checkLogin)
          $scope.checkLogin = result.result.checkLogin;
          //获取问题及答案
          $scope.findAnswerByCaseId() ;
          if($rootScope.user.id != 0) {
            //判断当前用户是否回答问题
            $scope.IsUserAnswer();
          }
          //增加阅读量
          $scope.readNum() ;

          caseService.isCollect($rootScope.user.id,$stateParams.caseId)
            .then(function(data){
              caseService.isAgree($stateParams.caseId,$rootScope.user.id)
                .then(function(agreeData){
                  $scope.socialInfo.init($scope.case.agreeNum,$scope.case.storeNum,$scope.case.readNum,$scope.case.commentNum,agreeData.result,data.result);
                })
            })
          // 初始化view
          $scope.view.init(result.result.studiesList['a1']['a1']);
        })
    }

    //页面加载完成在请求数据
    $scope.$on('$ionicView.afterEnter', function() {

      $scope.getCaseDetail() ;

    }, false);

    //返回
    $scope.goToBack = function() {
      $rootScope.goToBack();
    };

    $scope.adjustSlideHeight = function(index){
      adjustSlideHeight(angular.element("#caseSlide .img")[index], false);
    }

    //监控UserId变化，读取个人信息
    $rootScope.$watch('user.id',function(newValue,oldValue){
      if(newValue > 0){
        //判断当前用户是否回答问题
        $scope.IsUserAnswer() ;
      }
    })

    //$scope.onDragDown = function(){
    //  $animate.enabled(true) ;
    //  //console.log(caseDetailviewScroll.getScrollPosition()) ;
    //  if(caseDetailviewScroll.getScrollPosition().top <= 360){
    //    $scope.imgListIsShow = true ;
    //  }
    //}
    //$scope.onDragUp = function(){
    //  $animate.enabled(true) ;
    //  if(caseDetailviewScroll.getScrollPosition().top > 360){
    //    $scope.imgListIsShow = false ;
    //  }
    //}


    //分享
    $scope.isShare = false ;
    $scope.share = function(type){
      $scope.isShare = false ;
      for(var i in $rootScope.share_urls){
        if($rootScope.share_urls[i].confKey == "share_case"){
          //$scope.shareUrl = $scope.share_header+encodeURIComponent($rootScope.share_urls[i].confValue + "?id="+$stateParams.caseId)+$scope.share_footer ;
          //$scope.shareUrl = $rootScope.share_urls[i].confValue + "?id="+$stateParams.caseId ;
          $scope.shareUrl = $rootScope.share_urls[i].confValue.replace("{id}",$stateParams.caseId) ;
        }
      }
      //alert("$scope.shareUrl="+$scope.shareUrl) ;
      //分享参数
      switch(type){
        case 0:
          $scope.scene = Wechat.Scene.SESSION;
          break ;
        case 1:
          $scope.scene = Wechat.Scene.TIMELINE;
          break ;
      }
      Wechat.isInstalled(function (installed) {
        if(installed == "No"){
          $scope.isShare = false ;
          showAlertService.PopAlert("提示信息","请先安装微信再分享","确认","") ;
          return ;
        }else{
          Wechat.share({
            message:{
              title: "影领APP-经典病例",
              description: $scope.case.courseDescription==null?"":$scope.case.courseDescription,
              thumb: $scope.case.studiesList['a1']['a1'][0].imageUrl,
              mediaTagName: "影领-TAG-001",
              messageExt: "影领",
              messageAction: "<action>dotalist</action>",
              media: {
                type:Wechat.Type.LINK ,
                webpageUrl:$scope.share_header+encodeURIComponent($scope.shareUrl)+$scope.share_footer
                //webpageUrl: $scope.shareUrl
              }
            },
            scene: $scope.scene
          }, function () {
            //$cordovaToast.showShortBottom('分享成功') ;
            //showAlertService.PopShow("提示信息","分享成功",1000) ;
            HomeService.addShareRecord($rootScope.user.id,$stateParams.caseId,1,$scope.shareUrl)
              .then(function(result){
              }) ;
          }, function (reason) {
            //showAlertService.PopShow("提示信息","分享失败",1000) ;
          });
        }
      });
    }
    //显示分享
    $scope.showShare = function() {
      if($rootScope.share_urls == null || $rootScope.share_urls == undefined){
        $rootScope.$broadcast('message',"正在获取分享信息，请稍后再试！",3000,"notice");
        UserService.getConfByType('share')
          .then(function(result){
            if(result.success){
              $rootScope.share_urls= result.result ;
            }
          })
        return ;
      }
      $scope.isShare = true ;
      var testUrl = "http://www.yinglink.com/hawk/webChart.jsp?type=http://www.yinglink.com/hawk/admin/medical_records.jsp?id={share_id}" ;
      $scope.shareUrl = testUrl.replace("{share_id}",$stateParams.caseId) ;
      //console.log("分享地址="+$scope.shareUrl) ;
    };
    //取消分享
    $scope.cancelShare = function(){
      $scope.isShare = false ;
    }

    $scope.showImgList = function(){
      $animate.enabled(true) ;
      $scope.imgListIsShow = true ;
    }

    //更改图片路径
    $scope.changeImgUrl = function(list){
      var img_path = "/jpeg" ;
      for(var i in list.studiesList['a1']['a1']){
        var imgUrl = list.studiesList['a1']['a1'][i].thumbnail ;
        if(!imgUrl){
          list.studiesList['a1']['a1'][i].imageUrl = "img/study/no_learn.png";
        }else{
          if(imgUrl.substr(0,7)!="http://" && imgUrl.substr(0,8)!="https://"){
            list.studiesList['a1']['a1'][i].imageUrl = $scope.img_url +"/" +list.studiesList['a1']['a1'][i].caseInfoId +img_path +"/"+imgUrl ;
          }else{
            list.studiesList['a1']['a1'][i].imageUrl = imgUrl ;
          }
        }
      }
      return list;
    }

    //获取问题答案信息
    $scope.findAnswerByCaseId = function(){
      caseService.findQuestionByCaseId($stateParams.caseId)
        .then(function(res) {
          if(res.code == 0 && !!res.result){
            $scope.answers = res.result;
            angular.forEach($scope.answers, function (data) {
              if ("y" == data.isTrue) {
                $scope.trueAnswer += "" + data.orderby + '、' + data.content + ";";
              }
            })
          }
        })
    }

    //判断当前用户是否回答过问题
    $scope.IsUserAnswer = function(){
      caseService.IsUserAnswer($rootScope.user.id,$stateParams.caseId)
        .then(function(re){
          if(re.code == 0 && !! re.result){
            $scope.userAnswer = re.result ;
            //如果用户回答过该题目
            if (re.result != null && re.result.chooseAnswer != ""){
              $scope.choose = re.result.chooseAnswer ;
            }
          }
        })
    }

    $scope.selectChange = function(choice,item){
      $scope.checkChoice = "" ;
      if($scope.questionType == 0){
        $scope.checkChoice = item.orderby + "、"+item.content+";" ;
      }else if($scope.questionType == 1){
        for(var i in choice){
          if(choice[i].checked != undefined && choice[i].checked == true){
            $scope.checkChoice += choice[i].orderby + '、' + choice[i].content + ";";
          }
        }
      }
      if($scope.checkChoice != ""){
        $scope.isChecked = true ;
      }else{
        $scope.isChecked = false ;
      }
    }

    //提交答案
    $scope.submitAnswer = function(choice,thinking){
      $scope.thinking = thinking ;

      var checkChoice = $scope.checkChoice ;
      $scope.choose = checkChoice ;

      //判断checkLogin是否为N，N：Y:
     if($rootScope.user.id <= 0){
        //跳转到登录页面
        $scope.choose = "";
        $rootScope.$broadcast('login:show');
      }else{
        $scope.choiceIsTrue(checkChoice) ;
      }

    }

    //判断答案是否正确
    $scope.choiceIsTrue = function(choice){
      //true:答对，false:答错
      if(choice == $scope.trueAnswer){
        $scope.submitFlag = "correct" ;
        //增加答题记录
        $scope.changeAnswerHistoryInfo(choice,'y') ;
        if($rootScope.user.id == 0){
          $scope.choose = "" ;
          $scope.submitFlag = "" ;
        }
      }else{
        $scope.submitFlag = "mistake" ;
        //增加答题记录
        $scope.changeAnswerHistoryInfo(choice,'n') ;
        if($rootScope.user.id == 0){
          $scope.choose = "" ;
          $scope.submitFlag = "" ;
        }
        //错题库中查找是否存在，不存在即加入错题库中。
        if($rootScope.user.id > 0){
          $scope.wrongIsExist(choice)
        }
      }
    }

    $scope.reCompute = function(selected){
      var tempArr = selected.split(";");
      if (tempArr.length == 1){
        return selected;
      }
      var resu = [];
      for(var i = 0;i < tempArr.length;i++){
        resu.push(tempArr[i].substring(0,tempArr[i].indexOf("、")));
      }
      return resu.join(" ");
    }

    //增加答题记录
    $scope.changeAnswerHistoryInfo = function(choice,isRight){
      caseService.changeAnswerHistoryInfo($rootScope.user.id,$stateParams.caseId,choice,$scope.trueAnswer,isRight,$scope.thinking)
        .then(function(){
        })
      //判断答错还是答对
      var resu = $scope.reCompute(choice) ;
      if(isRight == "y"){
        resu = "<i class='iconfont icon-datizhengque'></i> " + resu ;
      }else{
        resu = "<i class='iconfont icon-daticuowu'></i> " + resu ;
      }
      resu += "<br>" + "答题思路："+ $scope.thinking
      var replyModel = {
        carrierId: $stateParams.caseId,
        carrierType: 1 ,
        userId: $rootScope.user.id ,
        comment: resu ,
      }
      commentService.submitComment(replyModel)
        .then(function(result) {
          $scope.socialInfo.text.commentNum += 1 ;
          $scope.comment.flushComment() ;
        })
    }

    //查询错题库判断是否存在此道错题
    $scope.wrongIsExist = function(choice){
      caseService.wrongIsExist($rootScope.user.id,$stateParams.caseId)
        .then(function(result){
          if(result.code == 0 && result.result == false){
            $scope.addWrong(choice) ;
          }
        })
    }

    //添加错题
    $scope.addWrong = function(choice){
      caseService.addWrong($rootScope.user.id,$stateParams.caseId,$scope.trueAnswer,choice,$scope.thinking)
        .then(function(result){
          //console.log("添加至错题库");
        })
    }

    //增加阅读量
    $scope.readNum = function(){
      caseService.readNum($rootScope.user.id,$stateParams.caseId)
        .then(function (result) {
//        console.log("result="+result) ;
          if(result.code == 0){
            $scope.case.readNum += 1 ;
            $scope.updateSocial($rootScope.updateSocial.operRead,$rootScope.updateSocial.operationAdd) ;
          }
          //$scope.$emit("social", $stateParams.caseId);
        })
    }

    //操作列表页的社交数据
    $scope.updateSocial = function(operType,operation){
      $scope.$emit("social", $stateParams.caseId,$scope.module,operType,operation);
    }

    // 快速回复评论框
    $scope.show = function() {
      // 显示操作表
      $ionicActionSheet.show({
        buttons: [
          { text: '学习了, 感谢楼主提供这么好的病例' },
          { text: '我补充了几点看法' },
          { text: '我有不同意见' },
          { text: '这个病例我遇见过' },
          { text: '涨见识了,这个没见过,下回碰到了就心里有数啦' },
        ],
        titleText: '快速回复',
        cancelText: 'Cancel',
        buttonClicked: function(index) {
          //console.log(this.buttons[index].text) ;
          $scope.send_content = "" ;
          $scope.send_content = this.buttons[index].text ;
          return true;
        }
      });
    };


    /********* 评论功能开始 *********/
    $scope.comment = {
      comments: [],
      send_content: '',
      reply_head: '',
      expandId: -1,
      carrierId: $stateParams.caseId,
      carrierType: 1,
      complainType: 1,
      isSubmited: true
    };
    $scope.comment.params = {
      hasmore : false,
      from : 1,
      pageSize:3
    };

    $scope.comment.replyModel = {};

    $scope.comment.keyDown = function(e){
      var keyCode = window.event?e.keyCode:e.which;
      // 删除
      if (keyCode == 8){
        //console.log($scope.comment.send_content)
        //console.log($scope.comment.reply_head)
        if ($scope.comment.send_content + ' ' == $scope.comment.reply_head || $scope.comment.send_content == $scope.comment.reply_head){
          $scope.comment.replyModel = {};
          $scope.comment.send_content = '';
          $scope.comment.reply_head = '';
        }
      }
    }

    $scope.comment.submitComment = function(){
      if (!$scope.comment.send_content && !$scope.comment.send_content.trim()){
        return;
      }

      var comment = $scope.comment.send_content.replace($scope.comment.reply_head, '');
      if (!comment && !comment.trim()){
        return;
      }

      $scope.comment.isSubmited = false ;
      $scope.comment.replyModel.carrierId = $scope.comment.carrierId;
      $scope.comment.replyModel.carrierType = $scope.comment.carrierType;
      $scope.comment.replyModel.userId = $rootScope.user.id;
      $scope.comment.replyModel.comment = comment.replace(/\n/g, '<br/>');
      commentService.submitComment($scope.comment.replyModel)
        .then(function(result){
          if (!$scope.comment.replyModel.parentId){
            $scope.comment.flushComment() ;
            $scope.comment.replyModel = {};
          }else{
            commentService.getSubComment($scope.comment.carrierType, $scope.comment.replyModel.parentId)
              .then(function(result){
                for(var i in $scope.comment.comments){
                  if ($scope.comment.comments[i].id == $scope.comment.replyModel.parentId){
                    $scope.comment.comments[i].subComments=$scope.comment.changeImgUrl(result.result);
                    $scope.comment.replyModel = {};
                  }
                }
              })
          }
          $scope.comment.send_content = '';
          $scope.comment.reply_head = '';
        })
        .finally(function(){
          $scope.comment.isSubmited = true ;
        })
    }
    /********* 评论功能结束 *********/

    /********* 社交功能开始 *********/
    $scope.textAreaMoveEnd = function(){
      //console.log("点击事件触发");
      commentService.moveEnd(document.getElementById('task-detail-comment-area'));
    }
    $scope.socialInfo = {};
    // 控制社交功能区展示
    $scope.socialInfo.show = {};
    // 控制社交数值展示
    $scope.socialInfo.text = {};
    // 控制社交图标展示
    $scope.socialInfo.icon = {};

    $scope.socialInfo.show.likeFlag = true;
    $scope.socialInfo.show.storeFlag = true;
    $scope.socialInfo.show.readFlag = true;
    $scope.socialInfo.show.commentFlag = false;

    $scope.socialInfo.init = function(likeNum, storeNum, readNum, commentNum, liked, stored){
      $scope.socialInfo.text.likeNum = likeNum;
      $scope.socialInfo.text.storeNum = storeNum;
      $scope.socialInfo.text.readNum = readNum;
      $scope.socialInfo.text.commentNum = commentNum;
      $scope.socialInfo.icon.liked = liked;
      $scope.socialInfo.icon.stored = stored;
    }

    $scope.socialInfo.like = function(flag){
      if($rootScope.user.id <= 0){
        $rootScope.$broadcast('login:show');
        return ;
      }
      if (flag){
        $scope.socialInfo.icon.liked = true;
        $scope.socialInfo.text.likeNum += 1;
        caseService.addAgree($stateParams.caseId,$rootScope.user.id)
          .then(function(resu){
            if(resu.code == 0){
              $scope.updateSocial($rootScope.updateSocial.operAgree,$rootScope.updateSocial.operationAdd) ;
            }else{
              $scope.soocialInfo.text.likeNum -= 1;
            }
          },function(error){
            $scope.socialInfo.icon.liked = false;
            $scope.socialInfo.text.likeNum -= 1;
          })
      }else{
        return ;
        //console.log('I do not this video.');
        //caseService.reduceAgree($stateParams.caseId)
        //  .then(function(result) {
        //    if(result.state && result.state == 401){
        //      console.log("没有权限，请登录")
        //      $scope.modal.show() ;
        //    }else{
        //      $scope.socialInfo.icon.liked = false;
        //      $scope.socialInfo.text.likeNum -= 1;
        //      $scope.updateSocial($rootScope.updateSocial.operAgree,$rootScope.updateSocial.operationReduce) ;
        //    }
        //  })
      }
      // TODO

    }

    $scope.socialInfo.store = function(flag){
      if($rootScope.user.id <= 0){
        $rootScope.$broadcast('login:show');
        return ;
      }
      if (flag){
        $scope.socialInfo.icon.stored = true;
        $scope.socialInfo.text.storeNum += 1;
        caseService.collect($rootScope.user.id,$stateParams.caseId)
          .then(function(result){
            if(angular.isDefined(result) && angular.isDefined(result.state) && result.state == 401){
              //console.log("没有权限，请登录")
              $scope.modal.show() ;
            }else {
              $scope.updateSocial($rootScope.updateSocial.operStore,$rootScope.updateSocial.operationAdd) ;
            }
          },function(error){
            $scope.socialInfo.icon.stored = false;
            $scope.socialInfo.text.storeNum -= 1;
          })
      }else{
        return ;
        //caseService.cancleCollect($rootScope.user.id,$stateParams.caseId)
        //  .then(function(result){
        //    if(angular.isDefined(result) && angular.isDefined(result.state) && result.state == 401){
        //      console.log("没有权限，请登录")
        //      $scope.modal.show() ;
        //    }else {
        //      $scope.socialInfo.icon.stored = false;
        //      $scope.socialInfo.text.storeNum -= 1;
        //      $scope.updateSocial($rootScope.updateSocial.operStore,$rootScope.updateSocial.operationReduce) ;
        //    }
        //  })
      }
    }
    /********* 社交功能结束 *********/

    /** view 相关功能开始， 需要使用view的模块都需要提供以下功能**/
    $scope.view = {};
    $scope.view.oper = {
      maxId: '',
      caseId: $stateParams.caseId,
      caseType: 'jd'
    };
    $scope.view.showView = false;
    $scope.view.init = function(list){
      $scope.view.imgList = list;
      $scope.view.imgCount = list.length;
      $scope.view.showID = 1;
      $scope.view.showView = false;
    }

    $scope.view.openView = function(index) {
      $scope.view.showView = true;
      $scope.view.showID = 1 + index;
      angular.element('.nav-bar-container').hide();

      $scope.view.oper.maxId = getUUID();
      viewService.addViewerOperLog($scope.view.oper.caseType, $scope.view.oper.caseId,"大图按钮", "点击大图", $scope.view.oper.maxId)
    }
    /** view 相关功能结束**/

    window.addEventListener("native.keyboardshow", function(e){
      caseDetailviewScroll.scrollBottom();
    });
  });
