/**
 * Created by douhao on 2016/4/6.
 */
angular.module('community-controller',[])
  .controller('CommunityCtrl',function($scope,communityService,$rootScope,deviceService,$timeout,$ionicScrollDelegate,$state,$stateParams,showAlertService){
    showAlertService.loadingShow();
    $scope.type = communityService.getViewType();
    $scope.isActive = localStorage.getItem("communityEquipmentType")==null?0:localStorage.getItem("communityEquipmentType") ;
    $scope.equipemntParams = "" ;
    $scope.isShowSelection = {
      type:false,
      sort:false,
      show:false
    }
    $scope.equipmentNames = [] ;
    $scope.bodyPartsNames = [] ;
    $scope.bodyPartIsActive = [] ;
    $scope.equipmenIsActive = [] ;
    $scope.isSelBody = true ;
    $scope.isSelEquipment = true ;
    $scope.selectEquipNames = (localStorage.getItem("communityEquipmentName") == null) ? "":localStorage.getItem("communityEquipmentName") ;
    $scope.selectBodyNames = (localStorage.getItem("communityBodyName") == null) ? "":localStorage.getItem("communityBodyName") ;
    $scope.order = (localStorage.getItem("communityOrder") == null) ? 0 : localStorage.getItem("communityOrder");

    $scope.caseTypeOne = "文本列表";
    $scope.caseTypeTwo = "多图列表";

    $scope.discussInitFlag = ($scope.type == 1 ||  $scope.type == '') ;
    $scope.learnInitFlag = ($scope.type == 2) ;
    $scope.classicInitFlag = ($scope.type == 3) ;

    $scope.showDiscuss = ($scope.type == 1 ||  $scope.type == '') ;
    $scope.showClassic = ($scope.type == 3);
    $scope.showLearn = ($scope.type == 2) ;

    $rootScope.$on('switchType', function(e,item) {
      if (item == 1 ||  item == ''){
        $scope.discussInitFlag = true ;
      }else if(item == 2){
        $scope.learnInitFlag = true ;
      }else if(item == 3){
        $scope.classicInitFlag = true ;
      }
      $scope.showDiscuss = (item == 1 ||  item == '') ;
      $scope.showLearn = (item == 2) ;
      $scope.showClassic = (item == 3);
    });

    $scope.switchDataType = function(flag){
      if(flag == 1){
        $scope.discussInitFlag = true ;
        $scope.showClassic = false ;
        $scope.showDiscuss = true ;
        $scope.showLearn = false ;
      }else if(flag == 2){
        $scope.learnInitFlag = true ;
        $scope.showClassic = false ;
        $scope.showDiscuss = false ;
        $scope.showLearn = true ;
      }else if(flag == 3){
        $scope.classicInitFlag = true ;
        $scope.showClassic = true ;
        $scope.showDiscuss = false ;
        $scope.showLearn = false ;
      }
    }
    $scope.params = {
      hasmore : false ,
      current : 1 ,
      pageSize : 10,
    }
    $scope.img_url = img.url ;
    $scope.communitys = [];
    $scope.module = "community" ;

    //更改图片路径
    $scope.changeImgUrl = function(list){
      var img_path = "/jpeg" ;
      for(var i in list){
        var imgUrl = list[i].thumbnail ;
        if(!imgUrl || imgUrl==""){
          list[i].thumbnail = "img/study/no_learn.png";
        }else{
          if(imgUrl.substr(0,7)!="http://" && imgUrl.substr(0,8)!="https://"){
            list[i].thumbnail = $scope.img_url +"/" +list[i].id +"/"+imgUrl ;
          }
        }
      }
      return list;
    }

    //更新社交数据
    $rootScope.$on('socialOper', function(e,id,module,operType,operation) {
      if(module == $scope.module){
        for(var i in $scope.communitys){
          if($scope.communitys[i].id == id){
            if(operType == "isSpecialtyComment"){
              $scope.communitys[i].isSpecialtyComment = 1 ;
              return ;
            }
            if(operation){
              $scope.communitys[i][operType] ++;
            }else{
              $scope.cases[i][operType] --;
            }
          }
        }
      }
    });

    $rootScope.$on('deleteCase', function(e,item) {
      for(var i in $scope.communitys){
        if($scope.communitys[i].id == item.id){
          $scope.communitys.splice(i, 1) ;
        }
      }
    });

    $scope.doRefresh = function() {
      $scope.$broadcast("scroll.infiniteScrollComplete");
      $scope.hiden = true ;
      $scope.communitys = [];
      communityService.findAll($scope.isActive,1,$scope.params.pageSize,$scope.equipemntParams,$scope.selectBodyNames,$scope.order)
        .then(function(result) {
          $scope.hiden = false ;
          $scope.params = {
            hasmore : true ,
            current : 1 ,
            pageSize : 10,
          }
          if(result.code == 0 && result.result){
            $scope.communitys = $scope.changeImgUrl(result.result.objects);
            if($scope.params.pageSize > result.result.objects.length){
              $scope.params.hasmore = false ;
            }else{
              $scope.params.current ++ ;
            }
          }
          $scope.$broadcast('scroll.refreshComplete');
        })
        .finally(function () {
          showAlertService.loadingHide();
          $scope.$broadcast('scroll.refreshComplete');
        });
    };

    $rootScope.$on('DiscussCaseRefresh', function(e) {
      $scope.showClassic = false ;
      $scope.showDiscuss = true ;
      $scope.showLearn = false ;
      $scope.doRefresh();
    });

    $scope.doRefresh() ;
    $scope.loadMore = function(){
      communityService.findAll($scope.isActive,$scope.params.current,$scope.params.pageSize,$scope.equipemntParams,$scope.selectBodyNames,$scope.order)
        .then(function(result) {
          if(result.code == 0 && result.result){
            $scope.communitys = $scope.communitys.concat( $scope.changeImgUrl(result.result.objects));

            if($scope.params.pageSize > result.result.objects.length){
              $scope.params.hasmore = false ;
            }else {
              $scope.params.current++;
            }
          }
        })
        .finally(function () {
          showAlertService.loadingHide();
          $scope.$broadcast("scroll.infiniteScrollComplete");
        });
    };
    $scope.showTypeModal = function(){
      $scope.isShowSelection.type =  !$scope.isShowSelection.type ;
      $scope.isShowSelection.sort =  false ;
      $scope.isShowSelection.show =  false ;
    }
    $scope.showSortModal = function(){
      $scope.isShowSelection.sort =  !$scope.isShowSelection.sort ;
      $scope.isShowSelection.show =  false;
      $scope.isShowSelection.type =  false ;
    }
    $scope.showShowModal = function(){
      $scope.isShowSelection.show =  !$scope.isShowSelection.show ;
      $scope.isShowSelection.type =  false ;
      $scope.isShowSelection.sort =  false ;
    }

    $scope.resetSelectedBodyPart = function(){
      $scope.isSelBody = true ;
      $scope.isSelEquipment = true;
      for(var i in $scope.bodyPartIsActive){
        $scope.bodyPartIsActive[i] = false ;
      }
      for(var i in $scope.equipmenIsActive){
        $scope.equipmenIsActive[i] = false ;
      }
      $scope.selectBodyNames = "" ;
      $scope.selectEquipNames = "";
      $scope.equipemntParams = "" ;
      for(var i in $scope.equipmentNames) {
        if (parseInt($scope.equipmentNames[i].dpTag) == $scope.isActive) {
          $scope.equipemntParams += $scope.equipmentNames[i].code + ",";
        }
      }
      $scope.equipemntParams = $scope.equipemntParams.substring(0,$scope.equipemntParams.length-1) ;
    }

    $scope.comfirmSelectedBodyPart = function(){
      $scope.isShowSelection.type = false ;
      localStorage.setItem("communityEquipmentName", $scope.selectEquipNames);
      localStorage.setItem("communityBodyName", $scope.selectBodyNames);
      $scope.doRefresh();
    }

    $scope.toSlideTitle = function(index){
      $scope.isActive = index == 0 ?0:1;
      $scope.equipemntParams = "" ;
      for(var i in $scope.equipmentNames) {
        if (parseInt($scope.equipmentNames[i].dpTag) == $scope.isActive) {
          if($scope.equipmenIsActive[i] == true){
            $scope.equipemntParams += $scope.equipmentNames[i].code + ",";
          }
        }
      }
      //如果没有选中的设备，将设备选为不限，equipemntParams 为所选的所有的设备。
      if($scope.equipemntParams == "") {
        for (var i in $scope.equipmentNames) {
          if (parseInt($scope.equipmentNames[i].dpTag) == $scope.isActive) {
            $scope.equipemntParams += $scope.equipmentNames[i].code + ",";
          }
        }
        $scope.isSelEquipment = true ;
      }else{
        $scope.isSelEquipment = false ;
      }
      $scope.equipemntParams = $scope.equipemntParams.substring(0,$scope.equipemntParams.length-1) ;
      localStorage.setItem("communityEquipmentName", $scope.isActive);
      $scope.comfirmSelectedBodyPart() ;
    }

    //分类查询部位按钮
    $scope.isSelectedBodyPart = function(index){
      if(index == -1){
        $scope.isSelBody = $scope.isSelBody?false:true ;
        //如果选择了 "不限" 将其他都置为false;
        if($scope.isSelBody){
          for(var i in $scope.bodyPartIsActive){
            $scope.bodyPartIsActive[i] = false ;
          }
        }
        $scope.selectBodyNames = "" ;
      }else{
        $scope.bodyPartIsActive[index] = $scope.bodyPartIsActive[index]?false:true ;
        //如果有一个被选择，将"不限"置为false ;
        $scope.selectBodyNames = "" ;
        for(var i in $scope.bodyPartIsActive){
          if($scope.bodyPartIsActive[i] == true){
            $scope.selectBodyNames += $scope.bodyPartsNames[i].code + ",";
          }
        }
        $scope.selectBodyNames = $scope.selectBodyNames.substring(0,$scope.selectBodyNames.length-1) ;
      }

      if($scope.selectBodyNames == ""){
        $scope.isSelBody = true ;
      }else{
        $scope.isSelBody = false ;
      }
      localStorage.setItem("communityBodyName", $scope.selectBodyNames);
    }

    //分类查询设备按钮
    $scope.isSelectedEquipmen = function(index){
      if(index == -1){
        $scope.isSelEquipment = $scope.isSelEquipment?false:true ;
        $scope.equipemntParams = "" ;
        $scope.selectEquipNames = "" ;
        //如果选择了 "不限" 将其他都置为false;
        if($scope.isSelEquipment){
          for(var i in $scope.equipmenIsActive){
            if(parseInt($scope.equipmentNames[i].dpTag) == $scope.isActive){
              $scope.equipmenIsActive[i] = false ;
            }else if($scope.equipmenIsActive[i] == true){
              $scope.selectEquipNames +=$scope.equipmentNames[i].code + ",";
            }
          }
          $scope.selectEquipNames = $scope.selectEquipNames.substring(0,$scope.selectEquipNames.length-1) ;
        }
      }else{
        $scope.equipmenIsActive[index] = $scope.equipmenIsActive[index]?false:true ;
        //如果有一个被选择，将"不限"置为false ;
        $scope.selectEquipNames = "" ;
        $scope.equipemntParams = "" ;
        for(var i in $scope.equipmenIsActive){
          if($scope.equipmenIsActive[i] == true){
            $scope.selectEquipNames += $scope.equipmentNames[i].code + ",";
            if (parseInt($scope.equipmentNames[i].dpTag) == $scope.isActive) {
              $scope.equipemntParams += $scope.equipmentNames[i].code + ",";
            }
          }
        }
        $scope.selectEquipNames = $scope.selectEquipNames.substring(0,$scope.selectEquipNames.length-1) ;
        $scope.equipemntParams = $scope.equipemntParams.substring(0,$scope.equipemntParams.length-1) ;
      }

      if($scope.equipemntParams == ""){
        $scope.isSelEquipment = true ;
        for(var i in $scope.equipmentNames) {
          if (parseInt($scope.equipmentNames[i].dpTag) == $scope.isActive) {
            $scope.equipemntParams += $scope.equipmentNames[i].code + ",";
          }
        }
        $scope.equipemntParams = $scope.equipemntParams.substring(0,$scope.equipemntParams.length-1) ;
      }else{
        $scope.isSelEquipment = false ;
      }

      localStorage.setItem("cookieEquipmentName", $scope.selectEquipNames);
    }

    //初始化筛选选项条件
    deviceService.findDeviceType()
      .then(function(result){
        $scope.bodyPartsNames = result.result.bodysystems ;

        for(var i in $scope.bodyPartsNames){
          if($scope.selectBodyNames.indexOf($scope.bodyPartsNames[i].code) != -1){
            $scope.bodyPartIsActive.push(true) ;
            $scope.isSelBody = false ;
          }else{
            $scope.bodyPartIsActive.push(false) ;
          }
        }

        $scope.equipmentNames = result.result.equipments ;
        for(var i in $scope.equipmentNames) {
          if ($scope.equipmentNames[i].dpTag == $scope.isActive) {
            $scope.equipemntParams += $scope.equipmentNames[i].code + ",";
          }
        }
        $scope.equipemntParams = $scope.equipemntParams.substring(0,$scope.equipemntParams.length-1) ;
        //$scope.params.hasmore = true ;
        for(var i in $scope.equipmentNames){
          if($scope.selectEquipNames.indexOf($scope.equipmentNames[i].code) != -1){
            $scope.equipmenIsActive.push(true) ;
            $scope.isSelEquipment = false ;
          }else{
            $scope.equipmenIsActive.push(false) ;
          }
        }
        $scope.toSlideTitle($scope.isActive) ;
        //$scope.equipemntParams = $scope.selectEquipNames==""?$scope.equipemntParams:$scope.selectEquipNames ;
      })

    $scope.tilesFlag = (localStorage.getItem("tilesCommunityFlag") == null) ? 0 : localStorage.getItem("tilesCommunityFlag");

    $scope.changeTilesFlag = function(tilesFlag){
      //$scope.showmodal.hide();
      $scope.isShowSelection.show = false ;
      if ($scope.tilesFlag == tilesFlag){
        return;
      }

      $timeout(function(){
        $scope.tilesFlag = tilesFlag;
        localStorage.setItem("tilesCommunityFlag", tilesFlag);
        $scope.cases = [];
        $ionicScrollDelegate.scrollTop();
        $scope.doRefresh();
      }, 100)
    }

    $scope.changeSort = function(sort){
      if ($scope.order != sort){
        $timeout(function(){
          $scope.order = sort;
          localStorage.setItem("order", sort);
          $scope.doRefresh();
          $scope.isShowSelection.sort = false ;
        }, 100)
      }
    }

    $scope.gotoDetail = function(id){
      $state.go("menu.community-detail",{'communityId':id}) ;
    }

    //$scope.repeatFinsh = function(){
    //  var count = (screen.width-10)/105 ;
    //  $timeout(function(){
    //    var mySwiper = new Swiper('.discussCaseImageListDiv', {
    //      slidesPerView : count,
    //      spaceBetween : 5,
    //      slidesOffsetAfter : 10,
    //      observer:true,
    //      observeParents:true,
    //    })
    //  },200);
    //}

    $scope.$on("$ionicView.enter", function(){
      $rootScope.currentConversationInit();
    })
});
