/**
 * Created by douhao on 2016/4/6.
 */
angular.module('communityDetail-controller',[])
  .controller('CommunityDetailCtrl',function($scope,$rootScope,$stateParams,$state,$ionicScrollDelegate,communityService,$timeout,$ionicActionSheet,$location,$ionicModal,commentService,viewService,$cordovaToast,HomeService,showAlertService,UserService){
    var viewScroll = $ionicScrollDelegate.$getByHandle('messageDetailsScroll');
    $scope.params = {
      hasmore : true ,
      from : 10 ,
      pageSize:10,
    }
    $scope.module = "community" ;
    $ionicModal.fromTemplateUrl('templates/diagnose/authority-warn.html', {
      scope: $scope,
      animation: 'slide-in-down'
    }).then(function(modal) {
      $scope.modal = modal;
    });

    $scope.share_header = "https://open.weixin.qq.com/connect/oauth2/authorize?appid=wx6939749493987808&redirect_uri=" ;
    $scope.share_footer = "&response_type=code&scope=snsapi_userinfo#wechat_redirect" ;
    $scope.img_url = img.url ;
    $scope.community = null;
    $scope.comments = [] ;

    //获取详情信息及评论
    $scope.getCommunityDetail = function() {
      communityService.findById($stateParams.communityId)
        .then(function (result) {
          commentService.findComments($stateParams.communityId, 2, 1, 10)
            .then(function (res) {
              $scope.community = $scope.changeImgUrl(result.result);

              if (!$scope.community.personalImage){
                $scope.community.personalImage = img.personalImage;
              }

              $scope.comments = res;
              if (res.length < $scope.params.pageSize) {
                $scope.params.hasmore = false;
              }
              //增加阅读量
              $scope.readNum();
              communityService.isCollect($rootScope.user.id, $stateParams.communityId)
                .then(function (data) {
                  communityService.isAgree($stateParams.communityId,$rootScope.user.id)
                    .then(function(agreeData){
                      $scope.socialInfo.init($scope.community.agreeNum, $scope.community.storeNum, $scope.community.readNum, $scope.community.commentNum, agreeData.result, data.result);
                    })
                })

              // 初始化view模块
              $scope.view.init(result.result.caseInfoImageList);
            })
        })
    }

    //分享
    $scope.isShare = false ;
    $scope.share = function(type){
      $scope.isShare = false ;
        for(var i in $rootScope.share_urls){
          if($rootScope.share_urls[i].confKey == "share_community"){
            //$scope.shareUrl = $scope.share_header+encodeURIComponent($rootScope.share_urls[i].confValue + "?id="+$stateParams.communityId)+$scope.share_footer ;
            //$scope.shareUrl =$rootScope.share_urls[i].confValue + "?id="+$stateParams.communityId ;
            $scope.shareUrl = $rootScope.share_urls[i].confValue.replace("{id}",$stateParams.communityId) ;
          }
        }
        //alert($scope.shareUrl) ;
        //分享参数
        switch(type){
          case 0:
            $scope.scene = Wechat.Scene.SESSION;
            break ;
          case 1:
            $scope.scene = Wechat.Scene.TIMELINE;
            break ;
        }
        Wechat.isInstalled(function (installed) {
          if(installed == "No"){
            $scope.isShare = false ;
            showAlertService.PopAlert("提示信息","请先安装微信再分享","确认","") ;
            return ;
          }else{
            Wechat.share({
              message:{
                title: $scope.community.title,
                description: $scope.community.content==null?"":$scope.community.content,
                thumb: $scope.community.caseInfoImageList[0].imageUrl,
                mediaTagName: "yinglink-TAG-001",
                messageExt: "",
                messageAction: "<action>dotalist</action>",
                media: {
                  type:Wechat.Type.LINK ,
                  webpageUrl:$scope.share_header+encodeURIComponent($scope.shareUrl)+$scope.share_footer
                  //webpageUrl: $scope.shareUrl
                }
              },
              scene: $scope.scene
            }, function () {
              //$cordovaToast.showShortBottom('分享成功') ;
              //showAlertService.PopShow("提示信息","分享成功",1000) ;
              HomeService.addShareRecord($rootScope.user.id,$stateParams.communityId,2,$scope.shareUrl)
                .then(function(result){
                }) ;
            }, function (reason) {
              //$cordovaToast.showShortBottom('分享失败') ;
              //showAlertService.PopShow("提示信息","分享失败",1000) ;
            });
          }
        });

    }
    //显示分享
    $scope.showShare = function() {
      if($rootScope.share_urls == null || $rootScope.share_urls == undefined){
        $rootScope.$broadcast('message',"正在获取分享信息，请稍后再试！",3000,"notice");
        UserService.getConfByType('share')
          .then(function(result){
            if(result.success){
              $rootScope.share_urls= result.result ;
            }
          })
        return ;
      }
      $scope.isShare = true ;
    };
    //取消分享
    $scope.cancelShare = function(){
      $scope.isShare = false ;
    }

    //页面加载完成在请求数据
    $scope.$on('$ionicView.afterEnter', function() {

      $scope.getCommunityDetail() ;

    }, false);
    $scope.$on("executeDroidRecall", function(e,caseId){
      //console.log("reduce") ;
    })

    //操作列表页的社交数据
    $scope.updateSocial = function(operType,operation){
      $scope.$emit("social", $stateParams.communityId,$scope.module,operType,operation);
    }

    ////更改图片路径
    $scope.changeImgUrl = function(list){
      var img_path = "" ;
      var user_img = list.thumbnail ;
      if(!user_img){
        list.thumbnail = "img/study/no_learn.png";
      }else{
        if(user_img.substr(0,7)!="http://" && user_img.substr(0,8)!="https://"){
          list.thumbnail = $scope.img_url +"/" +list.id +img_path +"/"+user_img ;
        }else{
          list.thumbnail = user_img
        }
      }
      for(var i in list.caseInfoImageList){
        var imgUrl = list.caseInfoImageList[i].thumbnail ;
        if(!imgUrl){
          list.caseInfoImageList[i].imageUrl = "img/study/no_learn.png";
        }else{
          if(imgUrl.substr(0,7)!="http://" && imgUrl.substr(0,8)!="https://"){
            list.caseInfoImageList[i].imageUrl = $scope.img_url +"/" +list.caseInfoImageList[i].caseInfoId +img_path +"/"+imgUrl ;
          }else{
            list.caseInfoImageList[i].imageUrl = imgUrl ;
          }
        }
      }
      return list;
    }

    //增加阅读量
    $scope.readNum = function(){
      communityService.readNum($rootScope.user.id,$stateParams.communityId)
        .then(function (result) {
          //console.log("result="+result) ;
          if(result.code == 0){
            $scope.community.readNum += 1 ;
            $scope.updateSocial($rootScope.updateSocial.operRead,$rootScope.updateSocial.operationAdd) ;
          }
        })
    }

    //下一例
    $scope.next = function(communityId){
      //console.log("next" + communityId) ;
      communityService.next(communityId)
        .then(function(result) {
          //console.log(result)
          //判断返回id是否存在，存在时跳转，不存在将flag置为false
          if(result != ""){
            $state.go("menu.tab.community-detail",{'communityId': result}) ;
            //$location.path("#/menu/tab/communitys/"+result) ;
          }else{
            $scope.nextDisabled= true ;
          }
        })
    }

    //上一例
    $scope.previous = function(communityId){
      //console.log("previous" + communityId) ;
      communityService.previous(communityId)
        .then(function(result) {
          //判断返回id是否存在，存在时跳转，不存在将flag置为false
          if(result != ""){
            $state.go("menu.tab.community-detail",{'communityId': result}) ;
          }else{
            $scope.previousDisabled = true ;
          }
        })
    }

    //点赞
    $scope.operFlag = "add" ;
    $scope.agree = function(communityId){
      communityService.agreeOrDisAgree($rootScope.user.id,communityId,0,$scope.operFlag)
        .then(function(result) {
          //console.log($scope.community.agreeNum)
          if($scope.operFlag == "add"){
            $scope.operFlag = "reduce";
            $scope.community.agreeNum += 1 ;
          }else if($scope.operFlag == "reduce"){
            $scope.operFlag = "add";
            $scope.community.agreeNum -= 1 ;
          }
        })
    }

    //鄙视
    $scope.disOperFlag = "add" ;
    $scope.disAgree = function(communityId){
        communityService.agreeOrDisAgree($rootScope.user.id,communityId,1,$scope.disOperFlag)
          .then(function(result) {
            //console.log($scope.community.agreeNum)
            if($scope.disOperFlag == "add"){
              $scope.disOperFlag = "reduce";
              $scope.community.disAgreeNum += 1 ;
            }else if($scope.disOperFlag == "reduce"){
              $scope.disOperFlag = "add";
              $scope.community.disAgreeNum -= 1 ;
            }
          })
    }

    //收藏
    $scope.isCollectFlag = false ;
    $scope.collect = function(communityId){
      userId = 0 ;
      communityService.collect(userId,communityId)
        .then(function(result) {
          if($scope.isCollectFlag){
            $scope.isCollectFlag = false;
          }else{
            $scope.isCollectFlag = true;
          }
        })
    }

    $scope.adjustSlideHeight = function(index){
      adjustSlideHeight(angular.element("#caseSlide .img")[index], false);
    }

    /********* 评论功能开始 *********/
    $scope.comment = {
      comments: [],
      send_content: '',
      reply_head: '',
      expandId: -1,
      carrierId: $stateParams.communityId,
      carrierType: 2,
      complainType: 2,
      isSubmited: true
    };
    $scope.comment.params = {
      hasmore : false,
      from : 1,
      pageSize:3
    };

    $scope.comment.replyModel = {};

    $scope.comment.keyDown = function(e){
      var keyCode = window.event?e.keyCode:e.which;
      // 删除
      if (keyCode == 8){
        //console.log($scope.comment.send_content)
        //console.log($scope.comment.reply_head)
        if ($scope.comment.send_content + ' ' == $scope.comment.reply_head || $scope.comment.send_content == $scope.comment.reply_head){
          $scope.comment.replyModel = {};
          $scope.comment.send_content = '';
          $scope.comment.reply_head = '';
        }
      }
    }

    $scope.comment.submitComment = function(){
      if (!$scope.comment.send_content && !$scope.comment.send_content.trim()){
        return;
      }

      var comment = $scope.comment.send_content.replace($scope.comment.reply_head, '');
      if (!comment && !comment.trim()){
        return;
      }
      $scope.comment.isSubmited = false ;
      $scope.comment.replyModel.carrierId = $scope.comment.carrierId;
      $scope.comment.replyModel.carrierType = $scope.comment.carrierType;
      $scope.comment.replyModel.userId = $rootScope.user.id;
      $scope.comment.replyModel.comment = comment.replace(/\n/g, '<br/>');
      commentService.submitComment($scope.comment.replyModel)
        .then(function(result){
          if (!$scope.comment.replyModel.parentId){
            $scope.comment.flushComment() ;
            $scope.comment.replyModel = {};
          }else{
            commentService.getSubComment($scope.comment.carrierType, $scope.comment.replyModel.parentId)
              .then(function(result){
                for(var i in $scope.comment.comments){
                  if ($scope.comment.comments[i].id == $scope.comment.replyModel.parentId){
                    $scope.comment.comments[i].subComments=$scope.comment.changeImgUrl(result.result);
                    $scope.comment.replyModel = {};
                  }
                }
              })
          }
          if(result.code == 0){
            if($rootScope.user.isSpecialty == 1){
              $scope.$emit("social", $stateParams.communityId,$scope.module,"isSpecialtyComment",true);
            }
          }
          $scope.comment.send_content = '';
          $scope.comment.reply_head = '';
        })
        .finally(function(){
          $scope.comment.isSubmited = true ;
        })
    }
    /********* 评论功能结束 *********/
    /********* 社交功能开始 *********/
    $scope.textAreaMoveEnd = function(){
      //console.log("点击事件触发");
      commentService.moveEnd(document.getElementById('task-detail-comment-area'));
    }
    $scope.socialInfo = {};
    // 控制社交功能区展示
    $scope.socialInfo.show = {};
    // 控制社交数值展示
    $scope.socialInfo.text = {};
    // 控制社交图标展示
    $scope.socialInfo.icon = {};

    $scope.socialInfo.show.likeFlag = true;
    $scope.socialInfo.show.storeFlag = true;
    $scope.socialInfo.show.readFlag = true;
    $scope.socialInfo.show.commentFlag = false;

    $scope.socialInfo.init = function(likeNum, storeNum, readNum, commentNum, liked, stored){
      $scope.socialInfo.text.likeNum = likeNum;
      $scope.socialInfo.text.storeNum = storeNum;
      $scope.socialInfo.text.readNum = readNum;
      $scope.socialInfo.text.commentNum = commentNum;
      $scope.socialInfo.icon.liked = liked;
      $scope.socialInfo.icon.stored = stored;
    }

    $scope.socialInfo.like = function(flag){
      if($rootScope.user.id <= 0){
        //console.log("没有权限，请登录")
        $rootScope.$broadcast('login:show');
        return ;
      }
      if (flag){
        $scope.socialInfo.icon.liked = true;
        $scope.socialInfo.text.likeNum += 1;
        communityService.agree($rootScope.user.id,$stateParams.communityId,0,"add")
          .then(function (result) {
            if(result.code == 0){
              $scope.updateSocial($rootScope.updateSocial.operAgree,$rootScope.updateSocial.operationAdd) ;
            }else{
              $scope.socialInfo.icon.liked = false;
              $scope.socialInfo.text.likeNum -= 1;
            }
          },function (error){
            //console.log("error") ;
            $scope.socialInfo.icon.liked = false;
            $scope.socialInfo.text.likeNum -= 1;
          })
      }else{
        return ;
      //  console.log('I do not this video.');
      //  communityService.agree(0,$stateParams.communityId,0,"reduce")
      //    .then(function(result) {
      //      //if(result.state && result.state == 401){
      //      //  console.log("没有权限，请登录")
      //      //  $scope.modal.show() ;
      //      //}else {
      //        $scope.socialInfo.icon.liked = false;
      //        $scope.socialInfo.text.likeNum -= 1;
      //        $scope.updateSocial($rootScope.updateSocial.operAgree,$rootScope.updateSocial.operationReduce) ;
      //      //}
      //    })
      }
      // TODO

    }

    $scope.socialInfo.store = function(flag){

      if (flag){
        $scope.socialInfo.icon.stored = true;
        $scope.socialInfo.text.storeNum += 1;
        communityService.collect($rootScope.user.id,$stateParams.communityId)
          .then(function(result){
            //if(angular.isDefined(result) && angular.isDefined(result.state) && result.state == 401){
            //  console.log("没有权限，请登录")
            //  $scope.modal.show() ;
            //}else {

              $scope.updateSocial($rootScope.updateSocial.operStore,$rootScope.updateSocial.operationAdd) ;
            //}
          },function(error){
            $scope.socialInfo.icon.stored = false;
            $scope.socialInfo.text.storeNum -= 1;
          })
      }else{
        return ;
      //  communityService.cancleCollect($rootScope.user.id,$stateParams.communityId)
      //    .then(function(result){
      //      //if(angular.isDefined(result) && angular.isDefined(result.state) && result.state == 401){
      //      //  console.log("没有权限，请登录")
      //      //  $scope.modal.show() ;
      //      //}else {
      //        $scope.socialInfo.icon.stored = false;
      //        $scope.socialInfo.text.storeNum -= 1;
      //        $scope.updateSocial($rootScope.updateSocial.operStore,$rootScope.updateSocial.operationReduce) ;
      //      //}
      //    })
      }
    }
    /********* 社交功能结束 *********/


    /** view 相关功能开始， 需要使用view的模块都需要提供以下功能**/
    $scope.view = {};
    $scope.view.oper = {
      maxId: '',
      caseId: $stateParams.communityId,
      caseType: 'lt'
    };
    $scope.view.showView = false;
    $scope.view.init = function(list){
      $scope.view.imgList = list;
      $scope.view.imgCount = list.length;
      $scope.view.showID = 1;
      $scope.view.showView = false;
    }

    $scope.view.openView = function(index) {
      $scope.view.showView = true;
      $scope.view.showID = 1 + index;
      angular.element('.nav-bar-container').hide();

      $scope.view.oper.maxId = getUUID();
      viewService.addViewerOperLog($scope.view.oper.caseType, $scope.view.oper.caseId,"大图按钮", "点击大图", $scope.view.oper.maxId)
    }
    /** view 相关功能结束**/
});
