angular.module('addFriends-controller',[])
  .controller('addFriendsCtrl',function($scope,$rootScope,$state,UserService,groupService, $stateParams,$ionicLoading, $timeout, $ionicPopup, rongcloudService){

    $scope.user = {
      list : []
    };

    $scope.group = {
      list: []
    };

    $scope.searchType = $stateParams.type;

    $scope.search = {};

    $scope.noUserFlag = false;

    $scope.change = function(value){
      $scope.searchType = value ;
    }

    $scope.search.loadUserAndGroup = function(){
      if (!$scope.search.searchText){
        $rootScope.$broadcast('message',"请输入查询条件", 3000, "notice");
        return;
      }
      $ionicLoading.show();
      $scope.user.list = [];
      $scope.group.list = [];

      if ($scope.search.searchText.trim() == "*"){
        $scope.search.searchText = "";
      }

      if ($scope.searchType == 'user'){
        UserService.fuzzySelectUsers($scope.search.searchText == "*" ? "" : $scope.search.searchText)
          .then(function(result){
            $ionicLoading.hide();
            if (!!result.result){
              for(var i in result.result){
                if (!result.result[i].personalImage){
                  result.result[i].personalImage = img.personalImage;
                }

                if (result.result[i].id != $rootScope.user.id){
                  $scope.user.list.push(result.result[i]);
                }
              }
            }

            if ($scope.user.list.length == 0){
              $scope.noUserFlag = true;
            }else{
              $scope.noUserFlag = false;
            }
          },function(error){
            $ionicLoading.hide();
          }
        );
      }else{
        groupService.getGroups($rootScope.user.id, $scope.search.searchText)
          .then(function(result){
            $ionicLoading.hide();
            if (!!result.result){
              for(var i in result.result){
                if (!result.result[i].picture){
                  result.result[i].picture = img.personalImage;
                }
              }
              $scope.group.list = result.result;
            }

            if ($scope.group.list.length == 0){
              $scope.noUserFlag = true;
            }else{
              $scope.noUserFlag = false;
            }
          },function(error){
            $ionicLoading.hide();
          });
      }
    }

    $scope.joinGroupFlag = false;
    $scope.joinGroup = function(group){
      if ($scope.joinGroupFlag){
        return;
      }
      $scope.joinGroupFlag = true;
      var groupId = group.id;
      groupService.joinGroup($rootScope.user.id, groupId)
        .then(function(result){
          $scope.joinGroupFlag = false;
          group.isJoined = 1;
          rongcloudService.joinGroup(group);

          RongCloudLibPlugin.sendCommandNotificationMessage({
              conversationType: 'GROUP',
              targetId: groupId,
              name: 'JoinGroup',
              data: '<a class="JoinGroupUser-'+ $rootScope.user.id +'">"'+ $rootScope.user.nickName + '"</a> 加入了本群'
            },
            function(ret, err) {
              if (ret) {
                if (ret.status == "prepare") {
                  $rootScope.appendNewMsg(ret.result.message);
                }
              }
            }
          );

          var myPopup = $ionicPopup.show({
            title: '加入群组成功。'
          });
          $timeout(function() {
            myPopup.close();
          }, 3000);
        })
    }

    $scope.goGroupDetail = function(groupId){
      $state.go("menu.groupDetail",{'groupId': groupId}) ;
    }
});

