angular.module('addMembers-controller',[])
  .controller('addMemberCtrl',function($scope,$rootScope,$state,$stateParams,friendService,groupService, UserService,$ionicPopup,innermailService,$timeout, $interval,$ionicHistory,showAlertService, $ionicLoading, rongcloudService){

    $scope.friend = {
      friendList : [],
      searchText : '',
      addUserNum : 0,
      addUserList : []
    };

    $scope.noUserFlag = false;

    $scope.friend.load = function(){
      friendService.getFriendsForGroup($rootScope.user.id, $stateParams.groupId, $scope.friend.searchText)
        .then(function(result){
          if (result.code == 0){
            $scope.friend.friendList = result.result;

            for (var i in $scope.friend.friendList){
              for (var j in $scope.friend.addUserList){
                if ($scope.friend.friendList[i].id == $scope.friend.addUserList[j]){
                  $scope.friend.friendList[i].addFlag = true;
                }
              }
            }
            $scope.friend.friendList = result.result;

            if ($scope.friend.friendList.length == 0){
              $scope.noUserFlag = true;
            }else{
              $scope.noUserFlag = false;
            }
          }
        });
    }

    $scope.friend.load();

    $scope.checkUser = function(user){
      if (user.inGroup){
        return;
      }

      if (!!user.addFlag){
        user.addFlag = false;
        $scope.friend.addUserNum--;
        var index = -1;
        for (var i in $scope.friend.addUserList){
          if ($scope.friend.addUserList[i] == user.id){
            index = i;
            break;
          }
        }
        if (index >= 0){
          $scope.friend.addUserList.splice(index,1);
        }

      }else{
        user.addFlag = true;
        $scope.friend.addUserNum++;
        $scope.friend.addUserList.push(user.id);
      }
    }

    $scope.addUser = function(){
      if ($scope.friend.addUserNum <= 0 || $scope.friend.addUserList.length == 0){
        return;
      }

      $ionicLoading.show();
      groupService.joinGroup($scope.friend.addUserList.join(','), $stateParams.groupId)
        .then(function(result){
          $ionicLoading.hide();

          var names = '';
          for (var i in $scope.friend.addUserList){
            for (var j in $scope.friend.friendList){
              if ($scope.friend.addUserList[i] == $scope.friend.friendList[j].id){
                names = names + '<a class="JoinGroupUser-'+ $scope.friend.friendList[j].id +'">"'+ $scope.friend.friendList[j].name + '"</a> '
              }
            }
          }

          RongCloudLibPlugin.sendCommandNotificationMessage({
              conversationType: 'GROUP',
              targetId: $stateParams.groupId,
              name: 'JoinGroup',
              data: names + '加入了本群'
            },
            function(ret, err) {
              if (ret) {
                if (ret.status == "prepare") {
                  $rootScope.appendNewMsg(ret.result.message);
                }
              }
            }
          );

          $state.go("menu.groupMembers",{'groupId':$stateParams.groupId}) ;
        });
    }
  });

