angular.module('friends-controller',[])
  .controller('friendsCtrl',function($scope,$rootScope,$state,friendService,groupService, UserService,$ionicPopup,innermailService,$timeout, $interval,$ionicHistory,showAlertService, $ionicLoading, rongcloudService,$cordovaKeyboard){
    $scope.params = {
      hasmore : false ,
      current : 1 ,
      pageSize : 10,
    }
    $scope.applyFriend = {};
    $scope.applyFriend.init = function(){
    }
    $scope.applyFriend.agreeFriend = function(index){
      friendService.addFriend($rootScope.user.id, $rootScope.newmessage.innerMailList[index].senderId, 1)
        .then(function(result){
          var myPopup = $ionicPopup.show({
            title: '您已成功接受添加好友申请。'
          });
          $timeout(function() {
            myPopup.close();
          }, 3000);

          $rootScope.newmessage.innerMailList[index].status = 1;
          $rootScope.newmessage.innerMailCount--;
          innermailService.readMail($rootScope.newmessage.innerMailList[index].id);
          $scope.friend.load();
          $rootScope.$apply();
        })
    }

    $scope.applyFriend.addFriend = function(friendId,$event){
      friendService.addFriend($rootScope.user.id, friendId, 0)
        .then(function(result){
          var myPopup = $ionicPopup.show({
            title: '添加好友申请已经发送。'
          });
          $timeout(function() {
            myPopup.close();
          }, 3000);
        })
      $event.preventDefault();
    }

    $scope.applyFriend.rejectFriend = function(index){
      showAlertService.PopConfirm("拒绝好友申请","您确定拒绝该好友申请吗?","取消","确定")
        .then(function(res) {
          if(res) {
            friendService.rejectFriend($rootScope.user.id, $rootScope.newmessage.innerMailList[index].senderId)
              .then(function(result){
                $rootScope.newmessage.innerMailList[index].status = 1;
                $rootScope.newmessage.innerMailCount--;
                innermailService.readMail($rootScope.newmessage.innerMailList[index].id);
                $rootScope.$apply();
              })
          }
        });
    }

    $scope.friend = {
      friendList : [],
      searchFriendList : [],
      groupList : [],
      searchGroupList : [],
      recommendGroupList : [],
      searchText: '',
      isSearch:false,
      searchType:'',
      isGetDataIng:true
    };

    $scope.friend.cancelSearch = function(){
      $scope.friend.searchText = '' ;
      $scope.friend.isSearch = false ;
      $scope.friend.isGetDataIng = false ;
    }

    $scope.friend.clearSearch = function(){
      $scope.friend.searchText = '' ;
    }

    $scope.searchFriend = function(){
      friendService.getFuzzFriends($rootScope.user.id, $scope.friend.searchText,$scope.params.current,$scope.params.pageSize)
        .then(function(result){
          if (result.code == 0){
            for(var i in result.result){
              if (!result.result[i].personalImage){
                result.result[i].personalImage = img.personalImage;
              }
            }
            $scope.friend.searchFriendList = result.result;
            $scope.friend.isGetDataIng = false ;
            $scope.params.current ++ ;
            $timeout(function(){
              $scope.params.hasmore = true ;
            },1000) ;
          }
          showAlertService.loadingHide();
        })
        .finally(function(){
          $("#friendInput").blur() ;
        })
    }

    $scope.searchGroup = function(){
      groupService.getGroups($rootScope.user.id, $scope.friend.searchText)
        .then(function(result){
          if (!!result.result){
            for(var i in result.result){
              if (!result.result[i].picture){
                result.result[i].picture = img.personalImage;
              }
            }
            $scope.friend.searchGroupList = result.result;
            $scope.friend.isGetDataIng = false ;
          }
          showAlertService.loadingHide();
        })
    }

    $scope.change = function(type){
      $scope.friend.searchType = type ;
    }

    $scope.friend.search = function(){
      $scope.friend.searchFriendList = [] ;
      $scope.friend.searchGroupList = [] ;
      $scope.friend.isGetDataIng = true ;
      //搜索条件不为空时，搜索所有用户信息
      if($scope.friend.searchText != ''){
        showAlertService.loadingShow();
        $scope.friend.isSearch = true ;
        $scope.params = {
          hasmore: false,
          current: 1,
          pageSize: 10,
        }
        switch($scope.friend.searchType){
          case '':
              $scope.searchFriend() ;
              $scope.searchGroup() ;
              break ;
          case 'user':
              $scope.searchFriend() ;
              break ;
          case 'group':
              $scope.searchGroup() ;
              break ;
        }

      }else{
        $scope.friend.isSearch = false ;
      }
    }

    $scope.friend.loadMore = function(){
      friendService.getFuzzFriends($rootScope.user.id, $scope.friend.searchText,$scope.params.current,$scope.params.pageSize)
        .then(function(result){
          if (result.code == 0){
            for(var i in result.result){
              if (!result.result[i].personalImage){
                result.result[i].personalImage = img.personalImage;
              }
            }
            $scope.friend.searchFriendList = $scope.friend.searchFriendList.concat(result.result);
            if($scope.params.pageSize > result.result.length){
              $scope.params.hasmore = false ;
            }else{
              $scope.params.current ++ ;
            }
          }else{
            $scope.params.hasmore = false ;
          }
          $scope.$broadcast("scroll.infiniteScrollComplete");
        },function(reason){
          $scope.$broadcast("scroll.infiniteScrollComplete");
        })
    }


    $scope.friend.load = function(){
      showAlertService.loadingShow();
      friendService.getFriends($rootScope.user.id, $scope.friend.searchText)
        .then(function(result){
          if (result.code == 0){
            for(var i in result.result){
              if (!result.result[i].personalImage){
                result.result[i].personalImage = img.personalImage;
              }
            }
            $scope.friend.friendList = result.result;
            $scope.friend.isGetDataIng = false ;
          }
          showAlertService.loadingHide();
        });
      groupService.getGroupsByUserid($rootScope.user.id, $scope.friend.searchText)
        .then(function(result){
          if (!!result.result){
            for(var i in result.result){
              if (!result.result[i].picture){
                result.result[i].picture = img.personalImage;
              }
            }
            $scope.friend.groupList = result.result;
            $scope.friend.isGetDataIng = false ;
          }
        });
    }

    $scope.friend.getRecommendGroups = function(){
      groupService.getRecommendGroups($rootScope.user.id, 2)
        .then(function(result){
          if (!!result.result){
            for(var i in result.result){
              if (!result.result[i].picture){
                result.result[i].picture = img.personalImage;
              }
            }
            $scope.friend.recommendGroupList = result.result;
            $scope.$apply();
          }
        });
    }

    $scope.init = function(){
      $scope.friend.load();
      $scope.friend.getRecommendGroups();
      $scope.applyFriend.init();

      $interval(function(){
        if (!!$scope.friend.searchText){
          return;
        }

        groupService.getGroupsByUserid($rootScope.user.id, "")
        .then(function(result){
          if (!!result.result){
            for(var i in result.result){
              if (!result.result[i].picture){
                result.result[i].picture = img.personalImage;
              }
            }
            $scope.friend.groupList = result.result;

            if ($rootScope.conversation.conversationList.length > 0 && $scope.friend.groupList.length > 0){
              for (var i in $scope.friend.groupList){
                for (var j in $rootScope.conversation.conversationList){
                  if ($rootScope.conversation.conversationList[j].targetId == $scope.friend.groupList[i].id && $rootScope.conversation.conversationList[j].conversationType == 'GROUP'){
                    $rootScope.conversation.conversationList[j].isBanned = $scope.friend.groupList[i].isBanned == 1 ? true : false;
                  }
                }
              }
            }

            var groups = {};
            groups.groups = [];
            for(var i in result.result){
              var group = {id: result.result[i].id, name: result.result[i].name, portraitUrl: !!result.result[i].picture ? result.result[i].picture : img.personalImage};
              groups.groups.push(group);
            }

            if (groups.groups.length > 0){
              rongcloudService.syncGroup(groups);
            }
          }
        })
      }, 1000*10);

    }
    $scope.init();

    $scope.joinGroupFlag = false;
    $scope.joinGroup = function(group,$event){
      if ($scope.joinGroupFlag){
        return;
      }
      $scope.joinGroupFlag = true;
      var groupId = group.id;
      groupService.joinGroup($rootScope.user.id, groupId)
        .then(function(result){
          var index = -1;
          for (var i in $scope.friend.recommendGroupList){
            if ($scope.friend.recommendGroupList[i].id == groupId){
              index = i;
              break;
            }
          }

          if (index > -1){
            $scope.friend.recommendGroupList.splice(index, 1);
          }
          $scope.joinGroupFlag = false;

          if ($scope.friend.recommendGroupList.length == 0){
            $scope.friend.getRecommendGroups();
          }

          rongcloudService.joinGroup(group);

          RongCloudLibPlugin.sendCommandNotificationMessage({
              conversationType: 'GROUP',
              targetId: groupId,
              name: 'JoinGroup',
              data: '<a class="JoinGroupUser-'+ $rootScope.user.id +'">"'+ $rootScope.user.nickName + '"</a> 加入了本群'
            },
            function(ret, err) {
              if (ret) {
                if (ret.status == "prepare") {
                  $rootScope.appendNewMsg(ret.result.message,true);
                }
              }
            }
          );

          var myPopup = $ionicPopup.show({
            title: '加入群组成功。'
          });
          $timeout(function() {
            if($scope.friend.isSearch){
              group.isJoined = 1 ;
            }
            myPopup.close();
          }, 3000);
        })
      $event.preventDefault();
    }

    $scope.goGroupDetail = function(groupId){
      $state.go("menu.groupDetail",{'groupId': groupId}) ;
    }
    //$scope.goGroupSearch = function(){
    //  $state.go("menu.addFriend",{'type': 'group'}) ;
    //}

    $scope.$watch('newmessage.innerMailCount', function(newValue, oldValue) {
      if (newValue > 0){
        friendService.getFriends($rootScope.user.id, "")
          .then(function(result){
            if (result.code == 0){
              for(var i in result.result){
                if (!result.result[i].personalImage){
                  result.result[i].personalImage = img.personalImage;
                }
              }
              $scope.friend.friendList = result.result;
            }
          });
      }
    });

    $scope.$on( "$ionicView.enter", function(){
      $rootScope.currentConversationInit();
      $scope.friend.getRecommendGroups();

      for (var i in $rootScope.newmessage.innerMailList){
        if (!$rootScope.newmessage.innerMailList[i].title.startsWith("申请") && $rootScope.newmessage.innerMailList[i].status == 0){
          $rootScope.newmessage.innerMailList[i].status = 1;
          $rootScope.newmessage.innerMailCount--;
          innermailService.readMail($rootScope.newmessage.innerMailList[i].id);
        }
      }
    })

    $scope.searchBlur = function(){
      $("#friendInput").blur() ;
      $cordovaKeyboard.close();
    }
});

