angular.module('groupMembers-controller',[])
  .controller('groupMembersCtrl',function($scope,$rootScope,$state,$stateParams,friendService,groupService, UserService,$ionicPopup,innermailService,$timeout, $interval,$ionicHistory,showAlertService, $ionicLoading, rongcloudService){
    $scope.setPadding = function(){
      var width = screen.width ;
      var num = parseInt((width)/78);
      var padding = (width-num*78)/2 ;
      angular.element("#memberimgList").css("padding-left",padding) ;
    }

    $scope.$on('$ionicView.afterEnter', function() {
      $scope.setPadding() ;
    }, false);

    $scope.group = {};

    $scope.groups = {};
    $scope.isGroupHost=false;

    $scope.init = function() {

      groupService.getGroupById($stateParams.groupId)
        .then(function(result) {
          $scope.group = result.result;
          $scope.group.bannedFlag = result.result.isBanned == 1 ? true : false;

          for (var i in result.result.hosts){
            if (result.result.hosts[i] == $rootScope.user.id){
              $scope.isGroupHost = true;
              break;
            }
          }
        })


      groupService.getGroupMembers($stateParams.groupId,"","1","35")
        .then(function (res) {
          if (res.message == "success"){
            for(var i in res.result.objects){
              if (!res.result.objects[i].personalImage){
                res.result.objects[i].personalImage = img.personalImage;
              }
            }
            $scope.groups = res.result;
            $scope.$apply() ;
          }
        })
    }

    $scope.init();

    $scope.$watch('group.bannedFlag',function(newValue,oldValue){
      if (newValue == undefined || oldValue == undefined){
        return;
      }
      if (newValue){
        $scope.group.isBanned = 1;
      }else{
        $scope.group.isBanned = 0;
      }

      // 修改群组禁言标志
      groupService.updateGroupBanned($scope.group.id, $scope.group.isBanned);

      // 发送禁言消息
      RongCloudLibPlugin.sendCommandNotificationMessage({
          conversationType: $rootScope.currentConversation.conversationType,
          targetId: $rootScope.currentConversation.targetId,
          name: newValue ? 'GroupBannedFlagOpen' : 'GroupBannedFlagClose',
          data: newValue ? '管理员开启了群组禁言' : '管理员关闭了群组禁言'
        },
        function(ret, err) {
          if (ret) {
            if (ret.status == "prepare") {
              $rootScope.appendNewMsg(ret.result.message);
            }
          }
        }
      );
    })

    $scope.addMembers = function () {
      if($scope.group.manageUserid == null || $scope.group.manageUserid == undefined){
        $rootScope.$broadcast('message',"数据加载中，请稍后再试！",3000,"notice");
        return;
      }
      if (!$scope.isGroupHost) {
        $rootScope.$broadcast('message',"您不是管理员或主持,没有管理权限",3000,"notice");
        return;
      }
        $state.go("menu.addMember",{'groupId':$stateParams.groupId});
    }

    $scope.updateAnnouncement = function () {
      $state.go("menu.groupUpdate",{'groupId':$scope.group.id,'type':'announcement'}) ;
    }

    $scope.goBack = function () {
      $rootScope.goToBack();
    }

    $scope.getUserDetail = function (id) {
      $state.go("menu.userDetail",{'userId':id}) ;
    }

    //跳转到群组成员
    $scope.getMembersList = function(id,manageUserid){
      $state.go("menu.membersList",{'groupId':id, 'manageUserid':manageUserid}) ;
    }
  });

