angular.module('membersList-controller',[])
  .controller('membersListCtrl',function($scope,$rootScope,$ionicListDelegate,$state,$stateParams,friendService,groupService, UserService,$ionicPopup,innermailService,$timeout, $interval,$ionicHistory,showAlertService, $ionicLoading, rongcloudService){

    //判断是否是管理员
    $scope.isManager = false;
    if ($stateParams.manageUserid == $rootScope.user.id) {
      $scope.isManager = true;
    }

    $scope.groups = {};

    $scope.noUserFlag = false;

    $scope.search = {
      text: ''
    };

    // $scope.member_paras = {
    //   hasmore : true ,
    //   pageSize : 1000,
    // }

    $scope.getMember = function () {
      groupService.getGroupMembers($stateParams.groupId,$scope.search.text,"1","1000")
        .then(function (result) {
          // alert(JSON.stringify(result));
          if (result.message == "success"){
            for(var i in result.result.objects){
              if (!result.result.objects[i].personalImage){
                result.result.objects[i].personalImage = img.personalImage;
              }
            }
            $scope.groups = result.result;
            $scope.$apply() ;
            // alert(JSON.stringify($scope.groups.total));
            if ($scope.groups.total == 0){
              $scope.noUserFlag = true;
            }else{
              $scope.noUserFlag = false;
            }

            // alert(JSON.stringify($scope.noUserFlag));
            // //当前数量小于查询数量，禁止加载更多
            // if (result.result.objects.length < $scope.member_paras.pageSize) {
            //   $scope.member_paras.hasmore = false;
            // }
            $scope.$broadcast('scroll.refreshComplete');
          }

        },function(error){
          $scope.$broadcast('scroll.refreshComplete');
        }).finally(function () {
        $scope.$broadcast('scroll.refreshComplete');
        });
    }

    //删除群组成员
    $scope.deleteMember = function (member) {
      if($stateParams.manageUserid == member.id){
        showAlertService.PopShow("提示信息","管理员不能移除!",2000) ;
      }
      else {
        showAlertService.PopConfirm("提示信息","是否将该成员从群组中移除","取消","确认")
          .then(function(result) {
            if(result) {
              groupService.deleteGroupMember($stateParams.groupId,member.id)
                .then(function (result) {
                  $scope.groups.objects.splice($scope.groups.objects.indexOf(member), 1);

                  RongCloudLibPlugin.sendCommandNotificationMessage({
                      conversationType: $rootScope.currentConversation.conversationType,
                      targetId: $rootScope.currentConversation.targetId,
                      name: 'RemoveGroupUser-'+member.id,
                      data: '"'+member.groupNickname + '" 已被管理员移出群聊'
                    },
                    function(ret, err) {
                      if (ret) {
                        if (ret.status == "prepare") {
                          $rootScope.appendNewMsg(ret.result.message, true);
                        }
                      }
                    }
                  );
                },function(error){
                  // alert(JSON.stringify(error));
                  showAlertService.PopShow("提示信息","移除失败,请稍后再试!",2000) ;
                })
            }
            else {
            }
          });
      }
    }

    $scope.addMembers = function () {
      $state.go("menu.addMember",{'groupId':$stateParams.groupId});
    }

    $scope.getMember();

    $scope.searchTextChange = function(){
      // alert($scope.search.text)
    }

    $scope.changeHost = function (member, value) {
      groupService.updateGroupHost($stateParams.groupId, member.id, value)
        .then(function(result) {
          member.isHost = value;
          $ionicListDelegate.closeOptionButtons();
        });

      RongCloudLibPlugin.sendCommandNotificationMessage({
          conversationType: $rootScope.currentConversation.conversationType,
          targetId: $rootScope.currentConversation.targetId,
          name: value==1 ? 'GroupUserHostOpen-'+member.id : 'GroupUserHostClose-'+member.id,
          data: value==1 ? '"'+member.groupNickname + '" 被管理员设为主持' : '"'+member.groupNickname + '" 被管理员取消主持'
        },
        function(ret, err) {
          if (ret) {
            if (ret.status == "prepare") {
              $rootScope.appendNewMsg(ret.result.message);
            }
          }
        }
      );
    }
  });

