angular.module('messageDetail-controller',[])
  .controller('messageDetailCtrl',function($ionicGesture,$scope,$rootScope,$state,$stateParams,$ionicSlideBoxDelegate, $ionicScrollDelegate,UserService,$ionicPopup,groupService,$cordovaCamera,$cordovaMedia,$cordovaFile,$cordovaImagePicker,$timeout,$interval,commentService,$cordovaKeyboard){

    $scope.userListFlag=false;
    $scope.showMsgTipFlag=false;
    $scope.doRefreshFlag=false;
    $scope.doRefreshMessageId=-1;
    $scope.failMessageList = [];
    $scope.isGroupHost=false;
    $scope.groupBannedFlag=false;
    $scope.alertDivStyle = {top: '0px'};

    $scope.atUser = null;
    $scope.messageTextChange = function(){
      if ($rootScope.currentConversation.conversationType != 'GROUP'){
        return;
      }
      if ($rootScope.currentConversation.inputText.endsWith('@')){
        $cordovaKeyboard.close();
        $scope.userListFlag=true;
      }
    }
    $scope.keyDown = function(e){
      if ($rootScope.currentConversation.conversationType != 'GROUP'){
        return;
      }
      var keyCode = window.event?e.keyCode:e.which;
      if (keyCode == 8){
        if ($rootScope.currentConversation.inputText.trim().endsWith('@'+$scope.atUser.name)){
          $rootScope.currentConversation.inputText = $rootScope.currentConversation.inputText.replace('@'+$scope.atUser.name, '');
          $scope.atUser = null;
        }
      }
    }
    $scope.selectAtUser = function(member){
      $scope.atUser = {id:member.id,name:member.groupNickname};
      $rootScope.currentConversation.inputText += $scope.atUser.name+' ';
      $scope.userListFlag=false;
    }

    $scope.onHoldUserPic = function(id, name){
      if ($scope.videoMessageFlag){
        $scope.videoMessageFlag = false;
      }

      name = name.split(' | ')[1];
      $scope.atUser = {id:id,name:name};
      $rootScope.currentConversation.inputText += '@'+$scope.atUser.name+' ';
    }

    $scope.getAtUserId = function(){
      if (!!$scope.atUser){
        return $scope.atUser.id;
      }
      return '';
    }

    $scope.sendNotificationMessage = function(name, data){
      RongCloudLibPlugin.sendCommandNotificationMessage({
          conversationType: $rootScope.currentConversation.conversationType,
          targetId: $rootScope.currentConversation.targetId,
          name: name,
          data: data
        },
        function(ret, err) {
          $scope.atUser = null;
          if (ret) {
            if (ret.status == "prepare") {
              $rootScope.appendNewMsg(ret.result.message);
            }
          }
        }
      );
    };

    $scope.sendTextMessage = function(text, reSendFlag){
      RongCloudLibPlugin.sendTextMessage({
          conversationType: $rootScope.currentConversation.conversationType,
          targetId: $rootScope.currentConversation.targetId,
          text: text,
          extra:new Date().getTime() + ' | ' + $rootScope.user.nickName + ' | ' + $scope.getAtUserId()
        },
        function(ret, err) {
          $scope.atUser = null;
          if (ret) {
            if (ret.status == "prepare") {
              if (!reSendFlag){
                $rootScope.appendNewMsg(ret.result.message);
              }
            }
          }
          if (err) {
            var messageId = err.result;
            $scope.failMessageList.push({"messageId":messageId, "messageType":"text", "text":text});
            $scope.setFailFlag(messageId, true);
          }
        }
      );
    };
    $scope.sendImgMessage = function(url, reSendFlag){
      RongCloudLibPlugin.sendImageMessage({
          conversationType: $rootScope.currentConversation.conversationType,
          targetId: $rootScope.currentConversation.targetId,
          imagePath: url,
          extra: new Date().getTime() + ' | ' + $rootScope.user.nickName + ' | ' + $scope.getAtUserId()
        },
        function(ret, err) {
          if (ret) {
            if (ret.status == "prepare") {
              if (!reSendFlag){
                $rootScope.appendNewMsg(ret.result.message, $scope.isOverScreen);
              }
            }
          }
          if (err) {
            var messageId = err.result.message.messageId;
            $scope.failMessageList.push({"messageId":messageId, "messageType":"img", "url":url});
            $scope.setFailFlag(messageId, true);
          }
        }
      );
    };

    $scope.sendVoiceMessage = function(path, dur, reSendFlag){
      RongCloudLibPlugin.sendVoiceMessage({
          conversationType: $rootScope.currentConversation.conversationType,
          targetId: $rootScope.currentConversation.targetId,
          voicePath: path,
          duration: dur,
          extra: new Date().getTime() + ' | ' + $rootScope.user.nickName + ' | ' + $scope.getAtUserId()
        },
        function(ret, err) {
          if (ret) {
            if (ret.status == "prepare") {
              if (!reSendFlag){
                $rootScope.appendNewMsg(ret.result.message);
              }
            }
          }
          if (err) {
            var messageId = err.result.message.messageId;
            $scope.failMessageList.push({"messageId":messageId, "messageType":"voice", "path":path, "dur":dur});
            $scope.setFailFlag(messageId, true);
          }
        }
      );
    };

    $scope.reSend = function(messageId){
      $scope.setFailFlag(messageId, false);
      var message = null;
      for (var i in $scope.failMessageList){
        if ($scope.failMessageList[i].messageId == messageId){
          message = $scope.failMessageList[i];
        }
      }

      if (!!message){
        if (message.messageType == 'text'){
          $scope.sendTextMessage(message.text, true);
        }else if (message.messageType == 'img'){
          $scope.sendImgMessage(message.url, true);
        }else if (message.messageType == 'voice'){
          $scope.sendVoiceMessage(message.path, message.dur, true);
        }
      }
    }

    $scope.setFailFlag = function(messageId, failFlag){
      for (var i in $rootScope.currentConversation.messageList){
        if ($rootScope.currentConversation.messageList[i].messageId == messageId){
          $rootScope.currentConversation.messageList[i].failFlag = failFlag;
          $rootScope.$apply();
          break;
        }
      }
    }

    var isIOS = ionic.Platform.isIOS();
    var isAndroid = ionic.Platform.isAndroid();

    $scope.sendPhoto = function(){
      var options = {
        maximumImagesCount: 9,
        maxSize: 100
      };

      $cordovaImagePicker.getPictures(options)
        .then(function (imageURIs) {
          if (imageURIs.length == 0){
            return;
          }

          var i = 0;
          $interval(function(){
            var imageURI;
            if(isIOS){
              imageURI= imageURIs[i].replace('file://','');
            }else{
              if (!imageURIs[i].startsWith('file://')){
                imageURI = 'file://'+ imageURIs[i];
              }else{
                imageURI = imageURIs[i];
              }
            }
            $scope.sendImgMessage(decodeURI(imageURI), false);
            i++;
          }, 1000, imageURIs.length);
        }, function (err) {
          console.log(err);
        });
    }

    //$scope.sendPhoto = function(){
    //  var options = {
    //    quality: 100,
    //    saveToPhotoAlbum: false,
    //    sourceType: 0,
    //    destinationType: Camera.DestinationType.FILE_URI
    //  };
    //
    //  $cordovaCamera.getPicture(options).then(function(imageURI) {
    //    var picPath = imageURI;
    //    if(isIOS){
    //      picPath = imageURI.replace('file://','');
    //    }
    //    if(isAndroid){
    //      var index = imageURI.indexOf('?');
    //      if (index > 0){
    //        picPath = imageURI.substring(0, imageURI.indexOf('?'));
    //      }
    //    }
    //
    //    $scope.sendImgMessage(picPath, false);
    //  }, function(err) {
    //    console.error(err);
    //  });
    //}

    $scope.sendCamera = function(){
      var options = {
        quality: 100,
        sourceType: Camera.PictureSourceType.CAMERA,
        destinationType: Camera.DestinationType.FILE_URI
      };

      $cordovaCamera.getPicture(options)
        .then(function(imageURI) {

        if(isIOS){
           imageURI= imageURI.replace('file://','');
        }

        $scope.sendImgMessage(imageURI, false);
      }, function(err) {
        console.error(err);
      });
    }

    $scope.sendText = function(){
      if (!$rootScope.currentConversation.inputText){
        return;
      }
      $scope.sendTextMessage($rootScope.currentConversation.inputText, false);
      $rootScope.currentConversation.inputText = '';

    }

    $scope.getHistoryMsg = function(oldestMessageId) {
      RongCloudLibPlugin.getHistoryMessages({
          conversationType: $rootScope.currentConversation.conversationType,
          targetId: $rootScope.currentConversation.targetId,
          count: 10,
          oldestMessageId: oldestMessageId
        },
        function(ret, err) {
          if (ret) {
            var result = new Array(),tmp;
            for (var i = ret.result.length - 1; i >= 0; i--) {
              tmp = ret.result[i];
              tmp = rongCloudUtil.resolveMsg(tmp);
              var userPic = $rootScope.getUserPic(tmp.senderUserId);
              tmp.userPic = userPic;
              result.push(tmp);
            }
            var hisArr = result.concat($rootScope.currentConversation.messageList);
            $rootScope.currentConversation.messageList = hisArr;

            var cancelMessageList = [];
            for(var i in $rootScope.currentConversation.messageList){
              if (!!$rootScope.currentConversation.messageList[i].content.data && $rootScope.currentConversation.messageList[i].content.name.startsWith('CancelMessage')){
                cancelMessageList.push($rootScope.currentConversation.messageList[i].content.name.split('-')[1]);
              }
            }
            if (!$scope.isOverScreen){
              $scope.imgsShowList = $rootScope.currentConversation.imageList.concat();
            }

            if (cancelMessageList.length > 0){
              var messageLists = [];
              for (var i in cancelMessageList){
                var index = -1;
                for (var j in $rootScope.currentConversation.messageList){
                  if (!!$rootScope.currentConversation.messageList[j].content.extra && $rootScope.currentConversation.messageList[j].content.extra.split(' | ')[0] == cancelMessageList[i]){
                    messageLists.push($rootScope.currentConversation.messageList[j].messageId);
                    index = j;
                    break;
                  }
                }
                if (index > -1){
                  $rootScope.currentConversation.messageList.splice(index, 1);
                }
              }

              if (messageLists.length > 0){
                RongCloudLibPlugin.deleteMessages({
                  messageIds: messageLists
                }, function (ret, err) {
                  console.log(JSON.stringify(ret))
                })
              }
            }

            if (oldestMessageId > -1 && ret.result.length > 0 && !!$('#messageDiv-'+oldestMessageId).position()){
              var timer = $interval(function(){
                var position = $('#messageDiv-'+oldestMessageId).position().top;
                if (position > 50){
                  var delegate = $ionicScrollDelegate.$getByHandle('messageDetailsScroll');
                  delegate.scrollTo(0, position - 60, false);
                  $interval.cancel(timer);
                  $scope.doRefreshFlag=false;
                }
              }, 50);
            }else{
              $scope.doRefreshFlag=false;
              $scope.$apply();
            }

            if (oldestMessageId == -1){
              $ionicScrollDelegate.scrollBottom(true);
            }

            $rootScope.currentConversation.imageList = [];
            for (var i in $rootScope.currentConversation.messageList){
              if ($rootScope.currentConversation.messageList[i].objectName == 'RC:ImgMsg'){
                $rootScope.currentConversation.imageList.push($rootScope.currentConversation.messageList[i].content.imageUrl);
              }
            }

            $("a[class^='JoinGroupUser']").on('click',function(e){
              var classInfo = $(e.target).attr("class");
              var userId = classInfo.split(' ')[0].split('-')[1];
              $state.go("menu.userDetail",{'userId':userId}) ;
            });
          }
          if (err) {
            console.log("getHistoryMessages error: " + JSON.stringify(err));
          }
        }
      );
    }

    $scope.clearMessagesUnreadStatus = function() {
      $rootScope.newmessage.messageCount = 0;
      for (var i in $rootScope.conversation.conversationList){
        var conversationTemp = $rootScope.conversation.conversationList[i];
        if (conversationTemp.targetId == $rootScope.currentConversation.targetId && conversationTemp.conversationType == $rootScope.currentConversation.conversationType){
          conversationTemp.unreadMessageCount = 0;
          conversationTemp.atFlag = false;
          $rootScope.$apply();
        }else{
          $rootScope.newmessage.messageCount += conversationTemp.unreadMessageCount;
        }
      }

      RongCloudLibPlugin.clearMessagesUnreadStatus({
          conversationType: $rootScope.currentConversation.conversationType,
          targetId: $rootScope.currentConversation.targetId
        },
        function (ret, err) {
          if (err) {
            //console.log("clearMessagesUnreadStatus error: " + JSON.stringify(err));
          }
        }
      );
    }

    $scope.doRefresh = function() {
      if ($scope.doRefreshFlag){
        return;
      }

      var oldestMessageId = -1;
      if ($rootScope.currentConversation.messageList.length > 0){
        oldestMessageId = $rootScope.currentConversation.messageList[0].messageId;
        if ($('#messageDiv-'+oldestMessageId).length == 0){
          oldestMessageId = -1;
        }
      }

      if (oldestMessageId == -1){
        $rootScope.currentConversation.messageList=[];
        $scope.doRefreshFlag=true;
        $scope.getHistoryMsg(oldestMessageId);
      }else{
        var position = $('#messageDiv-'+oldestMessageId).position().top;
        if (position > -1){
          $scope.doRefreshFlag=true;
          $scope.doRefreshMessageId=oldestMessageId;
          $timeout(function(){
            $scope.getHistoryMsg(oldestMessageId);
          }, 500);
        }
      }
    };

    $scope.init = function(){
      if($stateParams.conversationType == 'GROUP'){
        $scope.isGROUP = true;
        $scope.marginTopStyle = {top:'33px'};

        groupService.getGroupById($stateParams.targetId)
          .then(function(result){
            if (!!result.result){
              $scope.groupBannedFlag = result.result.isBanned == 1 ? true : false;

              for (var i in result.result.hosts){
                if (result.result.hosts[i] == $rootScope.user.id){
                  $scope.isGroupHost = true;
                  break;
                }
              }
            }
          })

      }else{
        $scope.isGROUP = false;
        $scope.marginTopStyle = {top:'17px'};
      }
      $rootScope.currentConversation.targetId = $stateParams.targetId;
      $rootScope.currentConversation.conversationType = $stateParams.conversationType;
      $rootScope.currentConversation.conversationTitle = $stateParams.conversationTitle;

      $scope.doRefresh();
      $scope.clearMessagesUnreadStatus();
      $scope.getMember();
    }

    $scope.$on( "$ionicView.enter", function(){
      $scope.openPicNumber = 0;
      if (!$rootScope.conversationFlag){
        $rootScope.$emit('message',"通信模块初始化失败，暂无法使用",3000,"notice");
        return;
      }
      $scope.closeOverScreen();
      if ($rootScope.currentConversation.messageList.length == 0){
        $scope.init();
      }else{
        $("a[class^='JoinGroupUser']").on('click',function(e){
          var classInfo = $(e.target).attr("class");
          var userId = classInfo.split(' ')[0].split('-')[1];
          $state.go("menu.userDetail",{'userId':userId}) ;
        });

        if($stateParams.conversationType == 'GROUP'){
          groupService.getGroupById($stateParams.targetId)
            .then(function(result){
              if (!!result.result){
                $scope.groupBannedFlag = result.result.isBanned == 1 ? true : false;

                var isGroupHost = false;
                for (var i in result.result.hosts){
                  if (result.result.hosts[i] == $rootScope.user.id){
                    isGroupHost = true;
                    break;
                  }
                }
                $scope.isGroupHost = isGroupHost;
              }
            })
        }
      }
    })

    $scope.videoMessageFlag = false;
    $scope.videoMessageText = "按住 说话";
    $scope.changeVideo = function(){
      $scope.videoMessageFlag = !$scope.videoMessageFlag;
    }

    $scope.showBigPic = false;
    $scope.showBigPicPath = 'img/sload.gif';
    $scope.openImage = function(url){
      $scope.showBigPicPath = url;
      $scope.showBigPic = true;
      angular.element('.nav-bar-container').hide();
    }
    $scope.closeImage = function(){
      $scope.showBigPic = false;
      $scope.showBigPicPath = 'img/sload.gif';
      angular.element('.nav-bar-container').show();
    }

    var src = "cordovaIMVoice.amr";
    var mediaRec;
    var path = "";
    if(isIOS){
      path = cordova.file.documentsDirectory;
      src = "cordovaIMVoice.wav";
    }else{
      path = cordova.file.externalApplicationStorageDirectory;
    }

    $scope.getMediaURL = function(s) {
      if (device.platform.toLowerCase() === "android") return path + s;
      return (path + s).replace('file://', '');
    }

    $scope.getNewMediaURL = function(s) {
      if (device.platform.toLowerCase() === "android") return path + s;
      return "documents://" + s;
    }

    $scope.start = function(){
      if (mediaRec) {
        mediaRec.release();
      }
      mediaRec = new Media($scope.getNewMediaURL(src),
        // 录音执行函数
        function() {
          //console.log("start():Audio Success");
        },
        // 录音失败执行函数
        function(err) {
          //console.log("start():Audio Error: " + JSON.stringify(err)+ "----"+getMediaURL(src));
        }
      );
    }
    $scope.currentVadioId = -1;
    $scope.backgroundColorChange = function(msgId, changeColor, currentColor){
      $('#triangle-'+msgId).css('border-color', 'transparent '+changeColor+' transparent transparent');
      $('#triangleself-'+msgId).css('border-color', 'transparent transparent transparent '+changeColor);
      $('#vadio-'+msgId).css('background-color', changeColor);
      $('#vadioself-'+msgId).css('background-color', changeColor);


      $timeout(function(){
        $('#triangle-'+msgId).css('border-color', 'transparent '+changeColor+' transparent transparent');
        $('#triangleself-'+msgId).css('border-color', 'transparent transparent transparent '+currentColor);
        $('#vadio-'+msgId).css('background-color', currentColor);
        $('#vadioself-'+msgId).css('background-color', currentColor);
      }, 500);
    }

    $scope.vadioTimer = null;
    $scope.play = function(message, nextFlag) {
      if (!!mediaRec){
        mediaRec.stop();
      }

      if (!nextFlag && !!$scope.vadioTimer){
        $timeout.cancel($scope.vadioTimer);
      }

      // 再次点击语音  停止播放
      if (message.messageId == $scope.currentVadioId){
        $scope.currentVadioId = -1;
        return;
      }

      mediaRec = $cordovaMedia.newMedia(message.content.voicePath,
        function() {
          $cordovaMedia.release();
        },
        function(err) {
        }
      );
      //开始播放录音
      $scope.currentVadioId = message.messageId;
      $scope.vadioTimer = $timeout(function(){
        var nextMessage = null;
        for (var i in $rootScope.currentConversation.messageList){
          if ($rootScope.currentConversation.messageList[i].messageId <= message.messageId){
            continue;
          }
          if ($rootScope.currentConversation.messageList[i].objectName == 'RC:VcMsg'){
            nextMessage = $rootScope.currentConversation.messageList[i];
            break;
          }
        }

        if (!!nextMessage && $scope.currentVadioId != -1){
          $scope.play(nextMessage, true);
        }else{
          $scope.currentVadioId = -1
        }
      }, message.content.duration * 1000 + 1000);
      mediaRec.play({ numberOfLoops: 1 });
      return false;
    };

    $scope.startRecord = function(){
      $scope.videoMessageText = "松开 结束";
      $scope.start();
      mediaRec.startRecord();
    }
    $scope.endRecord = function(){
      if (mediaRec) {
        mediaRec.stopRecord();
        mediaRec.release();
      }
      mediaRec = new Media($scope.getMediaURL(src),
        function() {
        },
        // 失败操作
        function(err) {
          //console.log("touchend():Audio Error: " + err.code);
        }
      );

      //开始播放录音
      mediaRec.play();
      mediaRec.stop();

      var counter = 0;
      var timerDur = setInterval(function() {
        counter = counter + 100;
        if (counter > 2000) {
          clearInterval(timerDur);
        }
        var dur = mediaRec.getDuration();

        if (dur > 0 && dur < 10000) {
          clearInterval(timerDur);
          var tmpPath = mediaRec.src;
          if(isIOS){
            tmpPath = path + src;
          }
          tmpPath = tmpPath.replace('file://', '');

          $scope.sendVoiceMessage(tmpPath, dur, false)

          mediaRec.release();
        }
      }, 100);

      $scope.videoMessageText = "按住 说话";
      return false;
    }

    $scope.goBack = function(){
      if ($scope.userListFlag){
        $scope.userListFlag = false;
      }else{
        $scope.currentVadioId = -1
        if (!!$scope.vadioTimer){
          $timeout.cancel($scope.vadioTimer);
        }

        if (!!mediaRec){
          mediaRec.stop();
        }
        $rootScope.goToBack();
      }
    }

    //跳转到群组信息
    $scope.goToMembers = function(id){
      $state.go("menu.groupMembers",{'groupId':id}) ;
    }


    $scope.imgIndex = 0;
    $scope.slideHasChanged = function (index) {
      var lastImg = angular.element('#img-'+$rootScope.currentConversation.targetId+'-' + (parseInt($scope.imgIndex)-1));
      var currentImg = angular.element('#img-'+$rootScope.currentConversation.targetId+'-' + $scope.imgIndex);
      var nextImg = angular.element('#img-'+$rootScope.currentConversation.targetId+'-' + (parseInt($scope.imgIndex)+1));
      if (lastImg.length > 0){
        bigPictureOnLoad(lastImg[0]);
      }
      if (currentImg.length > 0){
        bigPictureOnLoad(currentImg[0]);
      }
      if (nextImg.length > 0){
        bigPictureOnLoad(nextImg[0]);
      }
      $scope.imgIndex = index;
    }

    $scope.count = 0 ;
    $scope.imgsShowList = [];
    $scope.openPicNumber = 0;
    $scope.openOverScreen = function(url){
      $scope.openPicNumber ++;
      var index = -1;
      $scope.imgsShowList = $rootScope.currentConversation.imageList.concat();

      for (var i in $scope.imgsShowList){
        if ($scope.imgsShowList[i] == url){
          index = i;
          break;
        }
      }

      $scope.count ++ ;
      //$ionicSlideBoxDelegate.$getByHandle("myActiveSlide2").update() ;
      $ionicSlideBoxDelegate.update() ;
      $ionicSlideBoxDelegate.slide(parseInt(index),0);
      if ($scope.openPicNumber == 1){
        angular.element('.nav-bar-container').hide();
        $scope.isOverScreen = true ;
      }
      $timeout(function(){
        $(".big-picture").css('visibility','visible');
        $ionicSlideBoxDelegate.update() ;
        $ionicSlideBoxDelegate.slide(parseInt(index),0);
        if ($scope.openPicNumber > 1){
          angular.element('.nav-bar-container').hide();
          $scope.isOverScreen = true ;
        }
      },500);
      $scope.imgIndex = index ;
      //第一次点击出现大图时增加事件
      if($scope.count == 1){
        var pinchDragEvent = null;
        var slide = angular.element('#slide-'+$rootScope.currentConversation.targetId) ;
        // 计算拖动开始时两指间距离
        var intervalPinch = 0;
        var startX1 =  0;
        var startY1 =  0;
        var startX2 =  0;
        var startY2 =  0;
        var startDist = 0;
        var isIOS = ionic.Platform.isIOS();
        var intervalPx = 8;
        if (isIOS){
          intervalPx = 15;
        }

        $ionicGesture.on("pinch",function(e){
          var img = angular.element('#img-'+$rootScope.currentConversation.targetId+'-'+$scope.imgIndex) ;
          if (pinchDragEvent == null){
            pinchDragEvent = e;
            // 计算拖动开始时两指间距离
            var startTouch1 = pinchDragEvent.gesture.touches[0];
            var startTouch2 = pinchDragEvent.gesture.touches[1];
            startX1 =  startTouch1.pageX;
            startY1 =  startTouch1.pageY;
            startX2 =  startTouch2.pageX;
            startY2 =  startTouch2.pageY;
            startDist = Math.sqrt(Math.pow((startX2-startX1),2) + Math.pow((startY2-startY1),2));
            return;
          }

          intervalPinch++;
          if (intervalPinch%3 != 0){
            return;
          }

          //// 计算当前两指间距离
          var endTouch1 = e.gesture.touches[0];
          var endTouch2 = e.gesture.touches[1];
          var endX1 =  endTouch1.pageX;
          var endY1 =  endTouch1.pageY;
          var endX2 =  endTouch2.pageX;
          var endY2 =  endTouch2.pageY;
          var endDist = Math.sqrt(Math.pow((endX2-endX1),2) + Math.pow((endY2-endY1),2));
          var left = 0 ;
          var top = 0 ;
          var rate = 1 ;
          var reg = /\-?[0-9]+\.?[0-9]*/g ;

          if (Math.abs(endDist - startDist) > intervalPx){
            if (endDist > startDist){
              var width = screen.width ;
              var length = parseFloat(Math.abs(endDist - startDist)) ;
              var scale = img.css("webkitTransform") ;
              var array = scale.match(reg) ;
              left = parseFloat(array[4]) ;
              top = parseFloat(array[5]) ;
              rate = parseFloat(array[0]);
              var num = rate + parseFloat(length/width) ;
              img.css("webkitTransform","translate("+left+"px,"+top+"px) scale("+num+")") ;
            }else{
              var width = screen.width ;
              var length = parseFloat(Math.abs(endDist - startDist)) ;

              var scale = img.css("webkitTransform") ;
              var array = scale.match(reg) ;
              left = parseFloat(array[4]) ;
              top = parseFloat(array[5]) ;
              rate = parseFloat(array[0]);
              var num = rate - parseFloat(length/width) ;
              if(num >= 1){
                img.css("webkitTransform","translate("+left+"px,"+top+"px) scale("+num+")") ;
              }
            }
          }
          else{
            var x = endX1-startX1 ;
            var y = endY1-startY1 ;
            var scale = img.css("webkitTransform") ;
            var array = scale.match(reg) ;
            left = parseFloat(array[4]) + parseFloat(x);
            top = parseFloat(array[5]) + parseFloat(y);
            rate = parseFloat(array[0]);
            img.css("webkitTransform","translate("+left+"px,"+top+"px) scale("+rate+")") ;
          }
          pinchDragEvent = e;
          var startTouch1 = pinchDragEvent.gesture.touches[0];
          var startTouch2 = pinchDragEvent.gesture.touches[1];
          startX1 =  startTouch1.pageX;
          startY1 =  startTouch1.pageY;
          startX2 =  startTouch2.pageX;
          startY2 =  startTouch2.pageY;
          startDist = Math.sqrt(Math.pow((startX2-startX1),2) + Math.pow((startY2-startY1),2));
        }, slide);
        $ionicGesture.on("release",function(){
          pinchDragEvent = null;
          startX1 =  0;
          startY1 =  0;
          startX2 =  0;
          startY2 =  0;
          startDist = 0;
          intervalPinch = 0;
        }, slide);
      }
    }

    $scope.closeOverScreen = function(){
      angular.element('.nav-bar-container').show();
      $('.rj-stable-content').css('overflow','');
      $scope.isOverScreen = false ;
      $scope.imgsShowList = $rootScope.currentConversation.imageList.concat();
      $ionicSlideBoxDelegate.update() ;
      $ionicSlideBoxDelegate.slide($scope.imgIndex);
    }

    $scope.groupMembers = {};
    $scope.groupMembersSearch = {
      text: ''
    };

    $scope.getMember = function () {
      if ($rootScope.currentConversation.conversationType == 'GROUP'){
        groupService.getGroupMembers($rootScope.currentConversation.targetId ,$scope.groupMembersSearch.text,"1","1000")
          .then(function (result) {
            $scope.groupMembers = result.result;
          })
      }
    }

    $scope.getUserDetail = function (id) {
      $state.go("menu.userDetail",{'userId':id}) ;
    }

    $scope.showMsgTip = function(id){
      var message = null;
      for (var i in $rootScope.currentConversation.messageList){
        if ($rootScope.currentConversation.messageList[i].messageId == id){
          message = $rootScope.currentConversation.messageList[i];
          break;
        }
      }

      if (!message){
        return;
      }

      var overtime = 30 * 1000;
      var msgSendTime = message.sentTime;
      if (new Date().getTime() - msgSendTime > overtime){
        return;
      }

      var msgTipDivHeight = 40;
      var msgContentTop = $('#messageDiv-'+id).position().top + $ionicScrollDelegate.$getByHandle('messageDetailsScroll').getScrollPosition().top;
      var msgTimeHeight = $('#messageTime-'+id).length > 0 ? 26 : 0;

      var top = msgContentTop - msgTipDivHeight + msgTimeHeight;

      $scope.alertDivStyle = {top: (top > 0 ? top : 0) +'px'};
      $scope.showMsgTipId = id;
      $scope.showMsgTipFlag=true;
    }

    $scope.hideMsgTip = function(){
      if ($scope.showMsgTipFlag){
        $scope.showMsgTipFlag = false;
      }
    }

    $scope.cancelMessage = function(){
      var index = -1;
      for (var i in $rootScope.currentConversation.messageList){
        if ($rootScope.currentConversation.messageList[i].messageId == $scope.showMsgTipId){
          index = i;
          break;
        }
      }

      RongCloudLibPlugin.deleteMessages({
        messageIds: [$scope.showMsgTipId]
      }, function (ret, err) {
        console.log(JSON.stringify(ret))
      })

      if (index > -1){
        $scope.sendNotificationMessage('CancelMessage-'+$rootScope.currentConversation.messageList[index].content.extra.split(' | ')[0], '"'+ $rootScope.user.nickName +'" 撤回了一条消息');
        $rootScope.currentConversation.messageList.splice(index, 1);
      }
    }

    $scope.textAreaMoveEnd = function(event){
      //console.log("点击事件触发");
      commentService.moveEnd(event.currentTarget.children[0]);
    }

    $scope.templateMsgJump = function(msg){
      var tempMsg = JSON.parse(msg.replace('TEMPMSG-',''));

      if (tempMsg.dataType == 1){
        $state.go('menu.case-detail',{caseId:tempMsg.dataId}) ;
      }else if (tempMsg.dataType == 2){
        $state.go('menu.community-detail',{communityId:tempMsg.dataId}) ;
      }else if (tempMsg.dataType == 3){
        $state.go('menu.learn-detail',{learnId:tempMsg.dataId}) ;
      }else if (tempMsg.dataType == 4){
        $state.go('menu.ppt-detail',{pptId:tempMsg.dataId}) ;
      }else if (tempMsg.dataType == 5){
        $state.go('menu.classroom-detail',{classId:tempMsg.dataId}) ;
      }
    }

    $scope.$on("groupBannedFlag:open", function(){
      $scope.groupBannedFlag=true;
    })
    $scope.$on("groupBannedFlag:close", function(){
      $scope.groupBannedFlag=false;
    })
    $scope.$on("groupHostFlag:open", function(){
      $scope.isGroupHost=true;
    })
    $scope.$on("groupHostFlag:close", function(){
      $scope.isGroupHost=false;
    })
    $scope.$on("imgMsg", function(){
      if (!$scope.isOverScreen){
        $scope.imgsShowList = $rootScope.currentConversation.imageList.concat();
      }
    })
    $scope.$on("mobile:back", function(){
      if ($scope.userListFlag){
        $scope.userListFlag = false;
      }else{
        $scope.currentVadioId = -1
        if (!!$scope.vadioTimer){
          $timeout.cancel($scope.vadioTimer);
        }

        if (!!mediaRec){
          mediaRec.stop();
        }
      }
    })
  });

