/**
 * Created by sks on 2016/5/17.
 */
angular.module('search-controller',[])
  .controller('SearchCtrl',function($scope,$state,HomeService){
    $scope.params = {
      hasmore : false ,
      isSearch: false ,
      from : 0 ,
      pageSize:10,
    }
    $scope.queryResults = [] ;
    $scope.query = {
      queryStr :"",
    } ;
    $scope.case_type=[
      "",
      "cases",
      "communitys",
      "learn-detail",
      "ppt-detail",
      "classroom-detail",
    ]
    $scope.selectValue = "" ;
    $scope.community_img_url = img.url ;
    $scope.case_img_url = img.case_url

    //更改图片路径
    $scope.changeImgUrl = function(list){
      var img_path = "" ;
      for(var i in list){
        var imgUrl = list[i].thumbnail ;
        if(!imgUrl){
          list[i].thumbnail = "img/study/no_learn.png";
        }else{
          if(imgUrl.substr(0,7)!="http://" && imgUrl.substr(0,8)!="https://"){
            //case_type   1:经典病历    2:讨论社区
            if(list[i].case_type == '1'){
              list[i].thumbnail = $scope.case_img_url +"/" +img_path +"/"+imgUrl ;
            }else if(list[i].case_type == '2'){
              list[i].thumbnail = $scope.community_img_url +"/" +list[i].case_id +img_path +"/"+imgUrl ;
            }
          }
        }
      }
      return list;
    }

    $scope.change = function(value){
      //console.log(value) ;
      $scope.selectValue = value ;
    }
    $scope.search = function(){
      //console.log($scope.selectValue) ;
      $scope.params.from = 0 ;
      HomeService.search(0,$scope.params.pageSize,$scope.query.queryStr,$scope.selectValue)
        .then(function(res){
          if(res.code == 0){
            var result = JSON.parse(res.result);
            $scope.params.hasmore = true ;
            //未搜索到相关信息
            if(result.flag=="false") {
              $scope.params.hasmore = false ;
            }
            var response =JSON.parse(result.result);
            var docs = response.response.docs;
            if(response.response.numFound<$scope.params.pageSize){
              $scope.params.hasmore = false ;
            }
            $scope.params.isSearch = true ;
            //搜索到相关信息
            $scope.queryResults = $scope.changeImgUrl(docs) ;
            $scope.params.from += $scope.params.pageSize ;
          }else{
            $scope.params.hasmore = false ;
          }
        },function(reason){
          $scope.params.hasmore = false ;
        })
    }

    $scope.loadMore = function(){
      HomeService.search($scope.params.from,$scope.params.pageSize,$scope.query.queryStr)
        .then(function(res){
          if(res.code == 0){
            var result = JSON.parse(res.result);
            //未搜索到相关信息
            if(result.flag=="false") {
              $scope.params.hasmore = false ;
            }
            var response =JSON.parse(result.result);
            var docs = response.response.docs;
            if(response.response.numFound=="0"){
              $scope.params.hasmore = false ;
            }
            if(docs.length < $scope.params.pageSize){
              $scope.params.hasmore = false ;
            }
            //搜索到相关信息
            $scope.queryResults = $scope.queryResults.concat($scope.changeImgUrl(docs)) ;
            $scope.params.from += $scope.params.pageSize ;
          }else{
            $scope.params.hasmore = false ;
          }
        },function(reason){
          $scope.params.hasmore = false ;
        })
        .finally(function(){
          $scope.$broadcast('scroll.infiniteScrollComplete');
        })
    }
  })
