/**
 * Created by sks on 2016/11/30.
 */
angular.module('homepage-controller',[])
  .controller('HomepageCtrl',function($scope,UserService,$rootScope,$state,HomePageService,$ionicModal,$sce,$ionicGesture,$ionicSlideBoxDelegate,$timeout,$interval,$ionicScrollDelegate,communityService){
    $scope.advertisementSize = 5 ;
    $scope.doctorSize = 5 ;
    $scope.infos = [] ;
    $scope.initData = {
      "contentType":1,
      "contentUrl":"http://www.yinglink.com/"
    }
    $scope.advertisements = [] ;
    $scope.options = {
      loop: true,
      effect: 'Slide',
      initialSlide:1,
      speed: 500,
      //autoplay:2000,
      observer: true,
      //autoplayDisableOnInteraction:false,
    }
    $scope.isRefresh = false ;
    $scope.doctors = [] ;
    $scope.data = {} ;
    $scope.slideTimer ;
    $scope.watchTimer ;
    $scope.$on('$ionicView.enter', function() {
      //$scope.data.slider.update();
      //$scope.data.slider.startAutoplay();
      if(angular.element("#homepageSlide .img")[1].style.visibility != "hidden"){
        if($scope.data.slider.activeIndex > $scope.advertisementSize || $scope.data.slider.activeIndex > $scope.advertisements.length){
          $scope.data.slider.slideTo(1) ;
        }else{
          $scope.data.slider.slideTo($scope.data.slider.activeIndex+1) ;
        }
      }
      $interval.cancel($scope.slideTimer) ;
      $scope.slideTimer = $interval(function(){
          if($scope.advertisements.length > 1){
            $scope.data.slider.slideNext() ;
          }else{
            $interval.cancel($scope.slideTimer) ;
            $scope.data.slider.stopAutoplay();
          }
        },2000);
    }, false);

    $scope.module = "homepage" ;
    $scope.params = {
      hasmore : true ,
      current : 1 ,
      pageSize : 10,
    }

    //如果用户ID为0，查询游客登录的权限
    if($rootScope.user.id <= 0 || $rootScope.user.id == undefined){
      UserService.getConfByType('guest')
        .then(function(result){
          if(result.code == 0){
            $rootScope.guest_conf_urls= result.result
          }
        })
    }

    UserService.getAllPicUser()
      .then(function(result){
        if (result.code == 0){
          $rootScope.picUserlist = result.result;
        }
      })

    //获取广告信息
    $scope.getAdvertisements = function(){
      HomePageService.getContents($scope.advertisementSize)
        .then(function(result){
          if(result.code == 0){
            $scope.advertisements = result.result ;
            if($scope.advertisements.length > 0 && !$scope.isRefresh){
              $scope.watchTimer = $timeout(function(){
                $scope.$watch("data.slider.activeIndex",function(newValue,oldValue){
                  if(newValue != undefined){
                    if(newValue > $scope.advertisements.length){
                      $scope.adjustHomePageHeight(0) ;
                    }else{
                      $scope.adjustHomePageHeight(newValue) ;
                    }
                  }
                })
              },100) ;
            }
          }
        },function(reason){

        })
    }
    //获取医生信息
    $scope.getDoctors = function(){
      HomePageService.getDoctors($scope.doctorSize)
        .then(function(result){
          if(result.code == 0){
            $scope.doctors = result.result ;
          }
        },function(reason){

        })
    }
    //获取新闻信息
    $scope.getInfos = function(){
      HomePageService.getInfos($scope.params.current,$scope.params.pageSize)
        .then(function(result){
          $scope.params.hasmore = true ;
          if(result.code == 0 && !!result.result.objects){
            $scope.infos = $scope.infos.concat(result.result.objects) ;
            //当前页等于总页数时，禁止加载更多
            if($scope.params.pageSize > result.result.objects.length){
              $scope.params.hasmore = false ;
            }else {
              $scope.params.current++;
            }
          }else{
            $scope.params.hasmore = false ;
          }
        },function(reason){
          $scope.params.hasmore = false ;
        }).finally(function () {
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast("scroll.infiniteScrollComplete");
        });
    }

    $scope.doInfos = function(){
      HomePageService.getInfos($scope.params.current,$scope.params.pageSize)
        .then(function(result){
          $scope.params.hasmore = true ;
          if(result.code == 0 && !!result.result.objects){
            $scope.infos = result.result.objects ;
            //当前页等于总页数时，禁止加载更多
            if($scope.params.pageSize > result.result.objects.length){
              $scope.params.hasmore = false ;
            }else {
              $scope.params.current++;
            }
          }else{
            $scope.params.hasmore = false ;
          }
        },function(reason){
          $scope.params.hasmore = false ;
        }).finally(function () {
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast("scroll.infiniteScrollComplete");
        });
    }
    $scope.adjustHomePageHeight = function(index){
        adjustHomePageHeight(angular.element("#homepageSlide .img")[index], false);
    }
    $scope.getAdvertisements() ;
    $scope.getDoctors() ;
    $scope.goDetail = function(item,type){
      $state.go("menu.homepage-detail",{'id': item.id,'content':item,'type':type}) ;
    }
    $scope.goChallenge = function(){
      if($rootScope.user.id <= 0){
        $rootScope.$broadcast('goLogin:show');
      }else{
        $state.go("menu.personalChallenge") ;
      }
    }

    $scope.doRefresh = function(){
      $scope.isRefresh = true ;
      $ionicScrollDelegate.$getByHandle('homepageContent').resize();
      $scope.getAdvertisements() ;
      $scope.getDoctors() ;
      $scope.params = {
        hasmore : false ,
        current : 1 ,
        pageSize : 10,
      }
      $scope.doInfos() ;
    }


    $scope.repeatFinsh = function(){
      var count = screen.width/262 ;
      var mySwiper = new Swiper('.swiper-Doctor-container', {
        slidesPerView : count,
        spaceBetween : 12,
        slidesOffsetAfter : 12,
        observer:true,
        observeParents:true,
      })
    }

    $scope.$on('$ionicView.leave', function() {
      $rootScope.isVisible = false ;
      $interval.cancel($scope.slideTimer) ;
      $interval.cancel($scope.watchTimer) ;
    }, false);
    $scope.goInfo =function(item,type){

      if($rootScope.user.id > 0 && item.type > 0){
        HomePageService.addReadRecord(type,item.id,$rootScope.user.id)
          .then(function(result){
              if(result.code == 0){
                item.readNum += 1;
              }
          },function(reason){
          }) ;
      }
      switch (item.type){
        case 0:
              $scope.goDetail(item,type) ;
              break ;
        case 1:
              $state.go("menu.case-detail",{'caseId': item.contentDataId}) ;
              break ;
        case 2:
              $state.go("menu.community-detail",{'communityId': item.contentDataId}) ;
              break ;
        case 3:
              $state.go("menu.ppt-detail",{'pptId': item.contentDataId}) ;
              break ;
        case 4:
              $state.go("menu.learn-detail",{'learnId': item.contentDataId}) ;
              break ;
        case 5:
              $state.go("menu.classroom-detail",{'classId': item.contentDataId}) ;
              break ;
      }
    }
    //更新社交数据
    $rootScope.$on('socialOper', function(e,id,module,operType,operation) {
      if(module == $scope.module){
        for(var i in $scope.infos){
          if($scope.infos[i].id == id){
            if(operation){
              $scope.infos[i].readNum ++;
            }else{
              $scope.cases[i].readNum --;
            }
          }
        }
      }
    });

    //跳转至经典病例
    $scope.goCase = function(item,learnType){
      $scope.$emit("switch", item,learnType);
      communityService.setViewType(item) ;
      communityService.setLearnType(learnType) ;
      $state.go("menu.tab.community") ;
    }
  });
