/**
 * Created by sks on 2016/12/12.
 */
angular.module('speciaDetail-controller',[])
  .controller('SpeciaDetailCtrl',function($scope,UserService,$rootScope,$state,HomePageService,$ionicModal,$sce,$ionicGesture,$ionicSlideBoxDelegate,$stateParams,friendService,$ionicPopup,$timeout,$ionicScrollDelegate){
    var speciaDetailSlideBox = $ionicSlideBoxDelegate.$getByHandle('speciaDetailSlideBox');
    $scope.speciaDetail = $stateParams.data ;
    $scope.caseList = [] ;
    $scope.id = $stateParams.id ;
    $scope.doctorSize = 2 ;
    $scope.params = {
      page:1,
      pageSize:10,
      hasmore:true,
    }
    $scope.tabActive = 0 ;
    $scope.tableIsActive = 2 ;
    $scope.diagnoseIsActive = 2 ;
    $scope.canvasIsActive = 2 ;
    $scope.isHideSpeciality = true ;
    $scope.isHideAbstract = true ;
    $scope.userAnalyze = "" ;
    $scope.userDiagnosis = [] ;
    $scope.systemTotalAnswer = [] ;
    $scope.EquipmentToalAnswer = [] ;
    $scope.option = {
      title: {
        text: ''
      },
      tooltip: {
        confine:true,
        formatter: function(params) {
          var res = params.name;
          var datas = $scope.option.series[0].data[params.dataIndex].value;
          var names = $scope.option.radar.indicator ;
          for (var i = 0; i < datas.length; i++) {
            if(params.dataIndex == 0){
              if($scope.canvasIsActive == 1){
                res = res + '<br/>'+names[i].name+":"+datas[i]+"%"+'('+($scope.EquipmentToalAnswer[i] === null?0:$scope.EquipmentToalAnswer[i])+')';
              }else if($scope.canvasIsActive == 2){
                res = res + '<br/>'+names[i].name+":"+datas[i]+"%"+'('+($scope.systemTotalAnswer[i] === null?0:$scope.systemTotalAnswer[i])+')';
              }
            }else if(params.dataIndex == 1){
              res = res + '<br/>' +names[i].name+":"+ datas[i] ;
            }
          }
          return res;
        }
      },
      legend: {
        left:"10",
        top:"10",
        data: [{name:'正确率(数量)',icon:"roundRect"},{name:'能力值',icon:"roundRect"}]
      },
      radar: {
        indicator: [],
        name:{
          textStyle:{
            color:'#48b7c4',
          }
        },
        nameGap:2,
        center: ['50%', '50%'],
        radius:'70%',
      },
      series: [{
        name: '预算 vs 开销（Budget vs spending）',
        type: 'radar',
        data : [
          {
            value : [],
            name : '正确率(数量)',
            itemStyle: {
              normal: {
                color: '#55c3cf',
              },
            }
          },
          {
            value : [],
            name : '能力值',
            itemStyle: {
              normal: {
                color: '#cf5555',
              },
            }
          }
        ]
      }]
    };

    $scope.getSpeciaDetail = function(){
      HomePageService.getSpeciaDetail($scope.id)
        .then(function(result){
          if(result.code == 0){
            $scope.speciaDetail = result.result ;
            $scope.speciaDetail.isFriend = $stateParams.data.isFriend;
            if($scope.speciaDetail.isFriend == undefined){
              if($rootScope.user.id > 0){
                friendService.isFriend($rootScope.user.id, $scope.speciaDetail.id)
                  .then(function(result){
                    if(result.code == 0 && result.result){
                      $scope.speciaDetail.isFriend = true ;
                    }
                  },function(reason){

                  })
              }
            }
          }
        },function(reason){

        })
    }

    $scope.loadMore = function(){
      HomePageService.getPersonalCases($scope.id,$scope.params.page,$scope.params.pageSize)
        .then(function(result){
          if(result.code == 0){
            $scope.caseList = $scope.caseList.concat(result.result) ;
            //当前页等于总页数时，禁止加载更多
            if($scope.params.pageSize > result.result.length){
              $scope.params.hasmore = false ;
            }else{
              $scope.params.page ++;
            }
          }else{
            $scope.params.hasmore = false ;
          }
        },function(reason){
          $scope.params.hasmore = false ;
        })
        .finally(function () {
          $scope.$broadcast("scroll.infiniteScrollComplete");
        });
    }

    //获取医生信息
    $scope.getDoctors = function(){
      HomePageService.getDoctors($scope.doctorSize)
        .then(function(result){
          if(result.code == 0){
            $scope.doctors = result.result ;
            for(var i = 0 ; i < $scope.doctors.length ; i ++){
              friendService.isFriend($rootScope.user.id, $scope.doctors[i].id)
                .then(function(result){
                  if(result.code == 0 && result.result){
                    $scope.doctors[i].isFriend = true ;
                  }
                },function(reason){

                })
            }
          }
        },function(reason){

        })
    }

    $scope.addFriend = function(friednId,$event){
      if($rootScope.user.id <= 0){
        $rootScope.$broadcast('login:show');
        $event.stopPropagation();
        return ;
      }
      friendService.addFriend($rootScope.user.id, friednId, 0)
        .then(function(result){
          var myPopup = $ionicPopup.show({
            title: '添加好友申请已经发送。'
          });
          $timeout(function() {
            myPopup.close();
          }, 3000);
        })
      $event.stopPropagation();
    }

    $scope.sendMessage = function(user){
      $rootScope.currentConversationInit();
      $state.go('menu.messageDetail', {targetId: user.id, conversationType: 'PRIVATE', conversationTitle:user.nickName});
    }

    $scope.getSpeciaDetail() ;
    $scope.getDoctors() ;

    $scope.$on( "$ionicView.afterEnter", function(){
      if ($rootScope.currentConversation.conversationType == 'PRIVATE'){
        $rootScope.currentConversationInit();
      }
      $scope.myChart = echarts.init(document.getElementById('speciaDataMain'+$scope.id));
      $scope.myChart.showLoading();
      UserService.getAnalyzeDataByUserId($scope.id)
        .then(function(result){
          if(result.code == 0){
            $scope.userAnalyze = result.result.userAnalyze ;
            $scope.userAnalyzeDetails = result.result.userAnalyzeDetails ;
            $scope.userDiagnosis = result.result.userDiagnosis ;
            $scope.correctPercentageStyle = {width:$scope.userAnalyze.correctPercentage+"%"} ;
            $scope.abilityValueStyle = {width:$scope.userAnalyze.abilityValue+"%"} ;
            $scope.winPercentageStyle = {width:$scope.userAnalyze.winPercentage+"%"} ;
            $scope.toCanvasTitle($scope.canvasIsActive) ;
          }
        },function(reason){

        })
        .finally(function(){
            $scope.myChart.hideLoading();
        })
      $timeout(function(){
        speciaDetailSlideBox.next() ;
        $timeout(function(){
          speciaDetailSlideBox.previous() ;
        },2000);
      },2000) ;
    })

    var speciaDetailScroll = $ionicScrollDelegate.$getByHandle('speciaDetailScroll');
    $scope.switchTab = function(index){
      if($scope.tabActive != index){
        $scope.tabActive = index ;
      }
      speciaDetailScroll.resize();
    }

    $scope.toTableTitle = function(index){
      $scope.tableIsActive = index ;
    }

    $scope.toDiagnoseTitle = function(index){
      $scope.diagnoseIsActive = index ;
    }

    $scope.toCanvasTitle = function(index){
      $scope.canvasIsActive = index ;
      $scope.option.radar.indicator = [] ;
      $scope.option.series[0].data[0].value = [] ;
      $scope.option.series[0].data[1].value = [] ;
      $scope.EquipmentToalAnswer = [] ;
      $scope.systemTotalAnswer = [] ;
      for(var i = 0 ; i < $scope.userAnalyzeDetails.length ; i ++){
        if($scope.userAnalyzeDetails[i].type == $scope.canvasIsActive){
          var item = {name: $scope.userAnalyzeDetails[i].name,max : 100} ;
          $scope.option.radar.indicator.push(item) ;
          $scope.option.series[0].data[0].value.push($scope.userAnalyzeDetails[i].correctPercentage == null?0:$scope.userAnalyzeDetails[i].correctPercentage) ;
          $scope.option.series[0].data[1].value.push($scope.userAnalyzeDetails[i].abilityValue == null?0:$scope.userAnalyzeDetails[i].abilityValue) ;
        }
        if($scope.userAnalyzeDetails[i].type == 1){
          $scope.EquipmentToalAnswer.push($scope.userAnalyzeDetails[i].totalAnswer) ;
        }else if($scope.userAnalyzeDetails[i].type == 2){
          $scope.systemTotalAnswer.push($scope.userAnalyzeDetails[i].totalAnswer) ;
        }
      }
      $scope.myChart.setOption($scope.option);
      $scope.myChart.hideLoading();
    }
  })
