angular.module('learn-controller',[])
  .controller('LearnCtrl',['$scope','$state','learnService','$rootScope','showAlertService','communityService',function($scope,$state,learnService,$rootScope,showAlertService,communityService){
    $scope.learnType = communityService.getLearnType();
    //配置菜单数据
    $scope.imageSrc = "";
    showAlertService.loadingShow();
    $scope.getListData = function () {
      learnService.getListStyleData()
        .then(function(result){
          //console.log(JSON.stringify(result));
          $scope.videoLabels = result.result.videoLabels;
          $scope.pptLabels = result.result.pptLabels;
          $scope.activeLabelIds = $scope.videoLabels ;
          //$scope.$apply();
        })
        .finally(function() {
          $scope.$broadcast('scroll.refreshComplete');
        });
    }
    $scope.getListData();
    //$scope.oneStyle = "study-allpic-size"
    $scope.params = {
      hasmore : true ,
      current : 1 ,
      pageSize : 10,
    }
    $scope.module = "classRoom" ;
    $scope.labelId = "" ;
    $scope.videoType = "3" ;
    $scope.videoParams = {
      labelId:"" ,
      selectFlag:[],
    } ;
    $scope.pptParams = {
      labelId:"" ,
      selectFlag:[],
    } ;
    $scope.learnList = [];
    $scope.isActive = [true,false,false]

    $scope.getLearnList = function(labelId){
      $state.go("menu.tab.learn-list",{'labelId': labelId});
    }
    $scope.getPPtList = function(labelId){
      $state.go("menu.ppt-list",{'labelId': labelId});
    }

    $scope.img_learnPicUrl = img.learnPicUrl ;

    $scope.changeImgUrl = function(list){
      for(var i in list){
        if(!list[i].dataLearnPic){
          list[i].dataLearnPic = "img/study/no_learn.png";
        }else{
          if(list[i].dataLearnPic.substr(0,7)!="http://" && list[i].dataLearnPic.substr(0,8)!="https://"){
            list[i].dataLearnPic = $scope.img_learnPicUrl + list[i].dataLearnPic;
          }
        }
      }
      return list;
    }

    //更新社交数据
    $rootScope.$on('socialOper', function(e,id,module,operType,operation) {
      if(module == $scope.module){
        for(var i in $scope.learnList){
          if($scope.learnList[i].dataLearnId == id){
            if(operation){
              $scope.learnList[i][operType] ++;
            }
          }
        }
      }
    });

    $scope.doRefresh = function() {
      //$scope.getListData();
      $scope.hiden = true ;
      learnService.findAll("",$scope.videoType,1, $scope.params.pageSize)
        .then(function(result) {
          if(result.code == 0 && result.result.objects) {
            $scope.hiden = false ;
            $scope.learnList = $scope.changeImgUrl(result.result.objects);
            $scope.params = {
              hasmore : true ,
              current : 1 ,
              pageSize : 10,
            }
            for(var i in $scope.learnList){
              $scope.learnList[i].videoSize = Math.ceil(bytesToSize($scope.learnList[i].initialSize));
              $scope.learnList[i].videoLength = formatTime($scope.learnList[i].videoDuration);
            }
            //当前页等于总页数时，禁止加载更多
            if($scope.params.pageSize > result.result.objects.length){
              $scope.params.hasmore = false ;
            }else{
              $scope.params.current ++ ;
            }
          }else{
            $scope.params.hasmore = false ;
          }
        })
        .finally(function() {
          showAlertService.loadingHide();
          $scope.$broadcast('scroll.refreshComplete');
        });
    };
    //$scope.doRefresh() ;

    $scope.loadMore = function(){
      learnService.findAll("",$scope.videoType,$scope.params.current, $scope.params.pageSize)
        .then(function(result) {
          if(result.code == 0 && result.result.objects) {
            $scope.learnList = $scope.learnList.concat($scope.changeImgUrl(result.result.objects));
            for(var i in $scope.learnList){
              $scope.learnList[i].videoSize = Math.ceil(bytesToSize($scope.learnList[i].initialSize));
              $scope.learnList[i].videoLength = formatTime($scope.learnList[i].videoDuration);
            }
            //当前页等于总页数时，禁止加载更多
            if($scope.params.pageSize > result.result.objects.length){
              $scope.params.hasmore = false ;
            }else{
              $scope.params.current ++ ;
            }
          }else{
            $scope.params.hasmore = false ;
          }

        })
        .finally(function() {
          showAlertService.loadingHide();
          $scope.$broadcast("scroll.infiniteScrollComplete");
        });
    };

    $scope.switchFilter = function(flag){
      if($scope.isActive.indexOf(true) == 2){
        $scope.filterFlag = false ;
        return ;
      }
      if(flag){
        //隐藏
        if($scope.isActive.indexOf(true) == 0){
          $scope.videoParams.labelId = $scope.labelId ;
          $scope.videoParams.selectFlag = $scope.selectFlag ;
          $scope.$broadcast('refreshVideo');
        }
        if($scope.isActive.indexOf(true) == 1){
          $scope.pptParams.labelId = $scope.labelId ;
          $scope.pptParams.selectFlag = $scope.selectFlag ;
          $scope.$broadcast('refreshPpt');
        }
        $scope.filterFlag = false ;
      }else{
        //显示
        if($scope.isActive.indexOf(true) == 0){
          if($scope.videoParams.labelId == ""){
            $scope.selectLabel(0,0) ;
          }else{
            $scope.labelId = $scope.videoParams.labelId ;
            $scope.selectFlag = $scope.videoParams.selectFlag ;
          }
        }
        if($scope.isActive.indexOf(true) == 1){
          if($scope.pptParams.labelId == ""){
            $scope.selectLabel(0,0) ;
          }else{
            $scope.labelId = $scope.pptParams.labelId ;
            $scope.selectFlag = $scope.pptParams.selectFlag ;
          }
        }
        $scope.filterFlag = true ;
      }
    }

    $rootScope.$on('switchType', function(e,item,learnType) {
      $scope.switch(learnType) ;
    });

    $scope.switch = function(index){
      angular.forEach($scope.isActive,function(data,i,array){
        if(i == index){
          array[i] = true ;
        }else{
          array[i] = false ;
        }
      });
      if(index == 0){
        $scope.activeLabelIds = $scope.videoLabels ;
        $scope.labelId = $scope.videoParams.labelId ;
        $scope.selectFlag = $scope.videoParams.selectFlag ;
        if($scope.filterFlag){
          $scope.switchFilter(false) ;
        }
      }else if(index == 1){
        $scope.activeLabelIds = $scope.pptLabels ;
        $scope.labelId = $scope.pptParams.labelId ;
        $scope.selectFlag = $scope.pptParams.selectFlag ;
        if($scope.filterFlag){
          $scope.switchFilter(false) ;
        }
      }else{
        $scope.switchFilter(true) ;
      }
    }

    $scope.switch($scope.learnType) ;

    $scope.selectLabel = function(outIndex,inwardIndex){
      //$scope.selectFlag[outIndex][inwardIndex] = $scope.selectFlag[outIndex][inwardIndex]?true:false ;
      var selectLabels = [] ;
      if($scope.labelId != ""){
        selectLabels = $scope.labelId.split(",") ;
      }
      //如果选择的选项存在即
      if((selectLabels.indexOf($scope.activeLabelIds[outIndex][inwardIndex].id.toString())) == -1){
        //如果选择不是全部，将全部置空
        if($scope.activeLabelIds[outIndex][inwardIndex].id != $scope.activeLabelIds[0][0].id){
          if(selectLabels.indexOf($scope.activeLabelIds[0][0].id.toString()) != -1){
            selectLabels.splice(selectLabels.indexOf($scope.activeLabelIds[0][0].id.toString()),1) ;
          }
          selectLabels.push($scope.activeLabelIds[outIndex][inwardIndex].id.toString()) ;
        }else{
          $scope.labelId = $scope.activeLabelIds[0][0].id.toString() ;
          selectLabels = $scope.labelId.split(",") ;
        }
      }else{
        if($scope.activeLabelIds[outIndex][inwardIndex].id != $scope.activeLabelIds[0][0].id){
          selectLabels.splice(selectLabels.indexOf($scope.activeLabelIds[outIndex][inwardIndex].id.toString()),1) ;
        }
      }
      $scope.labelId = "" ;
      for(var x in selectLabels){
        $scope.labelId += selectLabels[x]+",";
      }
      $scope.labelId = $scope.labelId.substring(0,$scope.labelId.length-1) ;
      if(selectLabels.length <= 0){
        $scope.labelId = $scope.activeLabelIds[0][0].id.toString() ;
        selectLabels = $scope.labelId.split(",") ;
      }
      $scope.selectFlag = [] ;
      for(var x = 0 ; x < $scope.activeLabelIds.length ; x ++){
        var flag = [] ;
        for(var y = 0 ; y < $scope.activeLabelIds[x].length ; y ++){
          if(selectLabels.indexOf($scope.activeLabelIds[x][y].id.toString()) == -1 ){
            flag.push(false) ;
          }else{
            flag.push(true) ;
          }
        }
        $scope.selectFlag.push(flag) ;
      }
    }

    //报名截止时间与系统时间对比
    $scope.comparetime = function(liveTime){
      var systemTimes = new Date().getTime() ;
      var endTimes = Date.parse(liveTime) ;
      if(systemTimes>endTimes){
        return false ;
      }else{
        return true ;
      }
    }

    $scope.goDetail = function(item){
      //if($scope.comparetime(item.liveTime)){
        $state.go('menu.classroom-detail',{classId:item.dataLearnId}) ;
      //}else{
      //  alert("课堂已开始，不能进入") ;
      //} ;
    }

    $scope.$on( "$ionicView.enter", function(){
      $rootScope.currentConversationInit();
    })
}]);

