angular.module('learnList-controller',[])
  .controller('LearnListCtrl',function($scope,$state,$stateParams,learnService,$rootScope){
    $scope.params = {
      hasmore : true ,
      current : 1 ,
      pageSize : 10,
    }
    $scope.module = "video" ;
    $scope.videoType = "1"
    $scope.learnList = [];

    $scope.img_learnPicUrl = img.learnPicUrl ;

    $scope.changeImgUrl = function(list){
      for(var i in list){
        if(!list[i].dataLearnPic){
          list[i].dataLearnPic = "img/study/no_learn.png";
        }else{
          if(list[i].dataLearnPic.substr(0,7)!="http://" && list[i].dataLearnPic.substr(0,8)!="https://"){
            list[i].dataLearnPic = $scope.img_learnPicUrl + list[i].dataLearnPic;
          }
        }
      }
      return list;
    }

    //更新社交数据
    $rootScope.$on('socialOper', function(e,id,module,operType,operation) {
      if(module == $scope.module){
        for(var i in $scope.learnList){
          if($scope.learnList[i].dataLearnId == id){
            if(operation){
              $scope.learnList[i][operType] ++;
            }
          }
        }
      }
    });
    $scope.$on('refreshVideo', function(e) {
      $scope.doRefresh() ;
    });

    $scope.doRefresh = function() {
      $scope.hiden = true ;
      learnService.findAll($scope.videoParams.labelId,$scope.videoType,1, $scope.params.pageSize)
        .then(function(result) {
          // if(result.code == 0 && result.result.objects){
          if(result.code == 0){
            $scope.hiden = false ;
            $scope.learnList = $scope.changeImgUrl(result.result.objects);
            $scope.params = {
              hasmore : true ,
              current : 1 ,
              pageSize : 10,
            }
            for(var i in $scope.learnList){
              $scope.learnList[i].videoSize = Math.ceil(bytesToSize($scope.learnList[i].initialSize));
              $scope.learnList[i].videoLength = formatTime($scope.learnList[i].videoDuration);
            }

            //当前页等于总页数时，禁止加载更多
            if(result.result.objects){
            if($scope.params.current > result.result.objects.length){
              $scope.params.hasmore = false ;
            }else{
              $scope.params.current ++ ;
            }
            }else{
              $scope.params.hasmore = false ;
            }
          }
        })
        .finally(function () {
          $scope.$broadcast('scroll.refreshComplete');
        });
    };

    $scope.loadMore = function(){
      learnService.findAll($scope.videoParams.labelId,$scope.videoType,$scope.params.current, $scope.params.pageSize)
        .then(function(result) {
          // if(result.code == 0 && result.result.objects) {
          if(result.code == 0 && result.result.objects) {
              $scope.learnList = $scope.learnList.concat($scope.changeImgUrl(result.result.objects));
              for (var i in $scope.learnList) {
                $scope.learnList[i].videoSize = Math.ceil(bytesToSize($scope.learnList[i].initialSize));
                $scope.learnList[i].videoLength = formatTime($scope.learnList[i].videoDuration);
              }
              //当前页等于总页数时，禁止加载更多
              if($scope.params.pageSize > result.result.objects.length){
                $scope.params.hasmore = false ;
              }else{
                $scope.params.current ++ ;
              }
          }else{
            $scope.params.hasmore = false ;
          }
        })
        .finally(function () {
          $scope.$broadcast("scroll.infiniteScrollComplete");
        });

    };
});

