/**
 * Created by douhao on 2016/5/4.
 */
angular.module('personalCase-controller',[])
  .controller('personalCaseCtrl',function($scope,$rootScope,$state,$ionicHistory,UserService,showAlertService){
    $scope.params = {
      hasmore : true ,
      from : 1 ,
      pageSize : 10,
    }
    $scope.img_url = img.url ;
    $scope.cases = [] ;

    //更改图片路径
    $scope.changeImgUrl = function(list){
      var img_path = "" ;
      for(var i in list){
        if(!list[i].thumbnail){
          list[i].thumbnail = "img/study/no_learn.png";
        }else{
          if(list[i].thumbnail.substr(0,7)!="http://" && list[i].thumbnail.substr(0,8)!="https://"){
            list[i].thumbnail = $scope.img_url +"/" +list[i].id +img_path +"/"+list[i].thumbnail ;
          }else{
            list[i].thumbnail = list[i].thumbnail ;
          }
        }
      }
      return list;
    }


    $scope.delete = function(item){
      showAlertService.PopConfirm("提示信息","是否删除该病历？","取消","确认")
        .then(function(res) {
          if (res) {
            UserService.deleteMyForum(item.id)
              .then(function(result){
                $scope.cases.splice($scope.cases.indexOf(item), 1);
                $scope.$emit("deleteCase",item) ;
              })
          } else {
          }
        })
    }

    $scope.modify = function(item){
      $state.go("menu.reupload",{'caseId': item.id}) ;
    }

    $scope.doRefresh = function() {
      UserService.getMyForumList($rootScope.user.id,1,$scope.params.pageSize)
        .then(function(result) {
          $scope.params = {
            hasmore : true ,
            from : 1 ,
            pageSize : 10,
          }
          $scope.cases = $scope.changeImgUrl(result.result);
          //当前数量小于查询数量，禁止加载更多
          if (result.result.length < $scope.params.pageSize) {
            $scope.params.hasmore = false;
          }else{
            $scope.params.from += parseInt($scope.params.pageSize);
          }
          $scope.$broadcast('scroll.refreshComplete');
        },function(error){
          $scope.params.hasmore = false;
          $scope.$broadcast('scroll.refreshComplete');
        })
    };

    $scope.loadMore = function() {
      UserService.getMyForumList($rootScope.user.id, $scope.params.from,$scope.params.pageSize)
        .then(function (result) {
          $scope.cases = $scope.cases.concat($scope.changeImgUrl(result.result));
          //当前数量小于查询数量，禁止加载更多
          if (result.result.length < $scope.params.pageSize) {
            $scope.params.hasmore = false;
          }
          $scope.params.from += $scope.params.pageSize;
          $scope.$broadcast('scroll.infiniteScrollComplete');
        },function(error){
          $scope.params.hasmore = false;
          $scope.$broadcast('scroll.infiniteScrollComplete');
        })
    }

    //监控UserId变化，读取个人信息
    $scope.$watch('user.userId',function(newValue,oldValue){
      if(newValue > 0){
        //console.log("刷新个人信息")
        $scope.doRefresh() ;
      }
    })

  });
