angular.module('personalCenterUpdateImage-controller',[])
  .controller('personalCenterUpdateImageCtrl',function($ionicGesture,$scope,$rootScope,$state,$stateParams,UserService,ossService,$ionicLoading,showAlertService,$timeout){

    $scope.markStyle = {};
    $scope.dragStyle = {};
    $scope.init = function(){
      var screenHeight = window.innerHeight;
      var screenWidth = window.innerWidth;

      $scope.dragStyle = {height:screenWidth};
      if(ionic.Platform.isIOS()){
        $scope.markStyle = {height:(screenHeight-screenWidth-60)/2};
      }else{
        $scope.markStyle = {height:(screenHeight-screenWidth-40)/2};
      }
    }
    $scope.init();

    $scope.isSubmiting = false;
    $scope.personalImage = (!!$rootScope.user.personalImage && ($rootScope.user.personalImage != img.personalImage)) ? $rootScope.user.personalImage : img.personalNetImage;

    $scope.uploadImage = function(){
      if ($scope.isSubmiting){
        return;
      }
      $scope.isSubmiting = true;

      var reg = /\-?[0-9]+\.?[0-9]*/g;
      var translate = angular.element(".update-image").css("webkitTransform");
      var array = translate.match(reg) ;
      if (!!array){
        var ratio = array[0];
        var screenWidth = window.innerWidth;
        var imgHeight = parseFloat(angular.element(".update-image").css("height").replace('px',''));
        var imgWidth = parseFloat(angular.element(".update-image").css("width").replace('px',''));
        //var x = - (window.innerWidth / 2) - parseFloat(array[4])*ratio;
        //var y = - (window.innerWidth / 2) - parseFloat(array[5])*ratio;

        var x = -(screenWidth/2) + (imgWidth/2)*ratio - imgWidth/2 - array[4];
        var y = -(screenWidth/2) + (imgHeight/2)*ratio - imgHeight/2 - array[5];

        var pointX = x < 0 ? 0 :  x/ratio;
        var pointY = y < 0 ? 0 :  y/ratio;

        var imageWidth = (screenWidth + (x > 0 ? 0 : x))/ratio;
        var imageHeight = (screenWidth + (y > 0 ? 0 : y))/ratio;
      }

      UserService.resizePersonalImage($rootScope.user.id,$scope.personalImage,parseInt(imgHeight),parseInt(pointX),parseInt(pointY),parseInt(imageWidth),parseInt(imageHeight))
        .then(function(result){
          $scope.isSubmiting = false;
          if (!!result.result)
          $rootScope.user.personalImage = result.result;
          $rootScope.goToBack() ;
        },function(err){
          $scope.isSubmiting = false;
        })
    }

    $scope.uploadPersonImg = {
      accessid : '',
      accesskey : '',
      host : '',
      policyBase64 : '',
      signature : '',
      expire : 0,
      key : '',
      callbackbody : '',
      finalFileName : ''
    };

    $scope.uploadPersonImg.sendRequest = function() {
      var xmlhttp = null;
      if (window.XMLHttpRequest) {
        xmlhttp = new XMLHttpRequest();
      } else if (window.ActiveXObject) {
        xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
      }

      if (xmlhttp!=null) {
        var serverUrl = config.new_url+"/oss/signature?imgType=personalImg&userId="+$rootScope.user.id
        xmlhttp.open( "GET", serverUrl, false);
        xmlhttp.send(null);
        return xmlhttp.responseText
      }
    };

    $scope.uploadPersonImg.getOssSignature = function ()
    {
      var now = Date.parse(new Date()) / 1000;
      if ($scope.uploadPersonImg.expire < now + 3)
      {
        var response = $scope.uploadPersonImg.sendRequest();
        var result = eval ("(" + response + ")");
        $scope.uploadPersonImg.accessid = result.result.accessid;
        $scope.uploadPersonImg.host = result.result.host;
        $scope.uploadPersonImg.policyBase64 = result.result.policy;
        $scope.uploadPersonImg.signature = result.result.signature;
        $scope.uploadPersonImg.expire = parseInt(result.result.expire);
        $scope.uploadPersonImg.key = result.result.dir;
        $scope.uploadPersonImg.callbackbody = result['callback']
      }
    };

    $scope.uploadPersonImg.randomString = function(len) {
      len = len || 32;
      var chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678';
      var maxPos = chars.length;
      var pwd = '';
      for (var i = 0; i < len; i++) {
        pwd += chars.charAt(Math.floor(Math.random() * maxPos));
      }
      return pwd;
    }

    $scope.uploadPersonImg.getFileSuffix = function (filename) {
      var pos = filename.lastIndexOf('.')
      var suffix = ''
      if (pos != -1) {
        suffix = filename.substring(pos)
      }
      return suffix;
    }

    $scope.uploadPersonImg.calculateFileName = function (filename)
    {
      var suffix = $scope.uploadPersonImg.getFileSuffix(filename);
      $scope.uploadPersonImg.finalFileName = $scope.uploadPersonImg.key + $scope.uploadPersonImg.randomString(36) + suffix;
    }

    $scope.uploadPersonImg.setUploadParam = function(up, filename, ret)
    {
      if (!ret){
        $scope.uploadPersonImg.getOssSignature();
      }else{
        if (filename != '') {
          $scope.uploadPersonImg.calculateFileName(filename);
        }
      }

      var new_multipart_params = {
        'key' : $scope.uploadPersonImg.finalFileName,
        'policy': $scope.uploadPersonImg.policyBase64,
        'OSSAccessKeyId': $scope.uploadPersonImg.accessid,
        'success_action_status' : '200', //让服务端返回200,不然，默认会返回204
        'callback' :  $scope.uploadPersonImg.callbackbody,
        'signature':  $scope.uploadPersonImg.signature,
      };

      up.setOption({
        'url': $scope.uploadPersonImg.host,
        'multipart_params': new_multipart_params
      });

      up.start();
    }

    $scope.uploadPersonImg.uploader = new plupload.Uploader({
      runtimes : 'html5,flash,silverlight,html4',
      browse_button : 'updateImgButton',
      multi_selection: false,
      url : 'http://oss.aliyuncs.com',

      filters: {
        mime_types : [
          { title : "Image files", extensions : "jpg,gif,png,bmp,jpeg" },
        ],
        max_file_size : '10mb',//最大图片大小
        prevent_duplicates : false//不允许选择重复的图片
      },

      init: {
        upload:function(up){
          $scope.uploadPersonImg.setUploadParam(up, '', false);
        },

        FilesAdded: function(up, files) {
          $scope.isSubmiting = true;
          $scope.$apply();
          plupload.each(files, function(file) {
            $scope.uploadPersonImg.setUploadParam(up, file.name, false);
          });
        },

        BeforeUpload: function(up, file) {
          $scope.uploadPersonImg.setUploadParam(up, file.name, true);
        },

        FileUploaded: function(up, file, info) {
          if (info.status == 200) {
            $scope.personalImage =$scope.uploadPersonImg.host.replace('oss', 'img') + $scope.uploadPersonImg.finalFileName;
            angular.element(".update-image").css("-webkit-filter","none");
            angular.element(".update-image").css("webkitTransform", "translate(-50%,-50%)");
            up.files = [];
            $timeout(function(){
              $scope.isSubmiting = false ;
              $scope.$apply();
            }, 3000);
          } else {
            console.log(info.response)
          }
        },

        Error: function(up, err) {
          if (err.code == -600) {
            alert("文件大小超过10M");
          } else if (err.code == -601) {
            alert("只支持图片类型");
          } else if (err.code == -602) {
            alert("不能重复上传文件");
          } else {
            $scope.isSubmiting = false ;
          }
        }
      }
    });

    $scope.uploadPersonImg.uploader.init();


    /**** 大图手势事件开始 ****/
    var pinchDragEvent = null;
    var lastDragEvent = null;
    var intervalPinch = 0;
    var intervalDrag = 0;
    var intervalPx = 8;
    if (ionic.Platform.isIOS()){
      intervalPx = 15;
    }
    var startX1 =  0;
    var startY1 =  0;
    var startX2 =  0;
    var startY2 =  0;
    var startDist = 0;
    var startTouch1 = null;
    var startTouch2 = null;
    var endTouch1 = null;
    var endTouch2 = null;
    var viewPicDrag = angular.element('.update-image-drag-div');

    $ionicGesture.on("pinch",function(e){
      if (pinchDragEvent == null){
        pinchDragEvent = e;
        // 计算拖动开始时两指间距离
        startTouch1 = pinchDragEvent.gesture.touches[0];
        startTouch2 = pinchDragEvent.gesture.touches[1];
        startX1 =  startTouch1.pageX;
        startY1 =  startTouch1.pageY;
        startX2 =  startTouch2.pageX;
        startY2 =  startTouch2.pageY;
        startDist = Math.sqrt(Math.pow((startX2-startX1),2) + Math.pow((startY2-startY1),2));
        return;
      }

      intervalPinch++;
      if (intervalPinch % 3 != 0){
        return;
      }

      // 计算当前两指间距离
      endTouch1 = e.gesture.touches[0];
      endTouch2 = e.gesture.touches[1];
      var endX1 =  endTouch1.pageX;
      var endY1 =  endTouch1.pageY;
      var endX2 =  endTouch2.pageX;
      var endY2 =  endTouch2.pageY;
      var endDist = Math.sqrt(Math.pow((endX2-endX1),2) + Math.pow((endY2-endY1),2));
      if (Math.abs(endDist - startDist) > intervalPx){
        if (endDist > startDist){
          $scope.changeSize('big');
        }else{
          $scope.changeSize('small');
        }
      }else{
        $scope.changePosition(endX1-startX1, endY1-startY1);
      }

      pinchDragEvent = e;
      startTouch1 = pinchDragEvent.gesture.touches[0];
      startTouch2 = pinchDragEvent.gesture.touches[1];
      startX1 =  startTouch1.pageX;
      startY1 =  startTouch1.pageY;
      startX2 =  startTouch2.pageX;
      startY2 =  startTouch2.pageY;
      startDist = Math.sqrt(Math.pow((startX2-startX1),2) + Math.pow((startY2-startY1),2));
    }, viewPicDrag);
    $ionicGesture.on("release",function(){
      lastDragEvent = null;
      pinchDragEvent = null;
      startX1 =  0;
      startY1 =  0;
      startX2 =  0;
      startY2 =  0;
      startDist = 0;
      intervalDrag = 0;
      intervalPinch = 0;
    }, viewPicDrag);
    //拖拽
    $ionicGesture.on("drag",function(e){
      if (e.gesture.touches.length > 1){
        return;
      }

      intervalDrag++;
      if (intervalDrag%3 != 0){
        return;
      }

      var deltaX = e.gesture.deltaX;
      var deltaY = e.gesture.deltaY;
      if (!!lastDragEvent){
        deltaX = e.gesture.deltaX - lastDragEvent.gesture.deltaX;
        deltaY = e.gesture.deltaY - lastDragEvent.gesture.deltaY;
      }

      var absX = Math.abs(deltaX);
      var absY = Math.abs(deltaY);
      if (absX > 5 || absY > 5){
        lastDragEvent = e;
      }else{
        return;
      }

      $scope.changePosition(deltaX, deltaY);
    }, viewPicDrag);

    $scope.changePosition = function(x,y){
      var reg = /\-?[0-9]+\.?[0-9]*/g;
      var translate = angular.element(".update-image").css("webkitTransform");
      var array = translate.match(reg) ;
      if (!!array){
        array[4] = parseFloat(array[4]) + parseFloat(x);
        array[5] = parseFloat(array[5]) + parseFloat(y);
      }else{
        array = [1,0,0,1,x,y]
      }

      angular.element(".update-image").css("webkitTransform", "matrix("+array[0]+", "+array[1]+", "+array[2]+", "+array[3]+", "+array[4]+", "+array[5]+")");
    }

    $scope.changeSize = function(direction){
      var reg = /\-?[0-9]+\.?[0-9]*/g;
      var translate = angular.element(".update-image").css("webkitTransform");
      var array = translate.match(reg) ;

      var adjust = 0.04;
      if (ionic.Platform.isIOS()){
        adjust = 0.1;
      }

      switch (direction){
        case 'small':
          if (!!array){
            if (array[0] > 0.1){
              array[0] = parseFloat(array[0]) - adjust;
              array[3] = parseFloat(array[3]) - adjust;
            }
          }else{
            array = [1-adjust,0,0,1-adjust,0,0];

          }
          angular.element(".update-image").css('webkitTransform', "matrix("+array[0]+", "+array[1]+", "+array[2]+", "+array[3]+", "+array[4]+", "+array[5]+")");
          break;
        case 'big':
          if (!!array){
            array[0] = parseFloat(array[0]) + adjust;
            array[3] = parseFloat(array[3]) + adjust;
          }else{
            array = [1+adjust,0,0,1+adjust,0,0];
          }
          angular.element(".update-image").css('webkitTransform', "matrix("+array[0]+", "+array[1]+", "+array[2]+", "+array[3]+", "+array[4]+", "+array[5]+")");
          break;
      }
    }
    /**** 大图手势事件结束 ****/
  })
