/**
 * Created by douhao on 2017/1/13.
 */
angular.module('personalHomepage-controller',[])
  .controller('personalHomePageCtrl',function($scope,$rootScope,$state,UserService,$ionicSlideBoxDelegate,$timeout,$ionicScrollDelegate){
    var personalMenuSlideBox = $ionicSlideBoxDelegate.$getByHandle('personalMenuSlideBox');
    $scope.tabActive = 0 ;
    $scope.tableIsActive = 2 ;
    $scope.diagnoseIsActive = 2 ;
    $scope.canvasIsActive = 2 ;
    $scope.isHideSpeciality = true ;
    $scope.isHideAbstract = true ;
    $scope.userAnalyze = "" ;
    $scope.userDiagnosis = [] ;
    $scope.caseList = [] ;
    $scope.systemTotalAnswer = [] ;
    $scope.EquipmentToalAnswer = [] ;
    $scope.params = {
      hasmore : true ,
      current : 1 ,
      pageSize : 10,
    }

    $scope.loadMore = function(){
      UserService.getMyForumList($rootScope.user.id, $scope.params.current, $scope.params.pageSize)
        .then(function(result){
          if(result.code == 0 && result.result){
            $scope.caseList = $scope.caseList.concat(result.result);
            if($scope.params.pageSize > result.result.length){
              $scope.params.hasmore = false ;
            }else{
              $scope.params.current += $scope.params.pageSize;
            }
          }else{
            $scope.params.hasmore = false ;
          }
        },function(reason){
          $scope.params.hasmore = false ;
        })
        .finally(function () {
          $scope.$broadcast("scroll.infiniteScrollComplete");
        });
    }

    var personHomeScroll = $ionicScrollDelegate.$getByHandle('personHomeScroll');
    $scope.switchTab = function(index){
      if($scope.tabActive != index){
        $scope.tabActive = index ;
      }
      personHomeScroll.resize();
    }

    $scope.toTableTitle = function(index){
      $scope.tableIsActive = index ;
    }

    $scope.toDiagnoseTitle = function(index){
      $scope.diagnoseIsActive = index ;
    }

    $scope.toCanvasTitle = function(index){
      $scope.canvasIsActive = index ;
      $scope.myChart.showLoading();
      $scope.option.radar.indicator = [] ;
      $scope.option.series[0].data[0].value = [] ;
      $scope.option.series[0].data[1].value = [] ;
      $scope.EquipmentToalAnswer = [] ;
      $scope.systemTotalAnswer = [] ;
      for(var i = 0 ; i < $scope.userAnalyzeDetails.length ; i ++){
        if($scope.userAnalyzeDetails[i].type == $scope.canvasIsActive){
          var item = {name: $scope.userAnalyzeDetails[i].name,max : 100} ;
          $scope.option.radar.indicator.push(item) ;
          $scope.option.series[0].data[0].value.push($scope.userAnalyzeDetails[i].correctPercentage == null?0:$scope.userAnalyzeDetails[i].correctPercentage) ;
          $scope.option.series[0].data[1].value.push($scope.userAnalyzeDetails[i].abilityValue == null?0:$scope.userAnalyzeDetails[i].abilityValue) ;
        }
        if($scope.userAnalyzeDetails[i].type == 1){
          $scope.EquipmentToalAnswer.push($scope.userAnalyzeDetails[i].totalAnswer) ;
        }else if($scope.userAnalyzeDetails[i].type == 2){
          $scope.systemTotalAnswer.push($scope.userAnalyzeDetails[i].totalAnswer) ;
        }
      }
      $scope.myChart.setOption($scope.option);
      $scope.myChart.hideLoading();
    }

    $scope.option = {
      title: {
        text: ''
      },
      tooltip: {
        confine:true,
        formatter: function(params) {
          var res = params.name;
          var datas = $scope.option.series[0].data[params.dataIndex].value;
          var names = $scope.option.radar.indicator ;
          for (var i = 0; i < datas.length; i++) {
            if(params.dataIndex == 0){
              if($scope.canvasIsActive == 1){
                res = res + '<br/>'+names[i].name+":"+datas[i]+"%"+'('+($scope.EquipmentToalAnswer[i] === null?0:$scope.EquipmentToalAnswer[i])+')';
              }else if($scope.canvasIsActive == 2){
                res = res + '<br/>'+names[i].name+":"+datas[i]+"%"+'('+($scope.systemTotalAnswer[i] === null?0:$scope.systemTotalAnswer[i])+')';
              }
            }else if(params.dataIndex == 1){
              res = res + '<br/>' +names[i].name+":"+ datas[i] ;
            }
          }
          return res;
        }
      },
      legend: {
        left:"10",
        top:"10",
        data: [{name:'正确率(数量)',icon:"roundRect"},{name:'能力值',icon:"roundRect"}]
      },
      radar: {
        // shape: 'circle',
        indicator: [
          //{ name: '乳腺系统', max: 6500},
          //{ name: '骨骼肌肉系统', max: 16000},
          //{ name: '头颈部', max: 30000},
          //{ name: '中枢神经系统', max: 38000},
          //{ name: '呼吸系统', max: 52000},
          //{ name: '循环系统', max: 25000},
          //{ name: '消化系统', max: 25000},
          //{ name: '泌尿生殖系统', max: 25000}
        ],
        name:{
          textStyle:{
            color:'#48b7c4',
          }
        },
        nameGap:2,
        center: ['50%', '50%'],
        radius:'70%',
      },
      series: [{
        name: '正确率 vs 能力值',
        type: 'radar',
        // areaStyle: {normal: {}},
        data : [
          {
            value : [],
            name : '正确率(数量)',
            itemStyle: {
              normal: {
                color: '#55c3cf',
              },
            }
          },
          {
            value : [],
            name : '能力值',
            itemStyle: {
              normal: {
                color: '#cf5555',
              },
            }
          }
        ]
      }]
    };
    $scope.$on('$ionicView.loaded', function() {
      $scope.myChart = echarts.init(document.getElementById('dataMain'));

    }, false);

    $scope.$on('$ionicView.afterEnter', function() {
      if($scope.userAnalyze == ""){
        UserService.getAnalyzeData($rootScope.user.id)
          .then(function(result){
            if(result.code == 0){
              $scope.userAnalyze = result.result.userAnalyze ;
              $scope.userAnalyzeDetails = result.result.userAnalyzeDetails ;
              $scope.userDiagnosis = result.result.userDiagnosis ;
              $scope.correctPercentageStyle = {width:$scope.userAnalyze.correctPercentage+"%"} ;
              $scope.abilityValueStyle = {width:$scope.userAnalyze.abilityValue+"%"} ;
              $scope.winPercentageStyle = {width:$scope.userAnalyze.winPercentage+"%"} ;
              $scope.toCanvasTitle($scope.canvasIsActive) ;
            }
          },function(reason){

          })
        $timeout(function(){
          personalMenuSlideBox.next() ;
          $timeout(function(){
            personalMenuSlideBox.previous() ;
          },2000);
        },2000) ;
      }
    }, false);

    $scope.toUpdateImage = function($event){
      $state.go('menu.personalCenterUpdateImage') ;
      $event.stopPropagation();
    }

  })
