angular.module('personalUpgrade-controller',[])
  .controller('personalUpgradeCtrl',function($scope,$rootScope,$state,UserService,showAlertService){

    $scope.upgrade = {
      name : '',
      phone : '',
      phoneHasInit : false
    };

    $scope.upgrade.init = function(){
      UserService.getUserById($rootScope.user.id)
        .then(function(result){
          $scope.upgrade.name = result.result.name;
          $scope.upgrade.phone = result.result.phoneNumber;
          if (!!result.result.phoneNumber){
            $scope.upgrade.phoneHasInit = true;
          }
        })
    }

    $scope.upgrade.init();

    $scope.upgrade.updateUser = function(){
      if (!$scope.upgrade.phone){
        showAlertService.PopAlert("提示信息","请输入注册手机","确认","") ;
        return;
      }
      if (!$scope.upgrade.name){
        showAlertService.PopAlert("提示信息","请输入注册姓名","确认","") ;
        return;
      }

      UserService.updateUserPhoneAndName($rootScope.user.id, $scope.upgrade.name, $scope.upgrade.phone)
        .then(function(result){
          showAlertService.PopAlert("提示信息","用户信息更新成功","确认","") ;
          $rootScope.user.name = $scope.upgrade.name ;
          $rootScope.user.phoneNum = $scope.upgrade.phone ;
          var user = window.atob(localStorage.getItem("user")) ;
          if(user != null && user != "" && user.indexOf("@") == -1){
            localStorage.setItem("user", window.btoa($scope.upgrade.phone));
          }
        })
    }

    $scope.upgrade.validation = function(){
      UserService.getUserScoreSys($rootScope.user.id)
        .then(function(result){
          if (result.code == 0|| result.code == 1001|| result.code == 1002|| result.code == 1010|| result.code == 1011|| result.code == 1012){
            showAlertService.PopAlert("提示信息","升级会员医生成功","确认","") ;
            $rootScope.user.userIdentity = 2;
            $rootScope.goToBack();
          }else if(result.code == 1009 || result.code == 3001){
            showAlertService.PopAlert("提示信息","验证失败，请按照升级步骤操作！","确认","") ;
          }else{
            showAlertService.PopAlert("提示信息","验证失败！","确认","") ;
          }
        },function(result){
          showAlertService.PopAlert("提示信息","验证失败！","确认","") ;
        })
    }
  });
