angular.module('personalUserSetting-controller',[])
  .controller('personalUserSettingCtrl',function($scope,$rootScope,UserConfigService,showAlertService){

    $scope.userSetting = {
      newMessageVoice: true,
      newMessageVibrate: true,
      requestEncrypt: false
    }

    $scope.init = function(){
      if (!!$rootScope.userConfigs){
        for (var i in $rootScope.userConfigs){
          if ($rootScope.userConfigs[i].configName == 'NewMsgVoiceNotice'){
            $scope.userSetting.newMessageVoice = $rootScope.userConfigs[i].defaultValue == '1' ? true : false;
          }
          if ($rootScope.userConfigs[i].configName == 'NewMsgVibrateNotice'){
            $scope.userSetting.newMessageVibrate = $rootScope.userConfigs[i].defaultValue == '1' ? true : false;
          }
        }
      }

      $scope.userSetting.requestEncrypt = localStorage.getItem("httpType") == '1' ? true : false;
    }

    $scope.init();

    $scope.$watch('userSetting.newMessageVoice',function(newValue,oldValue){
      if (newValue == undefined || oldValue == undefined || newValue == oldValue){
        return;
      }
      $scope.updateUserSetting('NewMsgVoiceNotice', newValue ? '1' : '0');
    })
    $scope.$watch('userSetting.newMessageVibrate',function(newValue,oldValue){
      if (newValue == undefined || oldValue == undefined || newValue == oldValue){
        return;
      }
      $scope.updateUserSetting('NewMsgVibrateNotice', newValue ? '1' : '0');
    })
    $scope.$watch('userSetting.requestEncrypt',function(newValue,oldValue){
      if (newValue == undefined || oldValue == undefined || newValue == oldValue){
        return;
      }
      if (newValue){
        localStorage.setItem("httpType", "1");
        config.new_url = config.new_url.replace('http://', 'https://');
      }else{
        localStorage.setItem("httpType", "0");
        config.new_url = config.new_url.replace('https://', 'http://');
      }
      $scope.updateUserSetting('RequestEncrypt', newValue ? '1' : '0');
    })

    $scope.updateUserSetting = function(name, newValue){
      var userConfig = null;
      for (var i in $rootScope.userConfigs){
        if ($rootScope.userConfigs[i].configName == name){
          userConfig = $rootScope.userConfigs[i];
          break;
        }
      }

      if (!userConfig){
        return;
      }

      userConfig.defaultValue = newValue;

      var configModel = {
        userId : $rootScope.user.id,
        itemId : userConfig.id,
        value : newValue
      }

      UserConfigService.updateUserConfigs(configModel);
    }
});

