angular.module('personalValidation-controller',[])
  .controller('personalValidationCtrl',function($scope,$rootScope,$state,$ionicActionSheet,$cordovaCamera,$cordovaImagePicker,ossService, UserService, validationService,showAlertService,$cordovaKeyboard){

    $scope.validation = {
      id: 0,
      name: '',
      phone: '',
      region: '',
      hospital: '',
      email:'',
      department: '',
      position: '',
      licenseNumber: '',
      ID_frontpic: '',
      ID_frontpic_loading: false,
      certificate_pic: '',
      certificate_pic_loading: false,
      comment: '',
      applyStatus: 0
    }

    //初始化地区信息
    $scope.initSwfArea = function(){
      UserService.getSwfArea()
        .then(function(result){
          $scope.LAreaData = result ;
          if($scope.validation.region !=undefined && $scope.validation.region != null) {
            var ary =$scope.validation.region.split(",") ;
            var str = "" ;
            var province = ""
            var city = "" ;
            var area = "" ;
            var sorts = [] ;
            if(ary[0] != undefined){
              province = $scope.LAreaData.filter(function(a) {
                return a.id == ary[0];
              })[0]
            }
            if(ary[1] != undefined && province != undefined){
              city =province.child.filter(function(a) {
                return a.id == ary[1];
              })[0]
            }
            if(ary[2] != undefined && city != undefined){
              area = city.child.filter(function(a) {
                return a.id == ary[0];
              })[0]
            }
            if(province != "" && province != undefined){
              str += province.name ;
              sorts.push(province.sort-1) ;
            }
            if(city != "" && city != undefined){
              str += ","+city.name ;
              sorts.push(city.sort-1) ;
            }
            if(area != "" && area != undefined){
              str += ","+area.name ;
              sorts.push(area.sort-1) ;
            }

            $scope.validation.swfArea = str==""?$scope.validation.region:str ;
            $scope.validation.swfAreaSorts = sorts ;
            var area1 = new LArea();
            area1.init({
              'trigger': '#cityname1',
              'valueTo': '#cityvalue1',
              'keys': {
                id: 'id',
                name: 'name'
              },
              'type': 1,
              'data': $scope.LAreaData
            });
            if($scope.validation.swfAreaSorts != null && $scope.validation.swfAreaSorts.length > 0){
              area1.value=$scope.validation.swfAreaSorts;
            }
          }else{
            var area1 = new LArea();
            area1.init({
              'trigger': '#cityname1',
              'valueTo': '#cityvalue1',
              'keys': {
                id: 'id',
                name: 'name'
              },
              'type': 1,
              'data': $scope.LAreaData
            });
          }
        })
    }

    $scope.isSubmited = true ;
    $scope.upload = {
      host : 'http://partake-test.oss-cn-beijing.aliyuncs.com/',
      key : 'validation/'+$rootScope.user.id+'/',
    };
    $scope.imgSize = "@150h_200w_4e_0-0-0bgc_1o" ;
    $scope.flagStr1 = "@240h_320w" ;
    $scope.flagStr2 = "@240h_320w_1o" ;

    // 添加图片
    $scope.addPhoto = function (type) {
      if($scope.validation.applyStatus == 2){
        return;
      }

      $ionicActionSheet.show({
        buttons: [
          {text: '相机'},
          {text: '图库'}
        ],
        titleText: "请选择获取图片方式",
        cancelText: '取消',
        cancel: function () {
          return true;
        },
        buttonClicked: function (index) {
          switch (index) {
            case 0:
              $scope.takePhoto(type);
              break;
            case 1:
              $scope.pickImage(type);
              break;
            default:
              break;
          }
          return true;
        }
      });
    };

    //拍照
    $scope.takePhoto = function (type) {
      var options = {
        quality: 100,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: Camera.PictureSourceType.CAMERA,
        targetWidth: 240,
        targetHeight: 320
      };

      $cordovaCamera.getPicture(options)
        .then(function (imageURI) {
          ossService.getOssSignature(1).then(function(result) {
            $scope.upload.host = result.result.host;
            $scope.uploadPhoto(imageURI, type);
          })
        });
    };
    //选择照片
    $scope.pickImage = function (type) {
      var options = {
        maximumImagesCount: 1,
        quality: 10
      };

      $cordovaImagePicker.getPictures(options)
        .then(function (imageURIs) {
          if (imageURIs.length == 0){
            return;
          }
          ossService.getOssSignature(1).then(function(result) {
            $scope.upload.host = result.result.host;
            $scope.uploadPhoto(imageURIs[0], type);
          })
        });
    };

    // 上传
    $scope.uploadPhoto = function (fileUrl, type) {

      if (type=='id-front'){
        $scope.validation.ID_frontpic_loading = true;
        $scope.validation.ID_frontpic = "";
      }else if (type=='certificate'){
        $scope.validation.certificate_pic_loading = true;
        $scope.validation.certificate_pic = "";
      }

      var name = $scope.calculateFileName(fileUrl.substr(fileUrl.lastIndexOf('/')+1));
      var options = new FileUploadOptions();
      options.fileKey = "file";
      options.fileName = name;
      options.mimeType = "image/jpeg";
      options.httpMethod = "PUT";
      options.chunkedMode = true;

      options.headers = {
        'Content-Type': 'image/jpeg'
      };

      var ft = new FileTransfer();
      ft.upload(fileUrl, $scope.upload.host.replace('http', 'https') + $scope.upload.key + name, function(data) {
        if (type=='id-front'){
          $scope.validation.ID_frontpic = $scope.upload.host.replace('oss', 'img') + $scope.upload.key + name
          $scope.validation.ID_frontpic_loading = false;
        }else if (type=='certificate'){
          $scope.validation.certificate_pic = $scope.upload.host.replace('oss', 'img') + $scope.upload.key + name
          $scope.validation.certificate_pic_loading = false;
        }
        $scope.$apply();
      }, function(error) {
        $scope.validation.ID_frontpic_loading = false;
        $scope.validation.certificate_pic_loading = false;
        showAlertService.PopAlert("提示信息","网络原因，图片上传失败！","确认","") ;
      }, options);
    };

    $scope.calculateFileName = function (filename)
    {
      var pos = filename.lastIndexOf('.')
      var suffix = ''
      if (pos != -1) {
        suffix = filename.substring(pos)
      }

      var chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678';
      var maxPos = chars.length;
      var pwd = '';
      for (var i = 0; i < 36; i++) {
        pwd += chars.charAt(Math.floor(Math.random() * maxPos));
      }

      return pwd + suffix;
    }

    $scope.init = function(){
      validationService.getQualification($rootScope.user.id)
        .then(function(result){
          if (!!result.result){
            $scope.validation.id = result.result.id;
            $scope.validation.name = $rootScope.user.name;
            $scope.validation.phone = result.result.phoneNumber;
            $scope.validation.region = $rootScope.user.location;
            $scope.validation.hospital = $rootScope.user.hospital;
            $scope.validation.email = $rootScope.user.email;
            $scope.validation.department = $rootScope.user.department;
            $scope.validation.position = result.result.position;
            $scope.validation.licenseNumber = result.result.licenseNumber;
            $scope.validation.ID_frontpic = result.result.idfrontpic;
            $scope.validation.certificate_pic = result.result.certificatePic;
            $scope.validation.comment = result.result.comment;
            $scope.validation.applyStatus = result.result.applyStatus;
            //将申请状态绑定到用户属性
            $rootScope.user.applyStatus = result.result.applyStatus ;
            $scope.initSwfArea() ;
          }else{
            UserService.getUserById($rootScope.user.id)
              .then(function(result){
                if (!!result.result){
                  $scope.validation.name = result.result.name;
                  $scope.validation.phone = result.result.phoneNumber;
                  $scope.validation.email = result.result.email ;
                  $scope.validation.region = result.result.location;
                  $scope.validation.hospital = result.result.hospital;
                  $scope.validation.department = result.result.department;
                  $scope.validation.position = result.result.userPosition;
                  $scope.initSwfArea() ;
                }
              })
          }
        })
    }
    $scope.$on('$ionicView.afterEnter', function() {
      $scope.init();
      $scope.validationBlur() ;
    }, false);

    $scope.focusInput = function(){
      $scope.isChecked = false;
    }

    $scope.submit = function(){
      $scope.isChecked = true ;
      if($scope.myForm.$error.required != undefined && $scope.myForm.$error.required.length > 0){
        for(var i in $scope.myForm.$error.required){
          $scope.myForm.$error.required[i].$dirty = true ;
        }
        return ;
      }
      if($scope.myForm.$error.pattern != undefined && $scope.myForm.$error.pattern.length > 0){
        for(var i in $scope.myForm.$error.pattern){
          $scope.myForm.$error.pattern[i].$dirty = true ;
        }
        return ;
      }
      $scope.isSubmited = false ;
      $scope.validation.region = angular.element("#cityvalue1")[0].value ;
      validationService.updateQualification(
        $scope.validation.id,
        $rootScope.user.id,
        $scope.validation.name,
        $scope.validation.region,
        $scope.validation.hospital,
        $scope.validation.email,
        $scope.validation.department,
        $scope.validation.position,
        $scope.validation.licenseNumber,
        $scope.validation.ID_frontpic,
        $scope.validation.ID_frontpic,
        $scope.validation.certificate_pic)
        .then(function(result){
          $scope.isSubmited = true ;
          if(result.code == 0){
            showAlertService.PopAlert("提示信息","申请验证成功！","确认","") ;
            $scope.validation.applyStatus = 2;
            //将申请状态绑定到用户属性
            $rootScope.user.applyStatus = 2 ;
            $rootScope.user.name = $scope.validation.name;
            $rootScope.user.location = $scope.validation.region ;
            $scope.updateRootUserLocation() ;
            $rootScope.user.hospital = $scope.validation.hospital ;
            $rootScope.user.email = $scope.validation.email ;
            $rootScope.user.department = $scope.validation.department ;
          }else if(result.code == -1){
            showAlertService.PopAlert("提示信息","申请验证失败,请稍后重试或者联系管理员！","确认","") ;
          }
        },function(result){
          $scope.isSubmited = true ;
          showAlertService.PopAlert("提示信息","申请验证失败,请稍后重试或者联系管理员！","确认","") ;
        })
    }

    $scope.updateRootUserLocation = function(){
      UserService.getSwfArea()
        .then(function(result){
          var ary = [] ;
          var LAreaData = result ;
          if($rootScope.user.location !=undefined && $rootScope.user.location != null ){
            ary =$rootScope.user.location.split(",") ;
            var str = "" ;
            var province = ""
            var city = "" ;
            var area = "" ;
            var sorts = [] ;
            if(ary[0] != undefined){
              province = LAreaData.filter(function(a) {
                return a.id == ary[0];
              })[0]
            }
            if(ary[1] != undefined && province != undefined){
              city =province.child.filter(function(a) {
                return a.id == ary[1];
              })[0]
            }
            if(ary[2] != undefined && city != undefined){
              area = city.child.filter(function(a) {
                return a.id == ary[0];
              })[0]
            }
            if(province != "" && province != undefined){
              str += province.name ;
              sorts.push(province.sort-1) ;
            }
            if(city != "" && city != undefined){
              str += ","+city.name ;
              sorts.push(city.sort-1) ;
            }
            if(area != "" && area != undefined){
              str += ","+area.name ;
              sorts.push(area.sort-1) ;
            }

            $rootScope.user.swfArea = str==""?$rootScope.user.location:str ;
            $rootScope.user.swfAreaSorts = sorts ;
          }
        });
    }

    $scope.modifyApply = function(){
      $scope.validation.applyStatus = 0;
      //将申请状态绑定到用户属性
      $rootScope.user.applyStatus = 0 ;
    }

    $scope.reApply = function(){
      $scope.validation.id = 0;
      $scope.validation.position = '';
      $scope.validation.ID_frontpic = '';
      $scope.validation.certificate_pic = '';
      $scope.validation.comment = '';
      $scope.validation.applyStatus = 0;
      //将申请状态绑定到用户属性
      $rootScope.user.applyStatus = 0 ;
      UserService.getUserById($rootScope.user.id)
        .then(function(result){
          if (!!result.result){
            $scope.validation.name = result.result.name;
            $scope.validation.phone = result.result.phoneNumber;
            $scope.validation.email = result.result.email ;
            $scope.validation.region = result.result.location;
            $scope.validation.hospital = result.result.hospital;
            $scope.validation.department = result.result.department;
          }
        })
    }

    $scope.templete = {
      idTempleteFlag : false,
      certificateTempleteFlag : false,
    }

    $scope.validationBlur = function(){
      $cordovaKeyboard.close();
    }
  });
