angular.module('createCaseStepOne-controller',[])
  .controller('CreateCaseStepOneCtrl',function($scope, $state, deviceService, uploadCaseService, showAlertService){

    $scope.equipTypes = null;
    $scope.bodysystems = null;
    $scope.casePurposes = [{code:0, name:'分享'},{code:1, name:'求助'}];

    $scope.equipinit = function(){
      deviceService.findDeviceType()
        .then(function(result){
          $scope.equipTypes = result.result.equipments ;
          $scope.bodysystems = result.result.bodysystems ;
        });
    }
    $scope.equipinit();

    $scope.newCaseData = {
		  equipTypeIndex: -1,
		  equipTypes: null,
		  bodysystemIndex: -1,
		  bodysystems: null,
      casePurposeIndex: 0,
      casePurposes: null,
		  caseInfo: null
	  }

	  $scope.init = function(){
		  $scope.newCaseData = uploadCaseService.getNewCaseData();
		  if (!$scope.newCaseData){
			  $scope.caseDataInit();
		  }
	  }

	  $scope.caseDataInit = function(){
		  $scope.newCaseData = {};
		  $scope.newCaseData.equipTypeIndex = -1;
		  $scope.newCaseData.bodysystemIndex = -1;
      $scope.newCaseData.casePurposeIndex= 0;
		  $scope.newCaseData.caseInfo = {
		      id: 0,
		      title: '',
		      sex: '男',
		      age: 50,
		      ageList: [],
		      ageUnit: 'Y',
		      imgList: [],
		      contentMessage: '',
		      isPathology: false,
		      pathology: ''
		  }

		  for (var i=0; i<120; i++){
			  $scope.newCaseData.caseInfo.ageList.push(i+1);
		  }

      $scope.newCaseData.casePurposes =  [{code:0, name:'分享'},{code:1, name:'求助'}];

      if (!!$scope.equipTypes){
        $scope.newCaseData.equipTypes = $scope.equipTypes;
        $scope.newCaseData.bodysystems = $scope.bodysystems;
      }else{
        deviceService.findDeviceType()
          .then(function(result){
            $scope.equipTypes = result.result.equipments;
            $scope.bodysystems = result.result.bodysystems ;
            $scope.newCaseData.equipTypes = result.result.equipments ;
            $scope.newCaseData.bodysystems = result.result.bodysystems ;
          });
      }

    }

	    $scope.$on( "$ionicView.enter", function(){
	  	  $scope.init();
	  })

    $scope.selectEquipType = function(index){
      if ($scope.newCaseData.equipTypeIndex == index){
    	  $scope.newCaseData.equipTypeIndex = -1;
      }else{
    	  $scope.newCaseData.equipTypeIndex = index;
      }
    }

    $scope.selectBodySystem = function(index){
        if ($scope.newCaseData.bodysystemIndex == index){
        	$scope.newCaseData.bodysystemIndex = -1;
        }else{
        	$scope.newCaseData.bodysystemIndex = index;
        }
    }

    $scope.selectCasePurpose = function(index){
        if ($scope.newCaseData.casePurposeIndex == index){
        	$scope.newCaseData.casePurposeIndex = -1;
        }else{
        	$scope.newCaseData.casePurposeIndex = index;
        }
    }

    $scope.gotoStepTwo = function(){
          if ($scope.newCaseData.equipTypeIndex == -1){
            showAlertService.PopAlert("提示信息","请选择设备","确认","") ;
            return;
          }
    	  if ($scope.newCaseData.bodysystemIndex == -1){
            showAlertService.PopAlert("提示信息","请选择系统","确认","") ;
            return;
          }
      if ($scope.newCaseData.casePurposeIndex == -1){
        showAlertService.PopAlert("提示信息","请选择类型","确认","") ;
        return;
      }

    	uploadCaseService.setNewCaseData($scope.newCaseData);
      $scope.newCaseData = null;
      $state.go("menu.upload") ;
    }
});

