angular.module('createCaseStepTwo-controller',[])
  .controller('CreateCaseStepTwoCtrl',function($scope,$rootScope,$state,$stateParams,deviceService, uploadCaseService, ossService, showAlertService, $ionicLoading, $cordovaCamera, $ionicActionSheet, $cordovaImagePicker, $cordovaFileTransfer){

	$scope.newCaseData = uploadCaseService.getNewCaseData();

	$scope.step = 1;

    // 图片上传
    $scope.imgInfo = {};
    $scope.imgInfo.imgList = $scope.newCaseData.caseInfo.imgList;
    $scope.imgInfo.removeImg = function(index) {
      $scope.imgInfo.imgList.splice(index,1);
      try{
        $scope.upload.uploader.files.splice(index,1);
      }catch(e){
        console.log(JSON.stringify(e));
      }
      setTimeout(function() {
        $scope.$apply();
      }, 5);
    }
    $scope.imgInfo.reUploadImg = function(index) {
      if ($scope.imgInfo.imgList[index].failed){
        $scope.imgInfo.imgList[index].failed = false;
        $scope.imgInfo.imgList[index].imgLoadFlag = false;
        $scope.imgInfo.imgList[index].thumbUri = "img/load.gif";
        $scope.uploadPhoto($scope.imgInfo.imgList[index].imgUri);
      }
    }

    $scope.upload = {
      accessid : '',
      host : 'http://partake-test.oss-cn-beijing.aliyuncs.com/',
      policyBase64 : '',
      signature : '',
      key : 'lt/temp/',
    };

    // 添加图片
    $scope.addPhoto = function () {
      $ionicActionSheet.show({
        buttons: [
          {text: '相机'},
          {text: '图库'}
        ],
        titleText: "请选择获取图片方式",
        cancelText: '取消',
        cancel: function () {
          return true;
        },
        buttonClicked: function (index) {
          switch (index) {
            case 0:
              $scope.takePhoto();
              break;
            case 1:
              $scope.pickImage();
              break;
            default:
              break;
          }
          return true;
        }
      });
    };

    //拍照
    $scope.takePhoto = function () {
      var options = {
        quality: 100,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: Camera.PictureSourceType.CAMERA,
        targetWidth: 720,
        targetHeight: 960
      };

      $cordovaCamera.getPicture(options)
        .then(function (imageURI) {
          ossService.getOssSignature(1, $stateParams.caseId).then(function(result) {

            $scope.upload.accessid = result.result.accessid;
            $scope.upload.host = result.result.host;
            $scope.upload.policyBase64 = result.result.policy;
            $scope.upload.signature = result.result.signature;
            $scope.upload.key = result.result.dir;
            $scope.imgInfo.imgList.push({"id":0, "imgUri":imageURI, "imgLoadFlag":false, "failed":false, "thumbUri": "img/load.gif"});
            $scope.uploadPhoto(imageURI);
          })
        }, function (err) {
        });
    };
    //选择照片
    $scope.pickImage = function () {
      var options = {
        maximumImagesCount: 30
      };

      $cordovaImagePicker.getPictures(options)
        .then(function (imageURIs) {
          //Success
          ossService.getOssSignature(1, $stateParams.caseId).then(function(result) {
            $scope.upload.accessid = result.result.accessid;
            $scope.upload.host = result.result.host;
            $scope.upload.policyBase64 = result.result.policy;
            $scope.upload.signature = result.result.signature;
            $scope.upload.key = result.result.dir;
            for (var i in imageURIs){
              var tempUri = imageURIs[i];
              var picExist = false;
              for (var j in $scope.imgInfo.imgList){
                if (tempUri.indexOf('tmp_') > -1){
                    if(ionic.Platform.isIOS()){
                        if ($scope.imgInfo.imgList[j].imgUri.indexOf(tempUri.substring(tempUri.indexOf('tmp_'), tempUri.indexOf('='))) > -1){
                            picExist = true;
                            break;
                        }
                    }else{
                        if ($scope.imgInfo.imgList[j].imgUri.indexOf(tempUri.substring(tempUri.indexOf('tmp_'), tempUri.indexOf('%3D'))) > -1){
                            picExist = true;
                            break;
                        }
                    }
                }else{
                  if ($scope.imgInfo.imgList[j].imgUri == tempUri){
                    picExist = true;
                    break;
                  }
                }
              }

              if (picExist){
                continue;
              }

              $scope.imgInfo.imgList.push({"id":0, "imgUri":tempUri, "imgLoadFlag":false, "failed":false, "thumbUri": "img/load.gif"});
              $scope.$apply();
              $scope.uploadPhoto(tempUri);
            }
          })
        }, function (err) {
        });
    };

    // 上传
    $scope.uploadPhoto = function (fileUrl) {
      var name = $scope.upload.calculateFileName(fileUrl.substr(fileUrl.lastIndexOf('/')+1));
      var options = new FileUploadOptions();
      options.fileKey = "file";
      options.fileName = name;
      options.mimeType = "image/jpeg";
      options.httpMethod = "PUT";
      options.chunkedMode = true;

      options.headers = {
        'Content-Type': 'image/jpeg'
      };

      var ft = new FileTransfer();
      ft.upload(fileUrl, $scope.upload.host.replace('http', 'https') + $scope.upload.key + name, function(data) {
        for(var i in $scope.imgInfo.imgList){
          if ($scope.imgInfo.imgList[i].imgUri === fileUrl){
            $scope.imgInfo.imgList[i].imgLoadFlag = true;
            $scope.imgInfo.imgList[i].imgName = name;
            $scope.imgInfo.imgList[i].thumbUri = $scope.upload.host.replace('oss', 'img') + $scope.upload.key + name + "@70h_70w_1o";
          }
        }
        $scope.$apply();
      }, function(error) {
        for(var i in $scope.imgInfo.imgList){
          if ($scope.imgInfo.imgList[i].imgUri === fileUrl){
            $scope.imgInfo.failedFlag = true;
            $scope.imgInfo.imgList[i].failed = true;
            $scope.imgInfo.imgList[i].imgLoadFlag = true;
            $scope.imgInfo.imgList[i].thumbUri = "img/loadfailed.png";
          }
        }
        $scope.$apply();
      }, options);
    };

    $scope.upload.calculateFileName = function (filename){
      var pos = filename.lastIndexOf('.')
      var suffix = ''
      if (pos != -1) {
        suffix = filename.substring(pos)
      }

      var chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678';
      var maxPos = chars.length;
      var pwd = '';
      for (var i = 0; i < 36; i++) {
        pwd += chars.charAt(Math.floor(Math.random() * maxPos));
      }

      return pwd + suffix;
    }

    $scope.uploadCase = function(){
      if (!$scope.newCaseData.caseInfo.title){
        showAlertService.PopAlert("提示信息","请输入病例标题","确认","") ;
        return;
      }
      if (!$scope.newCaseData.caseInfo.age){
        showAlertService.PopAlert("提示信息","请输入年龄","确认","") ;
        return;
      }
      if (!$scope.newCaseData.caseInfo.contentMessage){
        showAlertService.PopAlert("提示信息","请输入病程描述","确认","") ;
        return;
      }

      var newFileNames = [];
      var unUploadNum = 0;
      for (var i in $scope.imgInfo.imgList){
        if (!$scope.imgInfo.imgList[i].imgLoadFlag){
          unUploadNum++;
        }

        if (!$scope.imgInfo.imgList[i].failed){
          newFileNames.push($scope.imgInfo.imgList[i].imgName);
        }
      }

      if (unUploadNum > 0){
        showAlertService.PopAlert("提示信息",unUploadNum+"张图片正在上传，请稍后！","确认","") ;
        return;
      }

      if (newFileNames.length == 0){
        showAlertService.PopAlert("提示信息","请至少选择一张图片","确认","") ;
        return;
      }

      $ionicLoading.show();

    uploadCaseService.addDiscussCase(
      $scope.newCaseData.caseInfo.title,
      $scope.newCaseData.caseInfo.contentMessage,
      $scope.newCaseData.caseInfo.pathology,
      $rootScope.user.id,
      newFileNames.join(','),
      $scope.newCaseData.caseInfo.sex,
      $scope.newCaseData.caseInfo.age + $scope.newCaseData.caseInfo.ageUnit,
      $scope.newCaseData.casePurposes[$scope.newCaseData.casePurposeIndex].code,
      $scope.newCaseData.equipTypes[$scope.newCaseData.equipTypeIndex].code,
      $scope.newCaseData.bodysystems[$scope.newCaseData.bodysystemIndex].code
    )
      .then(function(result){
        var score = !!$rootScope.uploadScore ? $rootScope.uploadScore : 15;
        $rootScope.$emit('message',"病例上传成功，积分+"+score,3000,"notice");
        $scope.step = 1;
        $scope.imgInfo.imgList = [];
        $scope.$apply();
    	  uploadCaseService.setNewCaseData(null);
        $ionicLoading.hide();

        $scope.$emit("DiscussCaseRefresh") ;
        $state.go("menu.tab.community");
      }, function(){
        var score = !!$rootScope.uploadScore ? $rootScope.uploadScore : 15;
        $rootScope.$emit('message',"病例上传成功，积分+"+score,3000,"notice");
        $scope.step = 1;
        $scope.imgInfo.imgList = [];
        $scope.$apply();
        uploadCaseService.setNewCaseData(null);
        $ionicLoading.hide();

        $scope.$emit("DiscussCaseRefresh") ;
        $state.go("menu.tab.community");
      })
    }

    $scope.drag = {
      nearIndex : -1,
      flag: false
    };

    $scope.imgDrag = function(index, e){
      if (e.gesture.touches.length > 1){
        return;
      }
      var deltaX = e.gesture.deltaX;
      var deltaY = e.gesture.deltaY;
      if (angular.element("#upload-img-"+index).css("opacity") != 0.5){
        return;
      }

      angular.element("#upload-img-"+index).css("left", parseInt(deltaX)+"px");
      angular.element("#upload-img-"+index).css("top", parseInt(deltaY)+"px");
      angular.element("#upload-img-"+index).css("z-index", 99);
      angular.element("#upload-img-"+index).css("opacity", 0.5);
      angular.element("#upload-del-"+index).css("left", parseInt(deltaX)+"px");
      angular.element("#upload-del-"+index).css("top", parseInt(deltaY)+"px");
      angular.element("#upload-del-"+index).css("z-index", 100);

      var lineCount = parseInt((window.innerWidth - 20) / 84);
      // 获取图片位置
      var currentImgNum = index + 1;
      var currentCol = currentImgNum % lineCount > 0 ? parseInt(currentImgNum / lineCount) + 1 : currentImgNum / lineCount;
      var currentRow = currentImgNum % lineCount > 0 ? currentImgNum % lineCount : lineCount;
      var currentX = deltaX + (currentRow-1) * 82;
      var currentY = deltaY + (currentCol-1) * 84;

      // 获取距离本图片最近的图片
      var nearPicIndex = -1;
      var nearPicDis = 10000;
      for (var i in $scope.imgInfo.imgList){
        var imgNum = parseInt(i) + 1;
        var col = imgNum%lineCount > 0 ? parseInt(imgNum / lineCount) + 1 : imgNum / lineCount;
        var row = imgNum%lineCount > 0 ? imgNum%lineCount : lineCount;
        var x = (row-1) * 82;
        var y = (col-1) * 84;

        var dis = Math.sqrt(Math.pow((currentX-x),2) + Math.pow((currentY-y),2));
        if (dis < nearPicDis){
          nearPicDis = dis;
          nearPicIndex = i;
        }
      }

      angular.element(".upload-img").css("border", "");
      if (index != nearPicIndex){
        angular.element("#upload-img-"+nearPicIndex).css("border", "2px solid red");
      }
      $scope.drag.nearIndex = nearPicIndex;
    }
    $scope.imgRelease = function(index,e){
      angular.element("#upload-img-"+index).css("z-index", 10);
      angular.element("#upload-img-"+index).css("opacity", 1);
      angular.element("#upload-img-"+index).css("left", "0px");
      angular.element("#upload-img-"+index).css("top", "0px");
      angular.element("#upload-del-"+index).css("z-index", 11);
      angular.element("#upload-del-"+index).css("left", "0px");
      angular.element("#upload-del-"+index).css("top", "0px");

      if ($scope.drag.nearIndex == -1 || $scope.drag.nearIndex == index){
        return;
      }
      var img = $scope.imgInfo.imgList.splice(index,1);
      $scope.imgInfo.imgList.splice($scope.drag.nearIndex,0,img[0]);
      $scope.drag.nearIndex = -1;
      angular.element(".upload-img").css("border", "");
      angular.element("#upload-content").css("overflow", "");
    }

    $scope.goToStepOne = function(){
        $scope.newCaseData.caseInfo.imgList = $scope.imgInfo.imgList;
    	uploadCaseService.setNewCaseData($scope.newCaseData);
        $state.go("menu.uploadone");
    }

    $scope.goToStepTwo = function(){
    	uploadCaseService.setNewCaseData($scope.newCaseData);
        $scope.step = 1;
    }

    $scope.goToStepThree = function(){

    	var newFileNames = [];
        var unUploadNum = 0;
        for (var i in $scope.imgInfo.imgList){
          if (!$scope.imgInfo.imgList[i].imgLoadFlag){
            unUploadNum++;
          }

          if (!$scope.imgInfo.imgList[i].failed){
            newFileNames.push($scope.imgInfo.imgList[i].imgName);
          }
        }

        if (unUploadNum > 0){
          showAlertService.PopAlert("提示信息",unUploadNum+"张图片正在上传，请稍后！","确认","") ;
          return;
        }

        if (newFileNames.length == 0){
          showAlertService.PopAlert("提示信息","请至少选择一张图片","确认","") ;
          return;
        }

        $scope.newCaseData.caseInfo.imgList = $scope.imgInfo.imgList;
        $scope.step = 2;
    }

    $scope.cancelUpload = function(){
        showAlertService.PopConfirm("提示信息","确定放弃此次上传吗?","取消","确定")
          .then(function(res) {
            if(res) {
              $scope.step = 1;
              $scope.imgInfo.imgList = [];
              $scope.$apply();
            	uploadCaseService.setNewCaseData(null);
            	$state.go("menu.tab.community");
            } else {
            }
          });
      }

    $scope.imgHold = function(index, e){
      angular.element("#upload-content").css("overflow", "hidden");
      angular.element("#upload-img-"+index).css("z-index", 99);
      angular.element("#upload-img-"+index).css("opacity", 0.5);
    }

    $scope.$on( "$ionicView.enter", function(){
      $scope.step = 1;
      $scope.newCaseData = uploadCaseService.getNewCaseData();
      $scope.imgInfo.imgList = $scope.newCaseData.caseInfo.imgList;
      if ($scope.imgInfo.imgList.length == 0){
        $scope.upload.uploader.files.splice(0,$scope.upload.uploader.files.length);
      }
    })
  });

