angular.module('upload-controller',[])
  .controller('UploadCtrl',function($scope,$rootScope,$state,$stateParams,deviceService, uploadCaseService,$ionicActionSheet,$cordovaCamera,$cordovaFileTransfer,$cordovaImagePicker, ossService, $ionicLoading,showAlertService){

    $scope.marginStyle = { margin: '0px 5px 12px 5px'};
    if(ionic.Platform.isIOS()){
      if(window.screen.width >= 375){
          if(ionic.Platform.isIPad()){
            $scope.marginStyle = { margin: '0px 0px 12px 16px'};
          }else{
            $scope.marginStyle = { margin: '0px 0px 12px 12px'};;
          }
      }else{
        $scope.marginStyle = { margin: '0px 0px 12px 18px'};
      }
    };

    $scope.uploadButtonText = '上传图片';
    $scope.lineCount = parseInt((window.innerWidth - 20) / 84);

    // 初始化设备类型
    $scope.deviceType = {
      list: []
    };
    $scope.bodySystem = {
      list: []
    };
    $scope.casePurpose = {
      list: [{code:0, name:'分享'},{code:1, name:'求助'}]
    };
    $scope.deviceType.activeIndex = -1;
    $scope.bodySystem.activeIndex = -1;
    $scope.casePurpose.activeIndex = -1;
    $scope.selectDeviceType = function(index){
      if ($scope.deviceType.activeIndex == index){
        $scope.deviceType.activeIndex = -1;
      }else{
        $scope.deviceType.activeIndex = index;
      }
    }

    $scope.selectBodySystem = function(index){
      if ($scope.bodySystem.activeIndex == index){
        $scope.bodySystem.activeIndex = -1;
      }else{
        $scope.bodySystem.activeIndex = index;
      }
    }

    $scope.selectCasePurpose = function(index){
      if ($scope.casePurpose.activeIndex == index){
        $scope.casePurpose.activeIndex = -1;
      }else{
        $scope.casePurpose.activeIndex = index;
      }
    }


    // 图片上传
    $scope.imgInfo = {};
    $scope.imgInfo.failedFlag = false;
    $scope.imgInfo.hideFlag = false;
    $scope.imgInfo.imgList = [];
    $scope.imgInfo.removeImg = function(index) {
      $scope.imgInfo.imgList.splice(index,1);
    }
    $scope.imgInfo.changePicHideFlag = function(flag){
      $scope.imgInfo.hideFlag = flag;
    }
    $scope.imgInfo.reUploadImg = function(index) {
      if ($scope.imgInfo.imgList[index].failed){
        $scope.imgInfo.failedFlag = false;
        $scope.imgInfo.imgList[index].failed = false;
        $scope.imgInfo.imgList[index].imgLoadFlag = false;
        $scope.imgInfo.imgList[index].thumbUri = "img/load.gif";
        $scope.uploadPhoto($scope.imgInfo.imgList[index].imgUri);
      }
    }

    $scope.upload = {
      accessid : '',
      host : 'http://partake-test.oss-cn-beijing.aliyuncs.com/',
      policyBase64 : '',
      signature : '',
      key : 'lt/temp/',
    };
    // 添加图片
    $scope.addPhoto = function () {
      $ionicActionSheet.show({
        buttons: [
          {text: '相机'},
          {text: '图库'}
        ],
        titleText: "请选择获取图片方式",
        cancelText: '取消',
        cancel: function () {
          return true;
        },
        buttonClicked: function (index) {
          switch (index) {
            case 0:
              $scope.takePhoto();
              break;
            case 1:
              $scope.pickImage();
              break;
            default:
              break;
          }
          return true;
        }
      });
    };

    //拍照
    $scope.takePhoto = function () {
      var options = {
        quality: 100,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: Camera.PictureSourceType.CAMERA,
        targetWidth: 720,
        targetHeight: 960
      };

      $cordovaCamera.getPicture(options)
        .then(function (imageURI) {
          ossService.getOssSignature(1, $stateParams.caseId).then(function(result) {

            $scope.upload.accessid = result.result.accessid;
            $scope.upload.host = result.result.host;
            $scope.upload.policyBase64 = result.result.policy;
            $scope.upload.signature = result.result.signature;
            $scope.upload.key = result.result.dir;
            $scope.imgInfo.imgList.push({"id":0, "imgUri":imageURI, "imgLoadFlag":false, "failed":false, "thumbUri": "img/load.gif"});
            $scope.uploadPhoto(imageURI);
          })
        }, function (err) {
        });
    };
    //选择照片
    $scope.pickImage = function () {
      var options = {
        maximumImagesCount: 30
      };

      $cordovaImagePicker.getPictures(options)
        .then(function (imageURIs) {
          //Success
          ossService.getOssSignature(1, $stateParams.caseId).then(function(result) {
            $scope.upload.accessid = result.result.accessid;
            $scope.upload.host = result.result.host;
            $scope.upload.policyBase64 = result.result.policy;
            $scope.upload.signature = result.result.signature;
            $scope.upload.key = result.result.dir;
            for (var i in imageURIs){
              var tempUri = imageURIs[i];
              var picExist = false;
              for (var j in $scope.imgInfo.imgList){
                if (tempUri.indexOf('tmp_') > -1){
                  if(ionic.Platform.isIOS()){
                    if ($scope.imgInfo.imgList[j].imgUri.indexOf(tempUri.substring(tempUri.indexOf('tmp_'), tempUri.indexOf('='))) > -1){
                      picExist = true;
                      break;
                    }
                  }else{
                    if ($scope.imgInfo.imgList[j].imgUri.indexOf(tempUri.substring(tempUri.indexOf('tmp_'), tempUri.indexOf('%3D'))) > -1){
                      picExist = true;
                      break;
                    }
                  }

                }else{
                  if ($scope.imgInfo.imgList[j].imgUri == tempUri){
                    picExist = true;
                    break;
                  }
                }
              }

              if (picExist){
                continue;
              }

              $scope.imgInfo.imgList.push({"id":0, "imgUri":tempUri, "imgLoadFlag":false, "failed":false, "thumbUri": "img/load.gif"});
              $scope.$apply();
              $scope.uploadPhoto(tempUri);
            }
          })
        }, function (err) {
        });
    };

    // 上传
    $scope.uploadPhoto = function (fileUrl) {
        var name = $scope.upload.calculateFileName(fileUrl.substr(fileUrl.lastIndexOf('/')+1));
        var options = new FileUploadOptions();
        options.fileKey = "file";
        options.fileName = name;
        options.mimeType = "image/jpeg";
        options.httpMethod = "PUT";
        options.chunkedMode = true;

        options.headers = {
          'Content-Type': 'image/jpeg'
        };

        var ft = new FileTransfer();
        ft.upload(fileUrl, $scope.upload.host.replace('http', 'https') + $scope.upload.key + name, function(data) {
          for(var i in $scope.imgInfo.imgList){
            if ($scope.imgInfo.imgList[i].imgUri === fileUrl){
              $scope.imgInfo.imgList[i].imgLoadFlag = true;
              $scope.imgInfo.imgList[i].imgName = name;
              $scope.imgInfo.imgList[i].thumbUri = $scope.upload.host.replace('oss', 'img') + $scope.upload.key + name + "@70h_70w_1o";
            }
          }
          $scope.$apply();
        }, function(error) {
          for(var i in $scope.imgInfo.imgList){
            if ($scope.imgInfo.imgList[i].imgUri === fileUrl){
              $scope.imgInfo.failedFlag = true;
              $scope.imgInfo.imgList[i].failed = true;
              $scope.imgInfo.imgList[i].imgLoadFlag = true;
              $scope.imgInfo.imgList[i].thumbUri = "img/loadfailed.png";
            }
          }
          $scope.$apply();
        }, options);
    };

    $scope.upload.calculateFileName = function (filename){
      var pos = filename.lastIndexOf('.')
      var suffix = ''
      if (pos != -1) {
        suffix = filename.substring(pos)
      }

      var chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678';
      var maxPos = chars.length;
      var pwd = '';
      for (var i = 0; i < 36; i++) {
        pwd += chars.charAt(Math.floor(Math.random() * maxPos));
      }

      return pwd + suffix;
    }

    // 病例信息
    $scope.caseInfo = {
      id: 0,
      title: '',
      sex: '男',
      age: 50,
      ageList: [],
      ageUnit: 'Y',
      contentMessage: '',
      isPathology: false,
      pathology: ''
    }
    $scope.caseInfo.init = function(){
      $scope.caseInfo.ageList = [];
      for (var i=0; i<120; i++){
        $scope.caseInfo.ageList.push(i+1);
      }
      $scope.imgInfo.imgList = [];
      deviceService.findDeviceType()
        .then(function(result){
          $scope.deviceType.list = result.result.equipments;
          $scope.bodySystem.list = result.result.bodysystems ;
          if ($stateParams.caseId > 0){
            uploadCaseService.getDiscussCase($stateParams.caseId)
              .then(function(result){
                // 图片列表
                for (var i in result.result.caseInfoImageList){
                  var image = result.result.caseInfoImageList[i];
                  var imgNames = image.imageName.split('/');
                  var imgName = imgNames[imgNames.length-1];
                  $scope.imgInfo.imgList.push({"id":image.id, "imgUri":image.thumbnail, "imgLoadFlag":true, "failed":false, "thumbUri": image.imageName + "@70h_70w_1o", "imgName": imgName});
                }

                // 设备类型
                for (var i in $scope.deviceType.list){
                  if ($scope.deviceType.list[i].code == result.result.caseType){
                    $scope.deviceType.activeIndex = i;
                  }
                }

                // 系统类型
                for (var i in $scope.bodySystem.list){
                  if ($scope.bodySystem.list[i].code == result.result.bsTag){
                    $scope.bodySystem.activeIndex = i;
                  }
                }

                // 系统类型
                for (var i in $scope.casePurpose.list){
                  if ($scope.casePurpose.list[i].code == result.result.casePurpose){
                    $scope.casePurpose.activeIndex = i;
                  }
                }

                // 病例信息
                $scope.caseInfo.id= result.result.id;
                $scope.caseInfo.title= result.result.title;
                $scope.caseInfo.sex= result.result.sex;

                var age = 0;
                var ageUnit = 'Y';

                if (!!result.result.age){
                  var reg = /\-?[0-9]+\.?[0-9]*/g;
                  var array = result.result.age.match(reg);
                  if (array.length > 0){
                    age = array[0];
                    var util = result.result.age.replace(age, '');
                    if (util == 'M' || util == '月'){
                      ageUnit = 'M'
                    }else if (util == 'D' || util == '天'){
                      ageUnit = 'D'
                    }
                  }
                }

                $scope.caseInfo.age= parseInt(age);
                $scope.caseInfo.ageUnit= ageUnit;

                $scope.caseInfo.contentMessage= result.result.content;
                $scope.caseInfo.pathology= result.result.pathology;
                $scope.caseInfo.isPathology = result.result.isPathology == 'n' ? false : true;

              })
          }
        });
    }
    $scope.caseInfo.init();


    $scope.reset = function(){
      $scope.caseInfo.id= 0;
      $scope.caseInfo.title= '';
      $scope.caseInfo.sex= '男';
      $scope.caseInfo.age= 50;
      $scope.caseInfo.ageUnit= 'Y';
      $scope.caseInfo.contentMessage= '';
      $scope.caseInfo.pathology= '';
      $scope.caseInfo.isPathology = false;
      $scope.imgInfo.failedFlag = false;
      $scope.imgInfo.hideFlag = false;
      $scope.deviceType.activeIndex = -1;

      $scope.imgInfo.imgList = [];
    }

    $scope.uploadCase = function(){
      if (!$scope.caseInfo.title){
        showAlertService.PopAlert("提示信息","请输入病例标题","确认","") ;
        return;
      }
      if (!$scope.caseInfo.age){
        showAlertService.PopAlert("提示信息","请输入年龄","确认","") ;
        return;
      }
      if (!$scope.caseInfo.contentMessage){
        showAlertService.PopAlert("提示信息","请输入病程描述","确认","") ;
        return;
      }
      if($scope.deviceType.activeIndex == -1){
        showAlertService.PopAlert("提示信息","请选择设备","确认","") ;
        return;
      }
      if($scope.bodySystem.activeIndex == -1){
        showAlertService.PopAlert("提示信息","请选择系统","确认","") ;
        return;
      }
      if($scope.casePurpose.activeIndex == -1){
        showAlertService.PopAlert("提示信息","请选择类型","确认","") ;
        return;
      }
      var newFileNames = [];
      var unUploadNum = 0;
      for (var i in $scope.imgInfo.imgList){
        if (!$scope.imgInfo.imgList[i].imgLoadFlag){
          unUploadNum++;
        }

        if (!$scope.imgInfo.imgList[i].failed){
          newFileNames.push($scope.imgInfo.imgList[i].imgName);
        }
      }

      if (unUploadNum > 0){
        showAlertService.PopAlert("提示信息",unUploadNum+"张图片正在上传，请稍后！","确认","") ;
        return;
      }

      if (newFileNames.length == 0){
        showAlertService.PopAlert("提示信息","请至少选择一张图片","确认","") ;
        return;
      }

      $ionicLoading.show();

      if ($stateParams.caseId == 0){
        uploadCaseService.addDiscussCase(
          $scope.caseInfo.title,
          $scope.caseInfo.contentMessage,
          $scope.caseInfo.pathology,
          $rootScope.user.id,
          newFileNames.join(','),
          $scope.caseInfo.sex,
          $scope.caseInfo.age + $scope.caseInfo.ageUnit,
          $scope.deviceType.list[$scope.deviceType.activeIndex].code
        )
          .then(function(result){
            $scope.reset();
            $ionicLoading.hide();
            $state.go("menu.tab.community");
          }, function(){
            $ionicLoading.hide();
            showAlertService.PopAlert("提示信息","提交失败","确认","") ;
          })
      }else{
        uploadCaseService.updateDiscussCase(
          $stateParams.caseId,
          $scope.caseInfo.title,
          $scope.caseInfo.contentMessage,
          $scope.caseInfo.pathology,
          $scope.caseInfo.isPathology == true ? 'y' : 'n',
          newFileNames.join(','),
          $scope.caseInfo.sex,
          $scope.caseInfo.age + $scope.caseInfo.ageUnit,
          $scope.casePurpose.list[$scope.casePurpose.activeIndex].code,
          $scope.deviceType.list[$scope.deviceType.activeIndex].code,
          $scope.bodySystem.list[$scope.bodySystem.activeIndex].code
        )
          .then(function(result){
            $scope.reset();
            $ionicLoading.hide();
            $state.go("menu.personalCase");
          }, function(){
            $ionicLoading.hide();
            showAlertService.PopAlert("提示信息","提交失败","确认","") ;
          })
      }
    }

    $scope.drag = {
      nearIndex : -1,
      flag: false
    };

    $scope.$watch('drag.flag',function(newValue,oldValue){
      if (newValue){
        angular.element("#upload-content").css("overflow", "hidden");
      }else{
        angular.element("#upload-content").css("overflow", "");
      }
    })

    $scope.activeOverflow = function(){
      $scope.drag.flag = false;
      angular.element("#upload-content").css("overflow", "");
    }

    $scope.imgDrag = function(index, e){
      if (!$scope.drag.flag){
        return;
      }

      if (e.gesture.touches.length > 1){
        return;
      }
      var deltaX = e.gesture.deltaX;
      var deltaY = e.gesture.deltaY;

      angular.element("#upload-img-"+index).css("left", parseInt(deltaX)+"px");
      angular.element("#upload-img-"+index).css("top", parseInt(deltaY)+"px");
      angular.element("#upload-img-"+index).css("z-index", 99);
      angular.element("#upload-img-"+index).css("opacity", 0.6);
      angular.element("#upload-del-"+index).css("left", parseInt(deltaX)+"px");
      angular.element("#upload-del-"+index).css("top", parseInt(deltaY)+"px");
      angular.element("#upload-del-"+index).css("z-index", 100);

      var lineCount = $scope.lineCount;
      // 获取图片位置
      var currentImgNum = index + 1;
      var currentCol = currentImgNum % lineCount > 0 ? parseInt(currentImgNum / lineCount) + 1 : currentImgNum / lineCount;
      var currentRow = currentImgNum % lineCount > 0 ? currentImgNum % lineCount : lineCount;
      var currentX = deltaX + (currentRow-1) * 82;
      var currentY = deltaY + (currentCol-1) * 84;

      // 获取距离本图片最近的图片
      var nearPicIndex = -1;
      var nearPicDis = 10000;
      for (var i in $scope.imgInfo.imgList){
        var imgNum = parseInt(i) + 1;
        var col = imgNum%lineCount > 0 ? parseInt(imgNum / lineCount) + 1 : imgNum / lineCount;
        var row = imgNum%lineCount > 0 ? imgNum%lineCount : lineCount;
        var x = (row-1) * 82;
        var y = (col-1) * 84;

        var dis = Math.sqrt(Math.pow((currentX-x),2) + Math.pow((currentY-y),2));
        if (dis < nearPicDis){
          nearPicDis = dis;
          nearPicIndex = i;
        }
      }

      angular.element(".upload-img").css("border", "");
      if (index != nearPicIndex){
        angular.element("#upload-img-"+nearPicIndex).css("border", "2px solid red");
      }
      $scope.drag.nearIndex = nearPicIndex;
    }
    $scope.imgRelease = function(index,e){
      if (!$scope.drag.flag){
        return;
      }

      angular.element("#upload-img-"+index).css("z-index", 10);
      angular.element("#upload-img-"+index).css("opacity", 1);
      angular.element("#upload-img-"+index).css("left", "0px");
      angular.element("#upload-img-"+index).css("top", "0px");
      angular.element("#upload-del-"+index).css("z-index", 11);
      angular.element("#upload-del-"+index).css("left", "0px");
      angular.element("#upload-del-"+index).css("top", "0px");

      if ($scope.drag.nearIndex == -1 || $scope.drag.nearIndex == index){
        return;
      }
      var img = $scope.imgInfo.imgList.splice(index,1);
      $scope.imgInfo.imgList.splice($scope.drag.nearIndex,0,img[0]);
      $scope.drag.nearIndex = -1;
      angular.element(".upload-img").css("border", "");
    }

    $scope.confirmGoToBack = function(){
      showAlertService.PopConfirm("提示信息","确定放弃此次修改吗?","取消","确定")
        .then(function(res) {
          if(res) {
            $rootScope.goToBack();
          } else {
          }
        });
    }
});

