angular.module('groupDetail-controller',['ionic'])
  .controller('groupDetailCtrl',function($state,$scope,$rootScope,$stateParams,groupService,$timeout,$ionicPopup,rongcloudService){
    $scope.group = {};
    $scope.joinGroup;

    $scope.init = function(){
      groupService.getGroupById($stateParams.groupId)
        .then(function(result){
          if (!result.result.picture){
            result.result.picture = img.personalImage;
          }
          $scope.group = result.result;
        });

      groupService.judgeGroup($rootScope.user.id, $stateParams.groupId)
        .then(function(result){
          $scope.joinGroup = result.result;
        });
    };

    $scope.joinGroupFlag = false;
    $scope.userJoinGroup = function(groupId){
      if ($scope.joinGroupFlag){
        return;
      }
      $scope.joinGroupFlag = true;
      groupService.joinGroup($rootScope.user.id, groupId)
        .then(function(result){
          $scope.joinGroupFlag = false;
          rongcloudService.joinGroup($scope.group)

          RongCloudLibPlugin.sendCommandNotificationMessage({
              conversationType: 'GROUP',
              targetId: groupId,
              name: 'JoinGroup',
              data: '<a class="JoinGroupUser-'+ $rootScope.user.id +'">"'+ $rootScope.user.nickName + '"</a> 加入了本群'
            },
            function(ret, err) {
              if (ret) {
                if (ret.status == "prepare") {
                  $rootScope.appendNewMsg(ret.result.message);
                }
              }
            }
          );

          var myPopup = $ionicPopup.show({
            title: '加入群组成功。'
          });
          $timeout(function() {
            myPopup.close();
          }, 3000);
          $scope.joinGroup = true;
          $scope.$digest();
        })
    }

    $scope.sendMessage = function(group){
      $rootScope.currentConversationInit();
      $state.go('menu.messageDetail', {targetId: group.id, conversationType: 'GROUP', conversationTitle:group.name});
    }

    $scope.init();

    $scope.$on( "$ionicView.enter", function(){
      $rootScope.currentConversationInit();
    })
});

