/**
 * Created by douhao on 2016/4/25.
 */
angular.module('register-controller',[])
  .controller('RegisterCtrl',function($interval, $scope,$state,$rootScope,$ionicScrollDelegate,UserService,rongcloudService,innermailService, groupService,$ionicLoading,$cordovaKeyboard){
    //var viewScroll = $ionicScrollDelegate.$getByHandle('messageDetailsScroll');
    $scope.registerUser = {
      phone:'',
      randomCode:'',
      password:'',
      confirmPwd:'',
      userName:'',
      email:'',
      location:'',
      hospital:'',
      department:'',
      specialtyPaper:'',
      wechat:'',
      nickName:'',
      isExistPhone:false ,
    }
    $scope.showSuccess = false ;
    $scope.isSubmited = true ;
    //验证Email是否存在

    $scope.randomCodeButtonDisabled = false;
    $scope.randomCodeButtonText = '发送验证码';
    $scope.randomCodeButtonTimes = 0;
    $scope.getRandomCode = function(){
      $scope.isChecked = true ;
      if($scope.myForm.phone.$error.required || $scope.myForm.phone.$error.pattern){
        $scope.myForm.phone.$dirty = true ;
        return ;
      } ;
      $scope.isChecked = false ;
      UserService.getPhoneExist($scope.registerUser.phone)
        .then(function(result){
          if(result.result){
            $scope.registerUser.isExistPhone = true ;
          }else{
            $scope.randomCodeButtonTimes = 60;
            $scope.randomCodeButtonDisabled = true;

            var timer = $interval(function(){
              $scope.randomCodeButtonTimes--;
              $scope.randomCodeButtonText = "重新发送（"+ $scope.randomCodeButtonTimes +"s）";

              if ($scope.randomCodeButtonTimes == 0){
                $scope.randomCodeButtonDisabled = false;
                $scope.randomCodeButtonText = "发送验证码";
                $interval.cancel(timer);
              }
            }, 1000);

            UserService.getRandomCode($scope.registerUser.phone);
          }
        })
    }

    //验证手机账号是否存在
    $scope.isExistPhone = function(){
      UserService.getPhoneExist($scope.registerUser.phone)
        .then(function(result){
          if(result.result){
            $scope.registerUser.isExistPhone = true ;
          }else{
            $scope.register() ;
          }
        })
        .finally(function(){
          $ionicLoading.hide() ;
        })
    }

    $scope.goToBack = function(){
      if($rootScope.isVisible){
        $rootScope.isVisible = false ;
        $rootScope.goToBack() ;
      }else{
        $rootScope.goToBack() ;
      }
    }

    $scope.focusInput = function(){
      $scope.isChecked = false;
    }
    $scope.isChecked = false;
    //注册
    $scope.register = function(){
      $scope.isChecked = true ;
      if($scope.myForm != undefined){
        if($scope.myForm.$error.required != undefined && $scope.myForm.$error.required.length > 0){
          for(var i in $scope.myForm.$error.required){
            $scope.myForm.$error.required[i].$dirty = true ;
          }
          return ;
        }
        if($scope.myForm.$error.pattern != undefined && $scope.myForm.$error.pattern.length > 0){
          for(var i in $scope.myForm.$error.pattern){
            $scope.myForm.$error.pattern[i].$dirty = true ;
          }
          return ;
        }
        if($scope.registerUser.password != $scope.registerUser.confirmPwd){
          $scope.myForm.confirmPwd.$dirty = true ;
          return ;
        }
      }

      if($scope.registerUser.userName.trim() == ""){
        $scope.registerUser.userName = $scope.registerUser.nickName ;
      }
      $scope.isSubmited = false ;
      UserService.savePhoneRegist($scope.registerUser)
        .then(function(result){
          if (result.code == 0){
            $scope.login() ;
          }else if (result.code == 40021){
            $scope.isSubmited = true ;
            $rootScope.$broadcast('message',"验证码错误，请重新获取",3000,"notice");
          }
        })
        .finally(function(){
          $ionicLoading.hide() ;
        })
    }

    //登录
    $scope.login = function(){
      var user = {
        userName:$scope.registerUser.phone,
        password:$scope.registerUser.password,
      }
      UserService.login(user)
        .then(function(result){
          if(result.code != 0){
            //$rootScope.$broadcast("error") ;
          }else{
            //$rootScope.user.userId = result.id ;
            //$rootScope.user.userName = result.name ;
            $scope.showSuccess = true ;
            $scope.isSubmited = false ;
            //保存信息
            localStorage.setItem("user", window.btoa(result.result.phoneNumber));
            localStorage.setItem("pwd", window.btoa(result.result.phonePsd));
            $rootScope.user = result.result ;
            //sessionStorage.user = result

            if(!result.result.personalImage){
              $rootScope.user.personalImage = img.personalImage ;
            }

            // 站内信
            innermailService.getFriendMail($rootScope.user.id)
              .then(function(result){
                if (result.code == 0){
                  var innermails = result.result;
                  $rootScope.newmessage.innerMailList = [];
                  for (var i in innermails){
                    if (innermails[i].title != '站内信' && innermails[i].status == 0){
                      $rootScope.newmessage.innerMailList.push(innermails[i]);
                      $rootScope.newmessage.innerMailCount++;
                    }
                  }
                }
              })

            $state.go('menu.tab.cases') ;

            // 初始化rongCloud
            rongcloudService.getToken($rootScope.user.id)
              .then(function(result){
                rongcloudService.init(result.result.appKey, result.result.token);

                groupService.getGroupsByUserid($rootScope.user.id, '')
                  .then(function(result){
                    var groups = {};
                    groups.groups = [];
                    if (result.code == 0){
                      for(var i in result.result){
                        var group = {id: result.result[i].id, name: result.result[i].name, portraitUrl: !!result.result[i].picture ? result.result[i].picture : img.personalImage};
                        groups.groups.push(group);
                      }
                    }

                    if (groups.groups.length > 0){
                      rongcloudService.syncGroup(groups);
                    }
                  })
              })

          }
        })
    }

    $scope.setName = function(){
      $scope.registerUser.userName = $scope.registerUser.nickName ;
    }
    //注册提交
    $scope.submitForm = function(myForm){
      //console.log($scope.registerUser) ;
      $ionicLoading.show() ;
      $scope.isExistPhone() ;
    }

    $scope.$on('$ionicView.afterEnter', function() {
      $cordovaKeyboard.close();
    }, false);
    //window.addEventListener("native.keyboardshow", function(e){
    //  viewScroll.scrollBottom();
    //});
  });
