angular.module('userDetail-controller',['ionic'])
  .controller('userDetailCtrl',function($state, $scope,UserService,$rootScope,$stateParams,friendService,$ionicPopup,$timeout,$ionicSlideBoxDelegate,$ionicScrollDelegate,HomePageService,learnService){
    var userDetailSlideBox = $ionicSlideBoxDelegate.$getByHandle('userDetailSlideBox');
    $scope.user = {};
    $scope.tabActive = 0 ;
    $scope.tableIsActive = 2 ;
    $scope.diagnoseIsActive = 2 ;
    $scope.canvasIsActive = 2 ;
    $scope.doctorSize = 2 ;
    $scope.isHideSpeciality = true ;
    $scope.isHideAbstract = true ;
    $scope.userAnalyze = "" ;
    $scope.userDiagnosis = [] ;
    $scope.systemTotalAnswer = [] ;
    $scope.EquipmentToalAnswer = [] ;
    $scope.params = {
      page:1,
      pageSize:10,
      hasmore:true,
    }
    $scope.option = {
      title: {
        text: ''
      },
      tooltip: {
        confine:true,
        formatter: function(params) {
          var res = params.name;
          var datas = $scope.option.series[0].data[params.dataIndex].value;
          var names = $scope.option.radar.indicator ;
          for (var i = 0; i < datas.length; i++) {
            if(params.dataIndex == 0){
              if($scope.canvasIsActive == 1){
                res = res + '<br/>'+names[i].name+":"+datas[i]+"%"+'('+($scope.EquipmentToalAnswer[i] === null?0:$scope.EquipmentToalAnswer[i])+')';
              }else if($scope.canvasIsActive == 2){
                res = res + '<br/>'+names[i].name+":"+datas[i]+"%"+'('+($scope.systemTotalAnswer[i] === null?0:$scope.systemTotalAnswer[i])+')';
              }
            }else if(params.dataIndex == 1){
              res = res + '<br/>' +names[i].name+":"+ datas[i] ;
            }
          }
          return res;
        }
      },
      legend: {
        left:"10",
        top:"10",
        data: [{name:'正确率(数量)',icon:"roundRect"},{name:'能力值',icon:"roundRect"}]
      },
      radar: {
        indicator: [],
        name:{
          textStyle:{
            color:'#48b7c4',
          }
        },
        nameGap:2,
        center: ['50%', '50%'],
        radius:'70%',
      },
      series: [{
        name: '预算 vs 开销（Budget vs spending）',
        type: 'radar',
        data : [
          {
            value : [],
            name : '正确率(数量)',
            itemStyle: {
              normal: {
                color: '#55c3cf',
              },
            }
          },
          {
            value : [],
            name : '能力值',
            itemStyle: {
              normal: {
                color: '#cf5555',
              },
            }
          }
        ]
      }]
    };

    $scope.statistics = {
      caseNumber: 0,
      friendNumber: 0,
      saveNumber: 0,
      point: 0
    };
    $scope.caseList = [];
    $scope.isFriend;
    $scope.isSelf = true;

    $scope.init = function(){
      learnService.getUserScore($stateParams.userId)
        .then(function(result){
          if(result.code == 0){
            $scope.statistics.point=JSON.parse(result.result).obj.usableScore ;
          }
        })
      UserService.getUserById($stateParams.userId)
        .then(function(result){
          if (!result.result.personalImage){
            result.result.personalImage = img.personalImage;
          }
          $scope.user = result.result;
        });

      UserService.getMyForumList($stateParams.userId, 1, 1000)
        .then(function(result){
          $scope.caseList = result.result;
        });

      UserService.getStatisticsUser($stateParams.userId)
        .then(function(result){
          $scope.statistics.friendNumber = result.result;
        });

      UserService.getStatistics($stateParams.userId)
        .then(function(result){
          $scope.statistics.saveNumber = result.result.myStore+result.result.myForumStroreNum+result.result.myLearnStroreNum;
          $scope.statistics.caseNumber = result.result.myForumNum;
        });

      //获取医生信息
      HomePageService.getDoctors($scope.doctorSize)
        .then(function(result){
          if(result.code == 0){
            $scope.doctors = result.result ;
          }
        },function(reason){

        })

      friendService.isFriend($rootScope.user.id, $stateParams.userId)
        .then(function(result){
          $scope.isFriend = result.result;
        })

      if ($rootScope.user.id == $stateParams.userId) {
        $scope.isSelf = true;
      }else{
        $scope.isSelf = false;
      }
    };

    $scope.addFriend = function(friendId){
      friendService.addFriend($rootScope.user.id, friendId, 0)
        .then(function(result){
          var myPopup = $ionicPopup.show({
            title: '添加好友申请已经发送。'
          });
          $timeout(function() {
            myPopup.close();
          }, 3000);
        })
    }

    $scope.sendMessage = function(user){
      $rootScope.currentConversationInit();
      $state.go('menu.messageDetail', {targetId: user.id, conversationType: 'PRIVATE', conversationTitle:user.nickName});
    }

    $scope.init();

    $scope.loadMore = function(){
      HomePageService.getPersonalCases($scope.id,$scope.params.page,$scope.params.pageSize)
        .then(function(result){
          if(result.code == 0){
            $scope.caseList = $scope.caseList.concat(result.result) ;
            //当前页等于总页数时，禁止加载更多
            if($scope.params.pageSize > result.result.length){
              $scope.params.hasmore = false ;
            }else{
              $scope.params.page ++;
            }
          }else{
            $scope.params.hasmore = false ;
          }
        },function(reason){
          $scope.params.hasmore = false ;
        })
        .finally(function () {
          $scope.$broadcast("scroll.infiniteScrollComplete");
        });
    }

    $scope.$on( "$ionicView.enter", function(){
      if ($rootScope.currentConversation.conversationType == 'PRIVATE'){
        $rootScope.currentConversationInit();
      }

      $scope.myChart = echarts.init(document.getElementById('userDataMain'));
      UserService.getAnalyzeDataByUserId($stateParams.userId)
        .then(function(result){
          if(result.code == 0){
            $scope.userAnalyze = result.result.userAnalyze ;
            $scope.userAnalyzeDetails = result.result.userAnalyzeDetails ;
            $scope.userDiagnosis = result.result.userDiagnosis ;
            $scope.correctPercentageStyle = {width:$scope.userAnalyze.correctPercentage+"%"} ;
            $scope.abilityValueStyle = {width:$scope.userAnalyze.abilityValue+"%"} ;
            $scope.winPercentageStyle = {width:$scope.userAnalyze.winPercentage+"%"} ;
            $scope.toCanvasTitle($scope.canvasIsActive) ;
          }
        },function(reason){

        })
      $timeout(function(){
        userDetailSlideBox.next() ;
        $timeout(function(){
          userDetailSlideBox.previous() ;
        },2000);
      },2000) ;
    })

    var userDetailScroll = $ionicScrollDelegate.$getByHandle('userDetailScroll');
    $scope.switchTab = function(index){
      if($scope.tabActive != index){
        $scope.tabActive = index ;
      }
      userDetailScroll.resize();
    }

    $scope.toTableTitle = function(index){
      $scope.tableIsActive = index ;
    }

    $scope.toDiagnoseTitle = function(index){
      $scope.diagnoseIsActive = index ;
    }

    $scope.toCanvasTitle = function(index){
      $scope.canvasIsActive = index ;
      $scope.myChart.showLoading();
      $scope.option.radar.indicator = [] ;
      $scope.option.series[0].data[0].value = [] ;
      $scope.option.series[0].data[1].value = [] ;
      $scope.EquipmentToalAnswer = [] ;
      $scope.systemTotalAnswer = [] ;
      for(var i = 0 ; i < $scope.userAnalyzeDetails.length ; i ++){
        if($scope.userAnalyzeDetails[i].type == $scope.canvasIsActive){
          var item = {name: $scope.userAnalyzeDetails[i].name,max : 100} ;
          $scope.option.radar.indicator.push(item) ;
          $scope.option.series[0].data[0].value.push($scope.userAnalyzeDetails[i].correctPercentage == null?0:$scope.userAnalyzeDetails[i].correctPercentage) ;
          $scope.option.series[0].data[1].value.push($scope.userAnalyzeDetails[i].abilityValue == null?0:$scope.userAnalyzeDetails[i].abilityValue) ;
        }
        if($scope.userAnalyzeDetails[i].type == 1){
          $scope.EquipmentToalAnswer.push($scope.userAnalyzeDetails[i].totalAnswer) ;
        }else if($scope.userAnalyzeDetails[i].type == 2){
          $scope.systemTotalAnswer.push($scope.userAnalyzeDetails[i].totalAnswer) ;
        }
      }
      $scope.myChart.setOption($scope.option);
      $scope.myChart.hideLoading();
    }
});

