angular.module('commentDirective', [])

  .directive('commentModule', function () {
    var directiveDefinitionObject = {
      restrict: 'AE',
      templateUrl: 'templates/directive/comment.html',
      replace: true,
      scope: false,
      controller:function($scope, $rootScope, $state, commentService){
        //回复评论
        $scope.comment.reply = function(com){
          $scope.comment.send_content = "" ;
          var repName = !com.userName ? "匿名" : com.userName;
          if (com.parentId > 0){
            $scope.comment.replyModel.parentId =com.parentId;
            $scope.comment.replyModel.mentionUserId = com.userId;
            $scope.comment.send_content = "@" + repName + " ";
            $scope.comment.reply_head = "@" + repName + " ";
          }else{
            $scope.comment.replyModel.parentId =com.id;
            $scope.comment.send_content = "@" + repName + " ";
            $scope.comment.reply_head = "@" + repName + " ";
          }
        }

        $scope.comment.goUserPage = function(userId){
          if (userId != $rootScope.user.id){
            $state.go('menu.userDetail', {'userId': userId});
          }
        }

        //刷新评论
        $scope.comment.flushComment = function(){
          commentService.findComments($scope.comment.carrierId, $scope.comment.carrierType, 1, $scope.comment.params.pageSize)
            .then(function (result) {
              $scope.comment.comments = $scope.comment.changeImgUrl(result.result);
              $scope.comment.params.hasmore = true;
              $scope.comment.params.from = $scope.comment.params.pageSize+1;
              $scope.updateSocial($rootScope.updateSocial.operComment,$rootScope.updateSocial.operationAdd) ;
            })
        }

        //加载更多评论
        $scope.comment.loadMore = function() {
          commentService.findComments($scope.comment.carrierId, $scope.comment.carrierType, $scope.comment.params.from, $scope.comment.params.pageSize)
            .then(function (result) {
              var newComments = $scope.comment.changeImgUrl(result.result);
              var validComments = [];
              for (var i in newComments){
                var validFlag = true;
                for (var j in $scope.comment.comments){
                  if (newComments[i].id == $scope.comment.comments[j].id){
                    validFlag = false;
                    break;
                  }
                }
                if (validFlag){
                  validComments.push(newComments[i]);
                }
              }

              $scope.comment.comments = $scope.comment.comments.concat(validComments);
              //当前页等于总页数时，禁止加载更多
              if (result.result.length < $scope.comment.params.pageSize) {
                $scope.comment.params.hasmore = false;
              }else{
                $scope.comment.params.hasmore = true;
              }
            })
            .finally(function(){
              $scope.comment.params.from += $scope.comment.params.pageSize;
              $scope.$broadcast('scroll.infiniteScrollComplete');
            })
        }
        $scope.comment.loadMore();

        $scope.comment.changeImgUrl = function(list){
          for(var i in list){
            if(!list[i].userImage){
              list[i].userImage = img.personalImage;
            }

            if (!!list[i].subComments){
              for (var j in list[i].subComments){
                if(!list[i].subComments[j].userImage){
                  list[i].subComments[j].userImage = img.personalImage;
                }
              }
            }
          }
          return list;
        }

        $scope.comment.complain = function(dataId, dataType){
          if ($rootScope.user.id <= 0){
            $rootScope.$broadcast('login:show');
          }else{
            $state.go("menu.complain",{'dataId':dataId, 'dataType':dataType}) ;
          }
        }

        $scope.comment.expand = function(id){
          $scope.comment.expandId = id;
        }
        $scope.comment.collapse = function(id){
          $scope.comment.expandId = -1;
        }
      }
    }
    return directiveDefinitionObject;
  })
