angular.module('simpleDirective', [])

  .directive('simpleViewer', function () {
    var directiveDefinitionObject = {
      restrict: 'AE',
      templateUrl: 'templates/directive/viewer.html',
      replace: true,
      scope: false,
      controller:function($scope, $element, $timeout, $ionicGesture, $interval, viewService){

        $scope.view.bigImgList = [];
        $scope.view.tools = {
          isAuto : true,
          isLight : false,// 窗宽窗位
          isLarge : false,// 放大
          isMove : false,// 移动
          isPlay : false,// 播放
          isHelp : false,// 帮助
          isLinkage : false,//联动
        }
        $scope.landscapeFlag = false;

        var lastDragEvent = null;
        var pinchDragEvent = null;
        var thumbnailDragEvent = null;
        var viewPicSwitchEvent = null;
        var isIOS = ionic.Platform.isIOS();
        var isAndroid = ionic.Platform.isAndroid();

        /**** 大图切换开始 ****/
        var viewPicSwitch = angular.element('.view-bigpic-switch');
        $ionicGesture.on("release",function(){
          viewPicSwitchEvent = null;
        }, viewPicSwitch);
        $ionicGesture.on("drag",function(e){
          if (viewPicSwitchEvent == null){
            viewPicSwitchEvent = e;
            return;
          }
          var deltaX = e.gesture.deltaX - viewPicSwitchEvent.gesture.deltaX;
          if (Math.abs(deltaX) < 25){
            return;
          }else{
            viewPicSwitchEvent = e;
          }

          var direction = deltaX > 0 ? 'right' : 'left';
          switch (direction){
            case 'left':
                if ($scope.view.showID == 1){
                  $scope.view.showID = $scope.view.imgCount;
                }else{
                  $scope.view.showID -= 1;
                }
              break;
            case 'right':
              if ($scope.view.showID >= $scope.view.imgCount){
                $scope.view.showID = 1;
              }else{
                $scope.view.showID += 1;
              }
              break;
            default :
              break;
          }
          $scope.$digest()
        }, viewPicSwitch);

        $scope.view.changePic = function(num){
          $scope.view.showID += num;
          if ($scope.view.showID < 1){
            $scope.view.showID = $scope.view.imgCount;
          }
          if ($scope.view.showID > $scope.view.imgCount){
            $scope.view.showID = 1;
          }
        }
        /**** 大图切换结束 ****/


        /**** 缩略图拖拽开始 ****/
        var viewThumbnailDiv = angular.element('.view-thumbnail');
        $ionicGesture.on("release",function(){
          thumbnailDragEvent = null;
        }, viewThumbnailDiv);
        $ionicGesture.on("drag",function(e){
          var direction = e.gesture.direction;
          switch (direction){
            case 'left':
            case 'right':

              if ($scope.landscapeFlag){
                return;
              }

              // 图片少时，缩略图不允许拖拽
              var ulPx = angular.element('.view-thumbnail ul').css("width");
              var divPx = angular.element('.view-thumbnail').css("width");
              var ulNum = parseInt(ulPx.substring(0, ulPx.indexOf('px')));
              var divNum = parseInt(divPx.substring(0, divPx.indexOf('px')));
              if (divNum > ulNum){
                break;
              }

              var deltaX = e.gesture.deltaX;
              if (!!thumbnailDragEvent){
                deltaX = e.gesture.deltaX - thumbnailDragEvent.gesture.deltaX;
              }
              thumbnailDragEvent = e;
              var leftPx = angular.element(".view-thumbnail ul").css('left');
              var leftNum = parseInt(leftPx.substring(0, leftPx.indexOf('px')));


              // 左侧到头
              if (leftNum >= 4 && deltaX > 0){
                break;
              }
              // 右侧到头
              if(divNum - leftNum >= ulNum && deltaX < 0){
                break;
              }

              angular.element(".view-thumbnail ul").css('left','+='+deltaX);
              break;
            case 'up':
            case 'down':

              if (!$scope.landscapeFlag){
                return;
              }

              // 图片少时，缩略图不允许拖拽
              var ulPx = angular.element('.view-thumbnail ul').css("height");
              var divPx = angular.element('.view-thumbnail').css("height");
              var ulNum = parseInt(ulPx.substring(0, ulPx.indexOf('px')));
              var divNum = parseInt(divPx.substring(0, divPx.indexOf('px')));
              if (divNum > ulNum){
                break;
              }

              var deltaY = e.gesture.deltaY;
              if (!!thumbnailDragEvent){
                deltaY = e.gesture.deltaY - thumbnailDragEvent.gesture.deltaY;
              }
              thumbnailDragEvent = e;
              var topPx = angular.element(".view-thumbnail ul").css('top');
              var topNum = parseInt(topPx.substring(0, topPx.indexOf('px')));


              // 上侧到头
              if (topNum >= 4 && deltaY > 0){
                break;
              }
              // 下侧到头
              if(divNum - topNum >= ulNum && deltaY < 0){
                break;
              }

              angular.element(".view-thumbnail ul").css('top','+='+deltaY);
              break;
            default :
              break;
          }
        }, viewThumbnailDiv);
        /**** 缩略图拖拽结束 ****/

        /**** 大图手势事件开始 ****/
        var intervalPinch = 0;
        var intervalDrag = 0;
        var intervalPx = 8;
        if (isIOS){
          intervalPx = 15;
        }
        var startX1 =  0;
        var startY1 =  0;
        var startX2 =  0;
        var startY2 =  0;
        var startDist = 0;
        var startTouch1 = null;
        var startTouch2 = null;
        var endTouch1 = null;
        var endTouch2 = null;
        var viewPicDrag = angular.element('.view-bigpic-drag');

        var webkitFilterTemp = null;
        $ionicGesture.on("pinch",function(e){
          if (pinchDragEvent == null){
            pinchDragEvent = e;
            // 计算拖动开始时两指间距离
            startTouch1 = pinchDragEvent.gesture.touches[0];
            startTouch2 = pinchDragEvent.gesture.touches[1];
            startX1 =  startTouch1.pageX;
            startY1 =  startTouch1.pageY;
            startX2 =  startTouch2.pageX;
            startY2 =  startTouch2.pageY;
            startDist = Math.sqrt(Math.pow((startX2-startX1),2) + Math.pow((startY2-startY1),2));

            if($scope.view.tools.isLinkage){
              webkitFilterTemp = angular.element(".view-pics img").css("-webkit-filter");
              angular.element(".view-pics img").css("-webkit-filter", "none");
            }else{
              webkitFilterTemp = angular.element("#img-" + $scope.view.showID).css("-webkit-filter");
              angular.element("#img-" + $scope.view.showID).css("-webkit-filter", "none");
            }
            return;
          }

          intervalPinch++;
          if (intervalPinch%3 != 0){
            return;
          }

          // 计算当前两指间距离
          endTouch1 = e.gesture.touches[0];
          endTouch2 = e.gesture.touches[1];
          var endX1 =  endTouch1.pageX;
          var endY1 =  endTouch1.pageY;
          var endX2 =  endTouch2.pageX;
          var endY2 =  endTouch2.pageY;
          var endDist = Math.sqrt(Math.pow((endX2-endX1),2) + Math.pow((endY2-endY1),2));
          if (Math.abs(endDist - startDist) > intervalPx){
            if (endDist > startDist){
              $scope.view.changeSize('down');
            }else{
              $scope.view.changeSize('up');
            }
          }else{
            $scope.view.changePosition(endX1-startX1, endY1-startY1);
          }

          pinchDragEvent = e;
          startTouch1 = pinchDragEvent.gesture.touches[0];
          startTouch2 = pinchDragEvent.gesture.touches[1];
          startX1 =  startTouch1.pageX;
          startY1 =  startTouch1.pageY;
          startX2 =  startTouch2.pageX;
          startY2 =  startTouch2.pageY;
          startDist = Math.sqrt(Math.pow((startX2-startX1),2) + Math.pow((startY2-startY1),2));
        }, viewPicDrag);
        $ionicGesture.on("release",function(){
          lastDragEvent = null;
          pinchDragEvent = null;
          startX1 =  0;
          startY1 =  0;
          startX2 =  0;
          startY2 =  0;
          startDist = 0;
          intervalDrag = 0;
          intervalPinch = 0;

          if($scope.view.tools.isLinkage){
            angular.element(".view-pics img").css("-webkit-filter", webkitFilterTemp);
          }else{
            angular.element("#img-" + $scope.view.showID).css("-webkit-filter", webkitFilterTemp);
          }
          webkitFilterTemp = null;
        }, viewPicDrag);
        //拖拽
        $ionicGesture.on("drag",function(e){
          if (e.gesture.touches.length > 1){
            return;
          }

          intervalDrag++;
          if (intervalDrag%3 != 0){
            return;
          }

          var deltaX = e.gesture.deltaX;
          var deltaY = e.gesture.deltaY;
          if (!!lastDragEvent){
            deltaX = e.gesture.deltaX - lastDragEvent.gesture.deltaX;
            deltaY = e.gesture.deltaY - lastDragEvent.gesture.deltaY;
          }else{
            if ($scope.view.tools.isLarge || $scope.view.tools.isMove){
              if($scope.view.tools.isLinkage){
                webkitFilterTemp = angular.element(".view-pics img").css("-webkit-filter");
                angular.element(".view-pics img").css("-webkit-filter", "none");
              }else{
                webkitFilterTemp = angular.element("#img-" + $scope.view.showID).css("-webkit-filter");
                angular.element("#img-" + $scope.view.showID).css("-webkit-filter", "none");
              }
            }
          }

          var absX = Math.abs(deltaX);
          var absY = Math.abs(deltaY);
          if (absX > 5 || absY > 5){
            lastDragEvent = e;
          }else{
            return;
          }

          // 计算移动方向
          var direction = '';
          if (absX > absY){
            if (deltaX > 0){
              direction = 'right';
            }else{
              direction = 'left';
            }
          }else{
            if (deltaY > 0){
              direction = 'down';
            }else{
              direction = 'up';
            }
          }

          switch (direction){
            case 'up':
            case 'down':
              if ($scope.view.tools.isAuto || $scope.view.tools.isLight){
                $scope.view.changeGrey(direction);
              }else if($scope.view.tools.isLarge){
                $scope.view.changeSize(direction);
              }else if($scope.view.tools.isMove){
                $scope.view.changePosition(deltaX, deltaY);
              }
              break;
            case 'left':
            case 'right':
              if ($scope.view.tools.isAuto || $scope.view.tools.isLight){
                $scope.view.changeLight(direction);
              }else if($scope.view.tools.isLarge){
                $scope.view.changeSize(direction);
              }else if($scope.view.tools.isMove){
                $scope.view.changePosition(deltaX, deltaY);
              }
              break;
          }
        }, viewPicDrag);

        $scope.view.changeLight = function(direction){
          if ($scope.view.tools.isAuto){
            $scope.view.viewOperLog("auto","窗宽窗位","auto");
          }else{
            $scope.view.viewOperLog("窗宽窗位","窗宽窗位","other");
          }

          var adjust =  0.2;
          var reg = /\-?[0-9]+\.?[0-9]*/g;
          var contrast = 1;
          var brightness = 1;
          var webkitFilter = angular.element("#img-" + $scope.view.showID).css("-webkit-filter");
          if (webkitFilter != "none"){
            var webkitFilterArray = webkitFilter.match(reg);
            contrast = parseFloat(webkitFilterArray[0]);
            brightness = parseFloat(webkitFilterArray[1]);
          }
          if($scope.view.tools.isLinkage){
            if(direction == 'left'){
              angular.element(".view-pics img").css("-webkit-filter","contrast("+contrast+") brightness("+(brightness-adjust)+")");
            }else{
              angular.element(".view-pics img").css("-webkit-filter","contrast("+contrast+") brightness("+(brightness+adjust)+")");
            }
          }else{
            if(direction == 'left'){
              angular.element("#img-" + $scope.view.showID).css("-webkit-filter","contrast("+contrast+") brightness("+(brightness-adjust)+")");
            }else{
              angular.element("#img-" + $scope.view.showID).css("-webkit-filter","contrast("+contrast+") brightness("+(brightness+adjust)+")");
            }
          }
        }

        $scope.view.changeGrey = function(direction){
          if ($scope.view.tools.isAuto){
            $scope.view.viewOperLog("auto","窗宽窗位","auto");
          }else{
            $scope.view.viewOperLog("窗宽窗位","窗宽窗位","other");
          }

          var adjust =  0.2;
          var reg = /\-?[0-9]+\.?[0-9]*/g;
          var contrast = 1;
          var brightness = 1;
          var webkitFilter = angular.element("#img-" + $scope.view.showID).css("-webkit-filter");
          if (webkitFilter != "none"){
            var webkitFilterArray = webkitFilter.match(reg);
            contrast = parseFloat(webkitFilterArray[0]);
            brightness = parseFloat(webkitFilterArray[1]);
          }

          if($scope.view.tools.isLinkage){
            if(direction == 'up'){
              angular.element(".view-pics img").css("-webkit-filter","contrast("+(contrast-adjust)+") brightness("+brightness+")");
            }else{
              angular.element(".view-pics img").css("-webkit-filter","contrast("+(contrast+adjust)+") brightness("+brightness+")");
            }
          }else{
            if(direction == 'up'){
              angular.element("#img-" + $scope.view.showID).css("-webkit-filter","contrast("+(contrast-adjust)+") brightness("+brightness+")");
            }else{
              angular.element("#img-" + $scope.view.showID).css("-webkit-filter","contrast("+(contrast+adjust)+") brightness("+brightness+")");
            }
          }
        }

        $scope.view.changePosition = function(x,y){
          if ($scope.view.tools.isAuto){
            $scope.view.viewOperLog("auto","移动","auto");
          }else{
            $scope.view.viewOperLog("移动","移动","other");
          }

          var reg = /\-?[0-9]+\.?[0-9]*/g;
          var translate = angular.element("#img-" + $scope.view.showID).css("webkitTransform");
          var array = translate.match(reg) ;
          if (!!array){
            array[4] = parseFloat(array[4]) + parseFloat(x);
            array[5] = parseFloat(array[5]) + parseFloat(y);
          }else{
            array = [1,0,0,1,x,y]
          }

          if($scope.view.tools.isLinkage){
            angular.element(".view-pics img").css("webkitTransform", "matrix("+array[0]+", "+array[1]+", "+array[2]+", "+array[3]+", "+array[4]+", "+array[5]+")");
          }else{
            angular.element("#img-" + $scope.view.showID).css("webkitTransform", "matrix("+array[0]+", "+array[1]+", "+array[2]+", "+array[3]+", "+array[4]+", "+array[5]+")");
          }
        }

        $scope.view.changeSize = function(direction){
          if ($scope.view.tools.isAuto){
            $scope.view.viewOperLog("auto","缩放","auto");
          }else{
            $scope.view.viewOperLog("缩放","缩放","other");
          }

          var reg = /\-?[0-9]+\.?[0-9]*/g;
          var translate = angular.element("#img-" + $scope.view.showID).css("webkitTransform");
          var array = translate.match(reg) ;

          var adjust = 0.04;
          if (isIOS){
            adjust = 0.1;
          }

          switch (direction){
            case 'up':
            case 'left':
              if (!!array){
                if (array[0] > 0.1){
                  array[0] = parseFloat(array[0]) - adjust;
                  array[3] = parseFloat(array[3]) - adjust;
                }
              }else{
                array = [1-adjust,0,0,1-adjust,0,0];

              }

              if ($scope.view.tools.isLinkage){
                angular.element(".view-pics img").css('webkitTransform', "matrix("+array[0]+", "+array[1]+", "+array[2]+", "+array[3]+", "+array[4]+", "+array[5]+")");
              }else{
                angular.element("#img-" + $scope.view.showID).css('webkitTransform', "matrix("+array[0]+", "+array[1]+", "+array[2]+", "+array[3]+", "+array[4]+", "+array[5]+")");
              }
              break;
            case 'down':
            case 'right':
              if (!!array){
                array[0] = parseFloat(array[0]) + adjust;
                array[3] = parseFloat(array[3]) + adjust;
              }else{
                array = [1+adjust,0,0,1+adjust,0,0];
              }
              if ($scope.view.tools.isLinkage){
                angular.element(".view-pics img").css('webkitTransform', "matrix("+array[0]+", "+array[1]+", "+array[2]+", "+array[3]+", "+array[4]+", "+array[5]+")");
              }else{
                angular.element("#img-" + $scope.view.showID).css('webkitTransform', "matrix("+array[0]+", "+array[1]+", "+array[2]+", "+array[3]+", "+array[4]+", "+array[5]+")");
              }
              break;
          }
        }
        /**** 大图手势事件结束 ****/

        /**** 工具栏事件开始 ****/
        $scope.view.goBack = function(){
          $scope.view.showView = false;
        }

        var playTimer = null;
        $scope.view.setTools = function(buttonName){
          switch(buttonName) {
            case "auto":
              $scope.view.buttonReset();
              $scope.view.tools.isAuto=true;
              break;
            case "contrast":
              $scope.view.buttonReset();
              $scope.view.tools.isLight=true;
              break;
            case "large":
              $scope.view.buttonReset();
              $scope.view.tools.isLarge=true;
              break;
            case "move":
              $scope.view.buttonReset();
              $scope.view.tools.isMove=true;
              break;
            case "play":
              if ($scope.view.tools.isPlay){
                $scope.view.tools.isPlay=false;
                $scope.view.tools.isAuto=true;
                if (!!playTimer){
                  $interval.cancel(playTimer);
                }
              }else{
                $scope.view.buttonReset();
                $scope.view.tools.isPlay=true;

                playTimer = $interval(function() {
                  $scope.view.showID += 1;
                  if ($scope.view.showID > $scope.view.imgCount){
                    $scope.view.showID = 1;
                  }
                }, 2000);
                $scope.view.viewOperLog("播放","播放","other");
              }
              break;
            case "help":
              if ($scope.view.tools.isHelp){
                $scope.view.tools.isHelp=false;
              }else{
                $scope.view.tools.isHelp=true;
                $scope.view.viewOperLog("帮助","帮助","other");
              }
              break;
            case "linkage":
              if ($scope.view.tools.isLinkage){
                $scope.view.tools.isLinkage = false;
              }else{
                $scope.view.tools.isLinkage = true;
                $scope.view.viewOperLog("联动","联动","other")
              }
              break;
            case "reset":
              if($scope.view.tools.isLinkage){
                angular.element(".view-pics img").css("-webkit-filter","none");
                angular.element(".view-pics img").css("webkitTransform", "matrix(1,0,0,1,0,0)");
              }else{
                angular.element("#img-" + $scope.view.showID).css("-webkit-filter","none");
                angular.element("#img-" + $scope.view.showID).css("webkitTransform", "matrix(1,0,0,1,0,0)");
              }
              break;
            default:
              break;
          }
        }

        $scope.view.buttonReset = function(){
          $scope.view.tools.isAuto=false;
          $scope.view.tools.isLight=false;
          $scope.view.tools.isLarge=false;
          $scope.view.tools.isMove=false;
          $scope.view.tools.isPlay=false;

          if (!!playTimer){
            $interval.cancel(playTimer);
          }
        }
        /**** 工具栏事件结束 ****/

        // 自动调节图片大小
        $scope.view.autoResizeImage = function(){
          for(var i in $scope.view.bigImgList){
            var index = parseInt(i) + 1;
            var img = angular.element("#img-" + index);
            var objImgWidth = img.css("width");
            var objImgHeight = img.css("height");
            if (!objImgWidth || objImgWidth == '0px'){
              return;
            }
            var maxWidth = parseInt(angular.element('.view-pics').width());
            var maxHeight = parseInt(angular.element('.view-pics').height());
            var hRatio;
            var wRatio;
            var Ratio = 1;
            var w = parseInt(objImgWidth.substring(0, objImgWidth.indexOf("px")));
            var h = parseInt(objImgHeight.substring(0, objImgHeight.indexOf("px")));
            wRatio = maxWidth / w;
            hRatio = maxHeight / h;

            Ratio = (wRatio <= hRatio ? wRatio : hRatio);
            w = w * Ratio;
            h = h * Ratio;

            var left = 0;
            if (w < maxWidth) {
              left = (maxWidth - w) / 2;
            }
            var top = 0;
            if (h < maxHeight) {
              top = (maxHeight - h) / 2;
            }
            img.css("left", left + "px");
            img.css("top", top + "px");
            img.css("width", w + "px");
            img.css("height", h + "px");
          }
        }

        $scope.$watch('view.showView', function(newValue, oldValue) {
          if (newValue){
            for(var i in $scope.view.imgList){
              $scope.view.bigImgList.push($scope.view.imgList[i]);
            }
            if ($scope.landscapeFlag){
              angular.element('.view-thumbnail ul').css("height", 10+$scope.view.imgCount*64);
              angular.element('.view-thumbnail ul').css("width", 64);
            }else{
              angular.element('.view-thumbnail ul').css("width", 10+$scope.view.imgCount*64);
              angular.element('.view-thumbnail ul').css("height", 64);
            }
          }else{
            $scope.view.bigImgList = [];
            angular.element('.view-thumbnail ul').css("left", 4);
            angular.element('.nav-bar-container').show();
          }
        });

        $scope.$watch('view.showID', function(newValue, oldValue) {
          if (newValue){
            $timeout(function() {
            }, 100)
          }else{
            $scope.view.bigImgList = [];
          }
        });

        $scope.view.dcmImageCut = function (id) {
          $scope.view.showID = id;
          $scope.view.viewOperLog("导航","导航","other");
        }

        $scope.view.doOnOrientationChange = function(resizeFlag){
          $timeout(function() {
            var screenHeight = window.innerHeight;
            var screenWidth = window.innerWidth;

            switch(window.orientation){
              case -90:
              case 90:
                $scope.landscapeFlag = true;
                if (isIOS){
                  screenHeight = window.screen.width;
                  screenWidth = window.screen.height;
                }
                angular.element('.view-pics').css("height", screenHeight-5);
                angular.element('.view-pics').css("width", screenWidth-120);
                angular.element('.view-pics').css("top", 0);
                angular.element('.view-pics').css("left", 70);
                angular.element('.view-thumbnail ul').css("height", 10+$scope.view.imgCount*64);
                angular.element('.view-thumbnail ul').css("width", 64);
                angular.element('.view-thumbnail ul').css("left", 0);
                angular.element('.view-thumbnail ul').css("top", 4);
                break;
              default:
                $scope.landscapeFlag = false;
                angular.element('.view-pics').css("height", screenHeight-125);
                angular.element('.view-pics').css("width", screenWidth);
                angular.element('.view-pics').css("top", 50);
                angular.element('.view-pics').css("left", 0);
                angular.element('.view-thumbnail ul').css("width", 10+$scope.view.imgCount*64);
                angular.element('.view-thumbnail ul').css("height", 64);
                angular.element('.view-thumbnail ul').css("left", 4);
                angular.element('.view-thumbnail ul').css("top", 0);
                break;
            }

            if (!!resizeFlag){
              $scope.view.autoResizeImage();
            }

            $scope.$apply();
          }, 250)
        }
        window.addEventListener('orientationchange', $scope.view.doOnOrientationChange);
        $scope.view.doOnOrientationChange(false);

        //操作记录
        var viewerOper ={"autoButton":{},"otherButton":{}};

        $scope.view.viewOperLog = function(button,func,buttonType){
          if(buttonType == "auto"){
            if(!viewerOper.autoButton.hasOwnProperty(func)){
              viewerOper.autoButton[func] = func;
              viewService.addViewerOperLog($scope.view.oper.caseType,$scope.view.oper.caseId,button,func,$scope.view.oper.maxId);
            }
          }
          else{
            if(!viewerOper.otherButton.hasOwnProperty(button)){
              viewerOper.otherButton[button] = func;
              viewService.addViewerOperLog($scope.view.oper.caseType,$scope.view.oper.caseId,button,func,$scope.view.oper.maxId);
            }
          }
        }
      }
    }

    return directiveDefinitionObject;
  })
