/**
 * Created by douhao on 2016/4/12.
 */
angular.module('starter.filter', [])
  .filter('myDateFilter', function() {
    return function(dataBaseDate) {
      var nowDate = moment(new Date());
      //console.log("nowDate=" + nowDate);
      var endDate = moment(dataBaseDate);
      //console.log("end_date=" + endDate);
      var date3 = nowDate.diff(endDate);

      var end_date = new Date(endDate);
      //计算出相差天数
      var days=Math.floor(date3/(24*3600*1000))

      //计算出小时数
      var leave1=date3%(24*3600*1000)    //计算天数后剩余的毫秒数
      var hours=Math.floor(leave1/(3600*1000))

      //计算相差分钟数
      var leave2=leave1%(3600*1000)        //计算小时数后剩余的毫秒数
      var minutes=Math.floor(leave2/(60*1000))

      //计算相差秒数
      var leave3=leave2%(60*1000)      //计算分钟数后剩余的毫秒数
      var seconds=Math.round(leave3/1000)

      //console.log(" 相差 "+days+"天 "+hours+"小时 "+minutes+" 分钟"+seconds+" 秒")
      if(days > 0){
        var y = end_date.getFullYear();
        var m =(end_date.getMonth() + 1).toString();
        var d = (end_date.getDate()).toString();
        if (m.length == 1) {
           m= "0" + m;
        }
        if (d.length == 1) {
          d = "0" + d;
        }
        return y + '年' + m + '月' + d + '日';
      }else if(hours > 0){
        return hours + "小时前";
      }else if(minutes > 0){
        return minutes + "分钟前";
      }else if(seconds > 0){
        return seconds + "秒前";
      }else{
        return "刚刚";
      }

    };
  })
  .filter('messageTimeFilter', function($rootScope) {
    return function(index1, messageId, index2) {
      var currentMsg = $rootScope.currentConversation.messageList[index1];
      var lastMsg = $rootScope.currentConversation.messageList[index2];

      if (!!lastMsg && currentMsg.sentTime-lastMsg.sentTime < 5 * 60 * 1000 && currentMsg.messageId != messageId){
        return "";
      }


      var date = new Date(currentMsg.sentTime);
      var month = date.getMonth() + 1;
      var day = date.getDate();
      var hour = date.getHours();
      if (hour < 10){
        hour = '0'+hour;
      }
      var minute = date.getMinutes();
      if (minute < 10){
        minute = '0'+minute;
      }

      var now = new Date();
      var yest = new Date();
      yest.setDate(now.getDate()-1);

      if (now.getMonth()==date.getMonth() && now.getDate()==date.getDate()) {
        return hour+":"+minute;
      }else if(yest.getMonth()==date.getMonth() && yest.getDate()==date.getDate()) {
        return "昨天 "+hour+":"+minute;
      }else{
        return month+"月"+day+"日 "+hour+":"+minute;
      }
    };
  })
  .filter('messageTimeShowFilter', function($rootScope) {
    return function(index1, messageId,index2) {
      var currentMsg = $rootScope.currentConversation.messageList[index1];
      var lastMsg = $rootScope.currentConversation.messageList[index2];

      if (!!lastMsg && currentMsg.sentTime-lastMsg.sentTime < 5 * 60 * 1000 && currentMsg.messageId != messageId){
        return false;
      }
      return true;
    };
  })
  .filter('replaceString',function() {
    return function (str,replaceStr) {
      if (str == null || str == "" || str == "undefined" || str == "0") {
        return replaceStr
      } else {
        return str;
      }
    }
  })
  .filter('ageFilter',function() {
    return function (str) {
      //if(str.indexOf("y") != -1){
      //  return str.replace
      //}

      if (str == null || str == "" || str == "undefined") {
        return ""
      }else{
        var age = str.replace("Y","").replace("M","").replace("W","").replace("D","").replace("H","") ;
        if(age == "null" || age == "" || age == "undefined"){
          return ""
        }else{
          str = str.replace("Y","岁") ;
          str = str.replace("M","月") ;
          str = str.replace("W","周") ;
          str = str.replace("D","天") ;
          str = str.replace("H","时") ;
        }
      }

      return str ;
    }
  })
  .filter('formatDate',function() {
    return function (str) {
      if(str != null && str != undefined && str.length>5){
        str = str.substring(2,str.length-5) ;
      }
      return str;
    }
  })
  .filter('flexToHtml',function() {
    return function (str) {
      if(str != undefined){
        str = str.replace(/<\/?font[^>]*>/gi,"");
      }
      return str;
    }
  })
  .filter('formatInt', function () {
    return function (str) {
      if (str == null || str == "" || str == "undefined" || str == "0") {
        return "0"
      }else if (parseInt(str) > 1000 && parseInt(str) <10000) {
        var s = parseFloat(parseInt(str)/1000).toFixed(1);
        return s+"千";
      }else if (parseInt(str) > 10000 && parseInt(str) <10000000) {
        var s = parseFloat(parseInt(str)/10000).toFixed(1) ;
        return s+"万";
      } else if(parseInt(str) > 10000000) {
        var s = parseFloat(parseInt(str)/10000000).toFixed(1) ;
        return s+"千万";
      }else{
        return str;
      }
    }
  })
  .filter('userImageFilter',function() {
    return function (str, size) {

      if (!!str && str.indexOf('http') > -1){
        if (str.indexOf('aliyuncs') > -1){
          str = str.replace("oss","img");
          str = str.replace("https","http") ;
          if (str.indexOf('@') == -1){
            str = str + '@' + size + 'w_' + size + 'h_1o'
          }
        }
      }else{
        str = img.personalImage;
      }

      return str;
    }
  })
  .filter('tilesPFilter',function() {
    return function (str) {
      if (!!str && str.length > 23) {
        return str.substring(0, 23) + '...';
      }
      return str;
    }
  })

  .filter('casePFilter',function() {
    return function (str) {
      if (!!str && str.length > 48) {
        return str.substring(0, 48) + '...';
      }
      return str;
    }
  })
  .filter('caseIsNewest',function(){
    return function (caseDate,diffTyep,diff) {
      var nowDate = moment();
      //console.log("nowDate=" + nowDate);
      var endDate = moment(caseDate);
      if(nowDate.diff(endDate,diffTyep) < diff){
        return true ;
      }else{
        return false ;
      }
    }
  })
  .filter('templateMsgListFilter',function() {
    return function (str) {
      if (!!str){

        if (str.startsWith('TEMPMSG-')){
          str = '[模板消息]';
        }

        str = str.replace(/<br\/>/g, '\n');
        str = str.replace(/&lt;/g, '<');
        str = str.replace(/&gt;/g, '>');

        while (str.indexOf('>') > str.indexOf('<')){
          var startIdx = str.indexOf('<');
          var endIdx = str.indexOf('>')+1;
          var tempStr = str.substring(startIdx,endIdx);
          str = str.replace(tempStr, '');
        }
      }
      return str;
    }
  })

  .filter('templateMsgFilter',function() {
    return function (str, para) {
      if (!!str){

        if (!str.startsWith('TEMPMSG-')){
          return str;
        }

        var tempMsg = JSON.parse(str.replace('TEMPMSG-','') );

        if (para == 'title'){
          return tempMsg.title;
        }else if (para == 'content'){
          return tempMsg.content;
        }else if (para == 'image'){
          if (!tempMsg.image){
            return img.personalImage;
          }
          var imageStr = tempMsg.image;
          if (imageStr.indexOf('aliyuncs') > -1){
            imageStr = imageStr.replace("oss","img");
            imageStr = imageStr.replace("https","http");
            if (imageStr.indexOf('@') == -1){
              imageStr = imageStr + '@50w_50h_1o'
            }
          }
          return imageStr;
        }else if (para == 'clickable'){
          return tempMsg.clickable;
        }
      }
      return str;
    }
  })

  .filter('messageExtraFilter',function() {
    return function (str) {
      if (!!str){
        return str.split(' | ')[1];
      }
      return '';
    }
  })
  .filter('replaceImgUrl',function(){
    return function (str,flagStr1,flagStr2,replaceStr) {
      if(str == undefined){
        return "" ;
      }
      str = str.replace("oss","img") ;
      str = str.replace("https","http") ;
      if (flagStr1 != ""　&& str.indexOf(flagStr1) != -1) {
        return str.replace(flagStr1,replaceStr) ;
      } else if(flagStr2 != "" &&str.indexOf(flagStr2) != -1){
        return str.replace(flagStr2,replaceStr) ;
      } else {
        return str+replaceStr;
      }
    }
  })
  .filter('formatDecimals',function(){
    return function (str) {
      if(str == null || isNaN(str)|| str == undefined ){
        return "" ;
      }else{
        str = (parseFloat(str)*100).toFixed(0) + "%" ;
        return str ;
      }
    }
  })
  .filter('pPlaceFilter',function() {
    return function (str) {
      if (!!str) {
        str = str.replace(/ /g, "&nbsp;");
      }
      return str;
    }
  })
  .filter('formatTime',function() {
    return function (str,start,length) {
      if(str != null && str != undefined && str.length>length){
        str = str.substring(start,str.length-length) ;
      }
      return str;
    }
  })
  .filter('replaceAnalyze',function() {
    return function (str,replaceStr,addStr) {
      if (str === null || str === "" || str === "undefined") {
        return replaceStr
      } else {
        if(addStr){
          return str+addStr;
        }else{
          return str ;
        }
      }
    }
  })
