/**
 * Created by douhao on 2016/4/6.
 */
angular.module('starter.routes', [])

  .config(function($stateProvider, $urlRouterProvider) {

    $stateProvider
      .state('guidepage' ,{
        url: '/guide-page',
        templateUrl:'templates/guide-page.html',
        controller:'GuidePageCtrl'
      })
      .state('signin', {
        url: '/sign-in',
        cache:false ,
        templateUrl: 'templates/user/sign-in.html',
        controller: 'SignInCtrl'
      })
      .state('register', {
        url: '/register',
        cache:false ,
        templateUrl: 'templates/user/register.html',
        controller: 'RegisterCtrl'
      })
      .state('retrievePwd', {
        url: '/retrievePwd',
        cache:false ,
        templateUrl: 'templates/user/retrieve-pwd.html',
        controller: 'RetrievePwdCtrl'
      })
      .state('bound', {
        url: '/bound',
        cache:false ,
        params:{"weChatUserInfo":""},
        templateUrl: 'templates/user/bound.html',
        controller: 'BoundCtrl'
      })
      .state('menu.search', {
        url: '/search',
        views: {
          'menuContent': {
            templateUrl: 'templates/home/search.html',
            controller: 'SearchCtrl'
          }
        }
      })
      .state('menu', {
        url: '/menu',
        abstract: true,
        templateUrl: 'templates/home/menu.html',
        controller: 'NavController'
      })
      // setup an abstract state for the tabs directive
      .state('menu.tab', {
        url: '/tab',
        abstract: true,
        views: {
          'menuContent': {
            templateUrl: 'templates/home/tabs.html',
            controller: 'TabController'
          }
        }
      })

      //.state('menu.setting', {
      //  url: '/setting',
      //  views: {
      //    'menuContent': {
      //      templateUrl: 'templates/personal/setting.html',
      //      controller: 'SettingCtrl'
      //    }
      //  }
      //})
      .state('menu.tab.personal', {
        url: '/personal',
        views: {
          'tab-personal': {
            templateUrl: 'templates/personal/personal.html',
            controller:"TabController"
          }
        }
      })
      .state('menu.personalHomePage', {
        url: '/personalHomePage',
        views: {
          'menuContent': {
            templateUrl: 'templates/personal/personal-homePage.html',
            controller:"personalHomePageCtrl"
          }
        }
      })
      .state('menu.personalIntegral', {
        url: '/personalIntegral',
        views: {
          'menuContent': {
            templateUrl: 'templates/personal/personal-integral.html',
            controller: 'personalIntegralCtrl'
          }
        }
      })
      .state('menu.personalCase', {
        url: '/personalCase',
        cache:false,
        views: {
          'menuContent': {
            templateUrl: 'templates/personal/personal-case.html',
            controller: 'personalCaseCtrl'
          }
        }
      })
      .state('menu.personalCollect', {
        url: '/personalCollect',
        views: {
          'menuContent': {
            templateUrl: 'templates/personal/personal-collect.html',
            controller: 'personalCollectCtrl'
          }
        }
      })
      .state('menu.personalInvite', {
        url: '/personalInvite',
        views: {
          'menuContent': {
            templateUrl: 'templates/personal/personal-invite.html',
            controller: 'personalInviteCtrl',
          }
        }
      })
      .state('menu.upgrade', {
        url: '/upgrade',
        views: {
          'menuContent': {
            templateUrl: 'templates/personal/personal-upgrade.html',
            controller: 'personalUpgradeCtrl'
          }
        }
      })
      .state('menu.validation', {
        url: '/validation',
        cache:false ,
        views: {
          'menuContent': {
            templateUrl: 'templates/personal/personal-validation.html',
            controller: 'personalValidationCtrl'
          }
        }
      })
      .state('menu.tab.friends', {
        url: '/friends',
        views: {
          'tab-friends': {
            templateUrl: 'templates/friend/friends.html',
            controller: 'friendsCtrl'
          }
        }
      })
      .state('menu.addFriend', {
        url: '/addFriend/:type',
        views: {
          'menuContent': {
            templateUrl: 'templates/friend/addFriend.html',
            controller: 'addFriendsCtrl'
          }
        }
      })
      .state('menu.messageDetail', {
        url: '/messageDetail/:targetId/:conversationType/:conversationTitle',
        //cache:false ,
        views: {
          'menuContent': {
            templateUrl: 'templates/friend/messageDetail.html',
            controller: 'messageDetailCtrl'
          }
        }
      })
      .state('menu.userDetail', {
        url: '/userDetail/:userId',
        cache:false ,
        views: {
          'menuContent': {
            templateUrl: 'templates/user/user-detail.html',
            controller: 'userDetailCtrl'
          }
        }
      })
      .state('menu.groupDetail', {
        url: '/groupDetail/:groupId',
        cache:false ,
        views: {
          'menuContent': {
            templateUrl: 'templates/user/group-detail.html',
            controller: 'groupDetailCtrl'
          }
        }
      })
      .state('menu.groupMembers', {
        url: '/groupMembers/:groupId',
        cache:false ,
        views: {
          'menuContent': {
            templateUrl: 'templates/friend/groupMembers.html',
            controller: 'groupMembersCtrl'
          }
        }
      })
      .state('menu.groupUpdate', {
        url: '/groupUpdate/:groupId/:type',
        views: {
          'menuContent': {
            templateUrl: 'templates/friend/groupUpdate.html',
            controller: 'groupUpdateCtrl'
          }
        }
      })
      .state('menu.membersList', {
        url: '/membersList/:groupId/:manageUserid',
        cache:false ,
        views: {
          'menuContent': {
            templateUrl: 'templates/friend/membersList.html',
            controller: 'membersListCtrl'
          }
        }
      })
      .state('menu.addMember', {
        url: '/addMember/:groupId',
        cache:false ,
        views: {
          'menuContent': {
            templateUrl: 'templates/friend/addMember.html',
            controller: 'addMemberCtrl'
          }
        }
      })
      .state('menu.personalCenter', {
        url: '/personalCenter',
        views: {
          'menuContent': {
            templateUrl: 'templates/personal/personal-center.html',
            controller: 'personalCenterCtrl'
          }
        }
      })
      .state('menu.personalCenterUp', {
        url: '/personalCenterUp/:type',
        views: {
          'menuContent': {
            templateUrl: 'templates/personal/personal-center-update.html',
            controller: 'personalCenterUpCtrl'
          }
        },
        data: {isPrivate: true}    //为路由添加该属性，判断是否为匿名路由
      })
      .state('menu.personalCenterUpdateImage', {
        url: '/personalCenterUpdateImage',
        cache: false,
        views: {
          'menuContent': {
            templateUrl: 'templates/personal/personal-center-updateimage.html',
            controller: 'personalCenterUpdateImageCtrl'
          }
        }
      })
      .state('menu.personalChallenge', {
        url: '/personalChallenge',
        cache: false,
        views: {
          'menuContent': {
            templateUrl: 'templates/personal/personal-challenge.html',
            controller: 'personalChallengeCtrl'
          }
        }
        //views: {
        //  'menuContent': {
        //    templateUrl: 'templates/personal/personal-challenge.html',
        //    controller: 'personalChallengeCtrl'
        //  }
        //}
      })
      //系统设置页面
      .state('menu.personalSystemSetting',{
      	url:'/personalSystemSetting',
      	views: {
          'menuContent': {
            templateUrl: 'templates/personal/personal-systemSetting.html',
            controller: 'personalSettingCtrl'
          }
        }
      })
      //用户设置页面
      .state('menu.personalUserSetting',{
      	url:'/personalUserSetting',
      	views: {
          'menuContent': {
            templateUrl: 'templates/personal/personal-userSetting.html',
            controller: 'personalUserSettingCtrl'
          }
        }
      })
      //联系我们页面
      .state('menu.connectUs',{
      	url:'/connectUs',
      	views: {
          'menuContent': {
            templateUrl: 'templates/personal/aboutApp/connectUs.html',
            controller: ''
          }
        }
      })
		//    服务条款页面
      .state('menu.aboutYingLink',{
      	url:'/aboutYingLink',
      	views: {
          'menuContent': {
            templateUrl: 'templates/personal/aboutApp/aboutYingLink.html',
            controller: ''
          }
        }
      })
      // Each tab has its own nav history stack:
      .state('menu.tab.homepage', {
        url: '/homepage',
        views: {
          'tab-homepage': {
            templateUrl: 'templates/homepage/homepage.html',
            controller: 'HomepageCtrl'
          }
        }
      })
      .state('menu.homepage-detail', {
        url: '/homepage/:id',
        cache:false,
        params:{content:"",type:""},
        views: {
          'menuContent': {
            templateUrl: 'templates/homepage/homepage-detail.html',
            controller: 'HomepageDetailCtrl'
          }
        }
      })
      .state('menu.specialists', {
        url: '/specialists',
        views: {
          'menuContent': {
            templateUrl: 'templates/homepage/specialists.html',
            controller: 'SpecialistsCtrl'
          }
        }
      })
      .state('menu.specia-detail', {
        url: '/specialists/:id',
        params:{data:""},
        cache: false,
        views: {
          'menuContent': {
            templateUrl: 'templates/homepage/specia-detail.html',
            controller: 'SpeciaDetailCtrl'
          }
        }
      })
      .state('menu.tab.cases', {
        url: '/cases',
        views: {
          'tab-case': {
            templateUrl: 'templates/case/case.html',
            controller: 'CaseCtrl'
          }
        }
      })
      .state('menu.case-detail', {
        url: '/cases/:caseId',
        cache: false,
        views: {
          'menuContent': {
            templateUrl: 'templates/case/case-detail.html',
            controller: 'CaseDetailCtrl'
          }
        },
      })

      .state('menu.tab.community', {
        url: '/communitys',
        params:{"type":""},
        views: {
          'tab-community': {
            templateUrl: 'templates/community/community.html',
            controller: 'CommunityCtrl'
          }
        }
      })
      .state('menu.community-detail', {
        url: '/communitys/:communityId',
        cache: false,
        views: {
          'menuContent': {
            templateUrl: 'templates/community/community-detail.html',
            controller: 'CommunityDetailCtrl'
          }
        },
      })

      .state('menu.uploadone', {
        url: '/uploadstepone',
        views: {
          'menuContent': {
            templateUrl: 'templates/upload/createCaseStepOne.html',
            controller: 'CreateCaseStepOneCtrl'
          }
        }
      })

      .state('menu.upload', {
        url: '/uploadsteptwo',
        views: {
          'menuContent': {
            templateUrl: 'templates/upload/createCaseStepTwo.html',
            controller: 'CreateCaseStepTwoCtrl'
          }
        }
      })

      .state('menu.reupload', {
        url: '/reupload/:caseId',
        cache: false,
        views: {
          'menuContent': {
            templateUrl: 'templates/upload/reupload.html',
            controller: 'UploadCtrl'
          }
        }
      })

      .state('menu.tab.learn', {
        url: '/learn',
        views: {
          'tab-learn': {
            templateUrl: 'templates/learn/learn.html',
            controller: 'LearnCtrl'
          }
        }
      })

      .state('menu.tab.learn-list', {
        url: '/learn/:labelId',
        //cache:false,
        views: {
          'tab-learn': {
            templateUrl: 'templates/learn/learn-list.html',
            controller: 'LearnListCtrl'
          }
        }
      })

      .state('menu.learn-detail', {
        url: '/learn-detail/:learnId',
        cache:false,
        views: {
          'menuContent': {
            templateUrl: 'templates/learn/learn-detail.html',
            controller: 'LearnDetailCtrl'
          }
        },
      })

      .state('menu.ppt-list', {
        url: '/ppt/:labelId',
        views: {
          'menuContent': {
            templateUrl: 'templates/learn/ppt-list.html',
            controller: 'PPtListCtrl'
          }
        },
      })

      .state('menu.ppt-detail', {
        url: '/ppt-detail/:pptId',
        cache:false,
        views: {
          'menuContent': {
            templateUrl: 'templates/learn/ppt-detail.html',
            controller: 'PPtDetailCtrl'
          }
        },
      })

      .state('menu.classroom-detail', {
        url: '/classroom-detail/:classId',
        cache:false ,
        views: {
          'menuContent': {
            templateUrl: 'templates/learn/classroom-detail.html',
            controller: 'ClassroomDetailCtrl'
          }
        },
      })

      .state('menu.tab.diagnose', {
        url: '/diagnose',
        views: {
          'tab-diagnose': {
            templateUrl: 'templates/diagnose/diagnose.html',
            controller: 'DiagnoseCtrl'
          }
        }
      })
      .state('menu.diagnose-authority', {
        url: '/diagnose-authority',
        views: {
          'menuContent': {
            templateUrl: 'templates/diagnose/diagnose-authority.html',
            controller: ''
          }
        }
      })
      .state('menu.tab.diagnose-list', {
        url: '/diagnose/:groupId',
        params:{"times":""},
        views: {
          'tab-diagnose': {
            templateUrl: 'templates/diagnose/diagnose-list.html',
            controller: 'DiagnoseListCtrl'
          }
        }
      })
      .state('menu.complain', {
        url: '/complain/:dataId/:dataType',
        views: {
          'menuContent': {
            templateUrl: 'templates/complain/complain.html',
            controller: 'ComplainCtrl'
          }
        }
      })
    ;

    // if none of the above states are matched, use this as the fallback
    $urlRouterProvider.otherwise('/guide-page');

  });
