angular.module('appversion-service',[])
  .factory('appversionService',function($http,$q) {
    var transform = [function (data) {
      /**
       * The workhorse; converts an object to x-www-form-urlencoded serialization.
       * @param obj
       * @returns {string}
       */
      var param = function (obj) {
        var query = '';
        var name, value, fullSubName, subName, subValue, innerObj, i;
        for (name in obj) {
          value = obj[name];
          if (value instanceof Array) {
            for (i = 0; i < value.length; ++i) {
              subValue = value[i];
              fullSubName = name + '[' + i + ']';
              innerObj = {};
              innerObj[fullSubName] = subValue;
              query += param(innerObj) + '&';
            }
          } else if (value instanceof Object) {
            for (subName in value) {
              subValue = value[subName];
              fullSubName = name + '[' + subName + ']';
              innerObj = {};
              innerObj[fullSubName] = subValue;
              query += param(innerObj) + '&';
            }
          } else if (value !== undefined && value !== null) {
            query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
          }
        }
        return query.length ? query.substr(0, query.length - 1) : query;
      };
      return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
    }];
    return{
      getLatestVersion: function () {
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/configuration/version"
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      setUserAppVersion: function (userId, appVersion) {
        var q = $q.defer();
        $http({
          headers: { 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'},
          transformRequest: transform,
          method: 'POST',
          url: config.new_url + "/appversion",
          data: {
            'userId':userId,
            'appVersion':appVersion
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },
    }
  })
