angular.module('comment-service',[])
  .factory('commentService',function($http,$q) {
    return{
      findComments : function(dataLearnId, carrierType,from, to){
        var q = $q.defer() ;
        $http({
          method: 'GET',
          url: config.new_url + "/social/comments",
          params: {
            'dataId': dataLearnId,
            'dataType': carrierType,
            'from': from,
            'to': to
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      submitComment : function(obj){
        var q = $q.defer() ;
        $http({
          method: 'POST',
          url: config.new_url + "/social/comments",
          data: {
            'dataId': obj.carrierId,
            'dataType': obj.carrierType,
            'userId': obj.userId,
            'comment': obj.comment,
            'parentId': obj.parentId,
            'mentionUserId': obj.mentionUserId
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      getSubComment : function(carrierType,commentId){
        var q = $q.defer() ;
        $http({
          method: 'GET',
          url: config.new_url + "/social/comments/subcomments/"+carrierType+"/"+commentId,
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },
      //将光标设置到最尾部的方法
      moveEnd: function(obj) {
        obj.focus();
        var len = obj.value.length;
        //console.log(len+"内容长度");
        if (document.selection) {
          //console.log("执行了移动光标的方法");
          var sel = obj.createTextRange();
          sel.moveStart('character', len);
          sel.collapse();
          sel.select();
        } else if (typeof obj.selectionStart === 'number' && typeof obj.selectionEnd === 'number') {
          obj.selectionStart = obj.selectionEnd = len;
        }
      }
    }
  })
