/**
 * Created by douhao on 2016/4/18.
 */
angular.module('community-service',[])
  .factory('communityService',function($http,$q) {
    var viewType = 1 ;
    var learnType = 0 ;
    var transform = [function (data) {
      /**
       * The workhorse; converts an object to x-www-form-urlencoded serialization.
       * @param obj
       * @returns {string}
       */
      var param = function (obj) {
        var query = '';
        var name, value, fullSubName, subName, subValue, innerObj, i;
        for (name in obj) {
          value = obj[name];
          if (value instanceof Array) {
            for (i = 0; i < value.length; ++i) {
              subValue = value[i];
              fullSubName = name + '[' + i + ']';
              innerObj = {};
              innerObj[fullSubName] = subValue;
              query += param(innerObj) + '&';
            }
          } else if (value instanceof Object) {
            for (subName in value) {
              subValue = value[subName];
              fullSubName = name + '[' + subName + ']';
              innerObj = {};
              innerObj[fullSubName] = subValue;
              query += param(innerObj) + '&';
            }
          } else if (value !== undefined && value !== null) {
            query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
          }
        }
        return query.length ? query.substr(0, query.length - 1) : query;
      };
      return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
    }];
    return {
      //查找所有
      findAll: function (dpTag,current,pageSize,equipmentName,bodyPartsName,order) {
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/discuss",
          params: {
            'dpTag':dpTag,
            'currentPage': current,
            'pageSize': pageSize,
            'equipTag': equipmentName,
            'bsTag': bodyPartsName,
            'order':order
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //根据Id查找
      findById: function(id){
        var q = $q.defer() ;
        $http({
          method: 'GET',
          url: config.new_url + "/discuss/"+id,
          params: {
            //'id': id
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      //点赞
      agree: function(userId,caseInfoId){
        var q = $q.defer() ;
        $http({
          method: 'post',
          url: config.new_url + "/social/like/"+userId+"/"+caseInfoId+"/2",
        })
        .success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //收藏
      collect:function(userId,caseId){
        var q = $q.defer() ;
        $http({
          method: 'post',
          url: config.new_url + "/social/store/0/"+userId+"/"+caseId+"/2",
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      //取消收藏
      cancleCollect:function(userId,caseId){
        var q = $q.defer() ;
        $http({
          method: 'post',
          url: config.new_url + "/social/store/1/"+userId+"/"+caseId+"/2",
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      //是否收藏
      isCollect:function(userId,caseId){
        var q = $q.defer() ;
        $http({
          method: 'GET',
          url: config.new_url + "/social/isstore",
          params: {
            'userId':userId,
            'dataId':caseId,
            'dataType':2
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      //是否点赞
      isAgree: function(caseId,userId){
        var q = $q.defer() ;
        $http({
          method: 'GET',
          url: config.new_url + "/social/islike",
          params: {
            'dataId':caseId,
            'dataType':2,
            'userId':userId,
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      //增加阅读量
      readNum:function(userId,caseId){
        var q = $q.defer() ;
        $http({
          method: 'post',
          url: config.new_url + "/social/read/"+userId+"/"+caseId+"/2",
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      setViewType:function(type){
        viewType = type ;
      },

      getViewType:function(){
        return viewType ;
      },

      setLearnType:function(type){
        learnType = type ;
      },
      getLearnType:function(){
        return learnType ;
      }
    }
  })
