angular.module('friend-service',[])
  .factory('friendService',function($http,$q,innermailService,$rootScope) {
    return{
      getFriends: function (userId, queryPara) {
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/friends/"+userId+"?queryPara="+queryPara,
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });
        return q.promise;
      },

      getFuzzFriends: function (userId, queryPara,current,pageSize) {
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/friends/fuzzySelect/"+userId,
          params: {
            'queryPara': queryPara,
            'current': current,
            'pageSize': pageSize,
          },
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });
        return q.promise;
      },

      getFriendsForGroup: function (userId, groupId, queryPara) {
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/friends/"+userId+"/group/"+groupId+"?queryPara="+queryPara,
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });
        return q.promise;
      },

      isFriend: function (userid, frienduserid) {
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/friends/"+userid +"/isfriend/"+frienduserid,
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });
        return q.promise;
      },

      addFriend: function (userid, frienduserid, type) {
        var url = null;
        if (type == 0){
          url = config.new_url + "/friends/"+userid +"/apply/"+frienduserid;
        }else{
          url = config.new_url + "/friends/"+userid +"/agree/"+frienduserid;
        }
        var q = $q.defer();
        $http({
          method: 'POST',
          url: url,
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });
        return q.promise;
      },

      rejectFriend: function (userid, frienduserid) {
        var q = $q.defer();
        $http({
          method: 'POST',
          url: config.new_url + "/friends/"+userid+"/reject/"+frienduserid,
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });
        return q.promise;
      },

      getFriendApply: function(){
        innermailService.getFriendMail($rootScope.user.id)
          .then(function(result){
            if (result.code == 0){
              var innermails = result.result;
              $rootScope.newmessage.innerMailCount = 0;
              $rootScope.newmessage.innerMailList = [];
              $rootScope.$apply();
              for (var i in innermails){
                if (innermails[i].title != '站内信' && innermails[i].status == 0){
                  $rootScope.newmessage.innerMailList.push(innermails[i]);
                  $rootScope.newmessage.innerMailCount++;
                }
              }
            }
          })
      }
    }
  })
