/**
 * Created by douhao on 2016/4/27.
 */
angular.module('guest-interceptor', [])
  .factory('GuestInterceptor', function($q,$rootScope,$injector) {
    var result = {
        status:401,
        message:'没有权限'
    }
    //var
    var notVisit = "0" ;
    var timer = 20*60*1000 ;

    var interceptor = {
      'request': function(config) {
        //设置全局http请求超时时间
        config.timeout = 5000;
        var requestTime = new Date().getTime() ;
        if((requestTime -$rootScope.sessionTime) > timer && localStorage.getItem("user") != null && localStorage.getItem("user") != ""){
          var loginUser = {
            userName:window.atob(localStorage.getItem("user")),
            password:window.atob(localStorage.getItem("pwd"))
          }
          $rootScope.sessionTime = requestTime ;
          $injector.get("UserService").login(loginUser)
            .then(function(result){
              if(result.code != 0){

              }else{
                $rootScope.user = result.result ;
                //sessionStorage.user = result

                if(!result.result.personalImage){
                  $rootScope.user.personalImage = img.personalImage ;
                }
              }
            })
        }
        // 成功的请求方法

        var userId = $rootScope.user.id ;

        //游客
        //判断当前url在model中是否存在，不存在即可访问，存在判断是否conf_value  true:可以访问， false：不可以访问
        if(userId <= 0 || userId == undefined){
          for(var i in $rootScope.guest_conf_urls){
            if(config.url.indexOf($rootScope.guest_conf_urls[i].confExtendObj.uri) != -1 && config.method.toUpperCase() == $rootScope.guest_conf_urls[i].confExtendObj.method.toUpperCase() && $rootScope.guest_conf_urls[i].confValue == notVisit){
              return $q.reject(result);
            }
          }
        }
        return config;
      },
      'response': function(response) {
        // 响应成功
        return response; // 或者 $q.when(config);
      },
      'requestError': function(rejection) {
        // 请求发生了错误，如果能从错误中恢复，可以返回一个新的请求或promise
        //return response; // 或新的promise
        // 或者，可以通过返回一个rejection来阻止下一步
        console.log("requestError");
         return $q.reject(rejection);
      },
      'responseError': function(rejection) {
        // 请求发生了错误，如果能从错误中恢复，可以返回一个新的响应或promise
        console.log("responseError="+rejection);
        //$injector.get('$ionicLoading').hide();
        if(rejection.message =="Unexpected token u") {
          var loginUser = {
            userName: window.atob(localStorage.getItem("user")),
            password: window.atob(localStorage.getItem("pwd"))
          }
          $injector.get("UserService").login(loginUser)
            .then(function(result){
              if(result.success == false){

              }else{
                $rootScope.user = result.result ;
                //sessionStorage.user = result

                if(!result.result.personalImage){
                  $rootScope.user.personalImage = img.personalImage ;
                }
              }
          })
        }

        if(rejection.status >= 400){
          if(rejection.status == '401'){
            $rootScope.$broadcast('login:show');
          }else if(rejection.status == '200'){
            //$rootScope.$broadcast("error") ;
            console.log(rejection) ;
          }
        }
        return $q.reject(rejection); // 或新的promise
        // 或者，可以通过返回一个rejection来阻止下一步
        // return $q.reject(rejection);
      }
    };
    return interceptor ;
  });
