/**
 * Created by sks on 2016/12/6.
 */
angular.module('homepage-service',[])
  .factory('HomePageService',function($http,$q){
    return{
        //获取广告信息
        getContents:function(size){
          var q = $q.defer() ;
          $http({
            method: 'GET',
            url: config.new_url + "/content/ad",
            params:{
              'size': size,
            }
          }).success(function(data,status,headers,config){
            // 当相应准备就绪时调用
            q.resolve(data) ;
          }).error(function(data,status,headers,config){
            // 当响应以错误状态返回时调用
            q.reject(data)
          })
          return q.promise ;
        },
      //获取新闻内容
      getNewContents:function(url){
        var q = $q.defer() ;
        $http({
          method: 'GET',
          url: url,
        }).success(function(data,status,headers,config){
          // 当相应准备就绪时调用
          q.resolve(data) ;
        }).error(function(data,status,headers,config){
          // 当响应以错误状态返回时调用
          q.reject(data)
        })
        return q.promise ;
      },
        //获取医生列表
        getDoctors:function(size){
          var q = $q.defer() ;
          $http({
            method: 'GET',
            url: config.new_url + "/famousdoctor",
            params:{
              'size': size,
            }
          }).success(function(data,status,headers,config){
            // 当相应准备就绪时调用
            q.resolve(data) ;
          }).error(function(data,status,headers,config){
            // 当响应以错误状态返回时调用
            q.reject(data)
          })
          return q.promise ;
        },
        //获取医生列表
        getInfos:function(current,pageSize){
          var q = $q.defer() ;
          $http({
            method: 'GET',
            url: config.new_url + "/content/news",
            params:{
              'current': current,
              'pageSize':pageSize
            }
          }).success(function(data,status,headers,config){
            // 当相应准备就绪时调用
            q.resolve(data) ;
          }).error(function(data,status,headers,config){
            // 当响应以错误状态返回时调用
            q.reject(data)
          })
          return q.promise ;
        },
      //增加阅读记录
      addReadRecord:function(type,id,userid){
        var q = $q.defer() ;
        $http({
          method: 'post',
          url: config.new_url + "/content/"+type+"/"+id+"/read/"+userid,
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },
      //获取专家列表
      getSpecialists:function(id,page,pageSize,content,provinces,citys){
        var q = $q.defer() ;
        $http({
          method: 'GET',
          url: config.new_url + "/famousdoctor/list",
          params:{
            'userid':id,
            'page':page,
            'pageSize':pageSize,
            'content':content,
            'provinces':provinces,
            'citys':citys
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      //获取详细信息
      getSpeciaDetail:function(id){
        var q = $q.defer() ;
        $http({
          method: 'GET',
          url: config.new_url + "/famousdoctor/"+id,
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },
      //获取个人病例
      getPersonalCases:function(userid,page,pageSize){
        var q = $q.defer() ;
        $http({
          method: 'GET',
          url: config.new_url + "/discuss/userid",
          params:{
            'userId':userid,
            'currentPage':page,
            'pageSize':pageSize,
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },
    }
  })
