/**
 * Created by douhao on 2016/4/18.
 */
angular.module('learn-service',[])
  .factory('learnService',function($http,$q) {
    var transform = [function (data) {
      /**
       * The workhorse; converts an object to x-www-form-urlencoded serialization.
       * @param obj
       * @returns {string}
       */
      var param = function (obj) {
        var query = '';
        var name, value, fullSubName, subName, subValue, innerObj, i;
        for (name in obj) {
          value = obj[name];
          if (value instanceof Array) {
            for (i = 0; i < value.length; ++i) {
              subValue = value[i];
              fullSubName = name + '[' + i + ']';
              innerObj = {};
              innerObj[fullSubName] = subValue;
              query += param(innerObj) + '&';
            }
          } else if (value instanceof Object) {
            for (subName in value) {
              subValue = value[subName];
              fullSubName = name + '[' + subName + ']';
              innerObj = {};
              innerObj[fullSubName] = subValue;
              query += param(innerObj) + '&';
            }
          } else if (value !== undefined && value !== null) {
            query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
          }
        }
        return query.length ? query.substr(0, query.length - 1) : query;
      };
      return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
    }];
    return{
      //查找所有
      findAll: function (lableId,templateTypeId,current,pageSize) {
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/datalearns",
          params: {
            'label':lableId,
            'type':templateTypeId,
            'current': current,
            'pageSize': pageSize
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //根据Id查找
      findById: function(id,userId){
        var q = $q.defer() ;
        $http({
          method: 'GET',
          url: config.new_url + "/datalearns/"+id+"/user/"+userId
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      //是否点赞
      isAgree: function(dataLearnId,userId){
        var q = $q.defer() ;
        $http({
          method: 'GET',
          url: config.new_url + "/social/islike",
          params: {
            'dataId':dataLearnId,
            'dataType':3,
            'userId':userId,
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      //是否收藏
      isCollect:function(dataLearnId,userId){
        var q = $q.defer() ;
        $http({
          method: 'GET',
          url: config.new_url + "/social/isstore",
          params: {
            'userId':userId,
            'dataId':dataLearnId,
            'dataType':3
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      // 收藏
      store : function(dataLearnId, userId){
        var q = $q.defer() ;
        $http({
          method: 'POST',
          url: config.new_url + "/social/store/0/"+userId+"/"+dataLearnId+"/3",
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      // 点赞
      like : function(dataLearnId, userId){
        var q = $q.defer() ;
        $http({
          method: 'POST',
          url: config.new_url + "/social/like/"+userId+"/"+dataLearnId+"/3",
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      // 阅读
      read : function(dataLearnId, userId){
        var q = $q.defer() ;
        $http({
          method: 'POST',
          url: config.new_url + "/social/read/"+userId+"/"+dataLearnId+"/3",
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      // 支付
      pay: function(dataLearnId,productId,userId,orderRemark){
        var q = $q.defer() ;
        $http({
          method: 'POST',
          url: config.new_url + "/datalearns/"+dataLearnId+"/"+productId+"/pay/"+userId
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      saveDataLearnEnter: function(dataLearnId,userId){
        var q = $q.defer() ;
        $http({
          method: 'POST',
          url: config.new_url + "/datalearns/"+dataLearnId+"/apply/"+userId
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      //获取个人积分
      getUserScore: function(userId){
        var q = $q.defer() ;
        $http({
          method: 'GET',
          url: config.new_url + "/scoreinfo/"+userId,
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      //获取列表显示数据
      getListStyleData:function(){
        var q = $q.defer();
        $http({
          method: 'GET',
          url:config.new_url +"/datalearns/labels",
        }).success(function(data,status,headers,config){
          q.resolve(data);
        }).error(function(data,status,headers,config){
          q.reject(data);
        });
        return q.promise;
      },

      //获取微课堂群组
      getGroupIdByUser: function(dataLearnId, userId){
        var q = $q.defer() ;
        $http({
          method: 'GET',
          url: config.new_url + "/datalearns/"+dataLearnId+"/groupId/"+userId,
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      }

    }
  })
