angular.module('rongcloud-service',[])
  .factory('rongcloudService',function($cordovaMedia,$http,$q,$cordovaVibration, $rootScope,UserService,groupService,UserConfigService, $timeout,showAlertService,$state,$ionicScrollDelegate) {
    var newMessageRec = null;
    return{
      getToken: function(userId){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/userinfos/"+userId+"/rongcloudtoken",
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });
        return q.promise;
      },

      syncGroup: function(groups){
        RongCloudLibPlugin.syncGroup(groups, function (ret, err) {
          if (ret.status == 'success'){
            console.log("sync group success.");
          } else{
            console.log("sync group failed: " + err.code);
          }
        })
      },

      joinGroup: function(group){
        RongCloudLibPlugin.joinGroup({
          groupId: group.id+"",
          groupName: group.name
        }, function (ret, err) {
        })
      },

      logout: function(){
        RongCloudLibPlugin.disconnect({isReceivePush: false},
          function(ret, err){
          });
      },

      init: function(appKey, token){
        RongCloudLibPlugin.init({
            appKey: appKey
          },
          function(ret, err) {
            if (ret) {
              $rootScope.conversationFlag = true;
            }
            if (err) {
              $rootScope.conversationFlag = false;
              //showAlertService.PopAlert("提示信息","网络问题，系统初始化失败，请重新登录.","确认","") ;
              //UserService.logoutApp();
            }
          }
        );

        RongCloudLibPlugin.setConnectionStatusListener(
          function(ret, err) {
            if (ret) {
              if(ret.result.connectionStatus == 'KICKED'){
                showAlertService.PopAlert("提示信息","您的帐号已在其他端登录.","确认","") ;
                RongCloudLibPlugin.disconnect({isReceivePush: false},
                  function(ret, err){
                  });
                UserService.logoutApp();
              }
            }
          }
        );

        RongCloudLibPlugin.connect({
            token: token
          },
          function(ret, err) {
            if (ret) {
              $timeout(function(){
                $rootScope.newmessage.messageCount = 0;
                $rootScope.conversation.conversationList = [];
                RongCloudLibPlugin.getConversationList(
                  function (ret, err) {
                    if (ret) {
                      var conversations = ret.result;
                      var target;
                      for (var i in conversations) {
                        var conversationTemp = conversations[i];
                        if(conversationTemp.conversationType == "PRIVATE"){
                          UserService.getUserById(conversationTemp.targetId)
                            .then(function(result){
                              var name = result.result.nickName;
                              var picture = !!result.result.personalImage ? result.result.personalImage : img.personalImage;
                              target = {name:name,picture:picture};
                              var conversation = null;
                              for (var j in conversations){
                                if (conversations[j].targetId == result.result.id && conversations[j].conversationType == 'PRIVATE'){
                                  conversation = conversations[j];
                                  break;
                                }
                              }
                              conversation = rongCloudUtil.resolveCon(conversation, 0, target);
                              $rootScope.conversation.conversationList.push(conversation);
                              $rootScope.newmessage.messageCount += conversation.unreadMessageCount;
                              $rootScope.$apply();
                            })
                        }else if(conversationTemp.conversationType == "GROUP"){
                          groupService.getGroupById(conversationTemp.targetId)
                            .then(function(result){
                              var name = result.result.name;
                              var picture = !!result.result.picture ? result.result.picture : img.personalImage;
                              target = {name:name,picture:picture};
                              var conversation = null;
                              for (var j in conversations){
                                if (conversations[j].targetId == result.result.id && conversations[j].conversationType == 'GROUP'){
                                  conversation = conversations[j];
                                  break;
                                }
                              }
                              conversation = rongCloudUtil.resolveCon(conversation, 0, target);
                              // 微课堂不需要消息提醒
                              if (result.result.isClassroom == 1){
                                conversation.unreadMessageCount = 0;
                              }
                              $rootScope.conversation.conversationList.push(conversation);
                              $rootScope.newmessage.messageCount += conversation.unreadMessageCount;
                              $rootScope.$apply();
                            })
                        }else if (conversationTemp.conversationType == 'SYSTEM'){
                          UserService.getUserById(conversationTemp.targetId)
                            .then(function(result){
                              var name = result.result.nickName;
                              var picture = !!result.result.personalImage ? result.result.personalImage : img.personalImage;
                              target = {name:name,picture:picture};
                              var conversation = null;
                              for (var j in conversations){
                                if (conversations[j].targetId == result.result.id && conversations[j].conversationType == 'SYSTEM'){
                                  conversation = conversations[j];
                                  break;
                                }
                              }
                              conversation = rongCloudUtil.resolveCon(conversation, 0, target);
                              $rootScope.conversation.conversationList.push(conversation);
                              $rootScope.newmessage.messageCount += conversation.unreadMessageCount;
                              $rootScope.$apply();
                            })

                        }
                      }
                    }
                    if (err) {
                      showAlertService.PopAlert("提示信息","获取会话列表失败.","确认","") ;
                    }
                  });

                if (!newMessageRec){
                  newMessageRec = $cordovaMedia.newMedia(img.newMessageVadio,
                    function() {
                      $cordovaMedia.release();
                    }
                  );
                }

                UserConfigService.getUserConfigs($rootScope.user.id)
                  .then(function(result){
                    $rootScope.userConfigs = result.result;

                    for(var i in $rootScope.userConfigs){
                      if ($rootScope.userConfigs[i].configName == 'RequestEncrypt'){
                        if ($rootScope.userConfigs[i].defaultValue == '1'){
                          if (localStorage.getItem("httpType") == '0'){
                            showAlertService.PopConfirm("安全提醒","您的设备是否需要切换到安全网络协议？","暂不切换","立即切换")
                              .then(function(res) {
                                if(res) {
                                  config.new_url = config.new_url.replace('http://', 'https://');
                                  localStorage.setItem("httpType", "1");
                                }
                              });
                          }
                        }else{
                          if (localStorage.getItem("httpType") == '1'){
                            showAlertService.PopConfirm("安全提醒","您的设备是否需要切换到普通网络协议？","暂不切换","立即切换")
                              .then(function(res) {
                                if(res) {
                                  config.new_url = config.new_url.replace('https://', 'http://');
                                  localStorage.setItem("httpType", "0");
                                }
                              });
                          }
                        }
                      }
                    }
                  });

                $rootScope.conversationFlag = true;
              }, 1000);
            }
            if (err) {
              if (err.code != -1000){
                $rootScope.conversationFlag = false;
                //showAlertService.PopAlert("提示信息","网络问题，系统初始化失败，请重新登录.","确认","") ;
                //UserService.logoutApp();
              }
            }
          }
        );

        // 等待会话列表初始化完成后开始启动消息监听
        $timeout(function() {
          RongCloudLibPlugin.setOnReceiveMessageListener(
            function(ret, err) {
              if (ret) {
                var message = ret.result.message;
                var target;
                if(message.conversationType == "PRIVATE"){
                  $rootScope.newmessage.messageCount++;
                  message.unreadMessageCount = 1;
                  if (!!$rootScope.userConfigs && $rootScope.appShowFlag){
                    for (var i in $rootScope.userConfigs){
                      if ($rootScope.userConfigs[i].configName == 'NewMsgVoiceNotice' && $rootScope.userConfigs[i].defaultValue == '1'){
                        newMessageRec.play({ numberOfLoops: 1 });
                      }
                      if ($rootScope.userConfigs[i].configName == 'NewMsgVibrateNotice' && $rootScope.userConfigs[i].defaultValue == '1'){
                        //navigator.vibrate(100);
                        $cordovaVibration.vibrate(100);
                      }
                    }
                  }

                  UserService.getUserById(message.targetId)
                    .then(function(result){
                      var name = result.result.nickName;
                      var picture = !!result.result.personalImage ? result.result.personalImage : img.personalImage;
                      target = {name:name,picture:picture};
                      var conver = rongCloudUtil.resolveCon(message, 1, target);

                      var conversation = null;
                      for (var i in $rootScope.conversation.conversationList){
                        var conversationTemp = $rootScope.conversation.conversationList[i];
                        if (conversationTemp.targetId == conver.targetId && conversationTemp.conversationType == 'PRIVATE'){
                          conversation = conversationTemp;
                          break;
                        }
                      }
                      if (!!conversation){
                        conversation.latestMessage = conver.latestMessage;
                        conversation.sentTime = conver.sentTime;

                        if (conversation.targetId == $rootScope.currentConversation.targetId && conversation.conversationType == $rootScope.currentConversation.conversationType){
                          var curMsg = rongCloudUtil.resolveMsg(message);
                          curMsg.userPic = picture;
                          $rootScope.currentConversation.messageList.push(curMsg);

                          if (curMsg.objectName == 'RC:ImgMsg'){
                            $rootScope.currentConversation.imageList.push(curMsg.content.imageUrl);
                          }

                          $rootScope.newmessage.messageCount--;

                          var scrollFlag = true;
                          if ($rootScope.currentConversation.messageList.length > 1){
                            var latestMessageId = $rootScope.currentConversation.messageList[$rootScope.currentConversation.messageList.length - 2].messageId;
                            scrollFlag = $('#messageDiv-'+latestMessageId).offset().top < $('#MessageDetail-'+conversation.targetId).height() + 50;
                          }
                          if (scrollFlag){
                            $ionicScrollDelegate.scrollBottom(true);
                          }

                          RongCloudLibPlugin.clearMessagesUnreadStatus({
                              conversationType: $rootScope.currentConversation.conversationType,
                              targetId: $rootScope.currentConversation.targetId
                            },
                            function (ret, err) {
                              if (err) {
                              }
                            }
                          );

                          if (!!message.content.data && message.content.name.startsWith('CancelMessage')){
                            var messageFlag = message.content.name.split('-')[1];
                            var index = -1;
                            for (var i in $rootScope.currentConversation.messageList){
                              if (!!$rootScope.currentConversation.messageList[i].content.extra && $rootScope.currentConversation.messageList[i].content.extra.split(' | ')[0] == messageFlag){
                                index = i;
                                break;
                              }
                            }
                            if (index > -1){
                              $rootScope.currentConversation.messageList.splice(index, 1);
                            }
                          }
                        }else{
                          conversation.unreadMessageCount++;
                        }
                      }else{
                        $rootScope.conversation.conversationList.splice(0, 0, conver);
                      }

                      $rootScope.$apply();
                    })
                }else if(message.conversationType == "GROUP"){
                  groupService.getGroupById(message.targetId)
                    .then(function(result){
                      if (result.result.isClassroom == 0){
                        $rootScope.newmessage.messageCount++;
                        message.unreadMessageCount = 1;
                        if (!!$rootScope.userConfigs && $rootScope.appShowFlag){
                          for (var i in $rootScope.userConfigs){
                            if ($rootScope.userConfigs[i].configName == 'NewMsgVoiceNotice' && $rootScope.userConfigs[i].defaultValue == '1'){
                              newMessageRec.play({ numberOfLoops: 1 });
                            }
                            if ($rootScope.userConfigs[i].configName == 'NewMsgVibrateNotice' && $rootScope.userConfigs[i].defaultValue == '1'){
                              //navigator.vibrate(100);
                              $cordovaVibration.vibrate(100);
                            }
                          }
                        }
                      }else{
                        message.unreadMessageCount = 0;
                      }

                      var name = result.result.name;
                      var picture = !!result.result.picture ? result.result.picture : img.personalImage;
                      target = {name:name,picture:picture};
                      var conver = rongCloudUtil.resolveCon(message, 1, target);

                      var conversation = null;
                      var converIndex = -1;
                      for (var i in $rootScope.conversation.conversationList){
                        var conversationTemp = $rootScope.conversation.conversationList[i];
                        if (conversationTemp.targetId == conver.targetId && conversationTemp.conversationType == 'GROUP'){
                          conversation = conversationTemp;
                          converIndex = i;
                          break;
                        }
                      }
                      if (!!conversation){
                        conversation.latestMessage = conver.latestMessage;
                        conversation.sentTime = conver.sentTime;

                        // 移除群组
                        if (!!message.content.data && message.content.name.startsWith('RemoveGroupUser')){
                          var userId = message.content.name.split('-')[1];
                          if (userId == $rootScope.user.id){
                            RongCloudLibPlugin.removeConversation({
                              conversationType: 'GROUP',
                              targetId: conversation.targetId
                            }, function (ret, err) {
                              $rootScope.conversation.conversationList.splice(converIndex, 1);
                            })
                          }
                        }

                        if (conversation.targetId == $rootScope.currentConversation.targetId && conversation.conversationType == $rootScope.currentConversation.conversationType){
                          var curMsg = rongCloudUtil.resolveMsg(message);
                          UserService.getUserById(message.senderUserId)
                            .then(function(result) {
                              var picture = !!result.result.personalImage ? result.result.personalImage : img.personalImage;
                              curMsg.userPic = picture;
                              $rootScope.currentConversation.messageList.push(curMsg);
                              if (curMsg.objectName == 'RC:ImgMsg'){
                                $rootScope.currentConversation.imageList.push(curMsg.content.imageUrl);
                                $rootScope.$broadcast('imgMsg');
                              }
                              if (result.result.isClassroom == 0){
                                $rootScope.newmessage.messageCount--;
                              }

                              var scrollFlag = true;
                              if ($rootScope.currentConversation.messageList.length > 1){
                                var latestMessageId = $rootScope.currentConversation.messageList[$rootScope.currentConversation.messageList.length - 2].messageId;

                                // 微课堂视频高度
                                var videoHeight = 0;
                                var messageDivHeight = 0;

                                if (!!$(".study-playPage").css('height')){
                                  videoHeight = parseInt($(".study-playPage").css('height').replace("px",""));
                                  messageDivHeight = $('#MessageDetailDir-'+conversation.targetId).height();
                                }else{
                                  messageDivHeight = $('#MessageDetail-'+conversation.targetId).height();
                                }

                                scrollFlag = $('#messageDiv-'+latestMessageId).offset().top < messageDivHeight + videoHeight + 50;
                              }
                              if (scrollFlag && messageDivHeight>0){
                                $ionicScrollDelegate.scrollBottom(true);
                              }
                              $rootScope.$apply();

                              RongCloudLibPlugin.clearMessagesUnreadStatus({
                                  conversationType: $rootScope.currentConversation.conversationType,
                                  targetId: $rootScope.currentConversation.targetId
                                },
                                function (ret, err) {
                                  if (err) {
                                  }
                                }
                              );

                              if (!!message.content.data && message.content.name.startsWith('CancelMessage')){
                                var messageFlag = message.content.name.split('-')[1];
                                var index = -1;
                                for (var i in $rootScope.currentConversation.messageList){
                                  if (!!$rootScope.currentConversation.messageList[i].content.extra && $rootScope.currentConversation.messageList[i].content.extra.split(' | ')[0] == messageFlag){
                                    index = i;
                                    break;
                                  }
                                }
                                if (index > -1){
                                  $rootScope.currentConversation.messageList.splice(index, 1);
                                }
                              }

                              // 群组禁言
                              if (!!message.content.data && message.content.name.startsWith('GroupBannedFlag')){
                                if (message.content.name == 'GroupBannedFlagOpen'){
                                  $rootScope.$broadcast('groupBannedFlag:open');
                                }
                                if (message.content.name == 'GroupBannedFlagClose'){
                                  $rootScope.$broadcast('groupBannedFlag:close');
                                }
                              }

                              // 群组主持
                              if (!!message.content.data && message.content.name.startsWith('GroupUserHost')){
                                var userId = message.content.name.split('-')[1];
                                if (userId == $rootScope.user.id){
                                  if (message.content.name.startsWith('GroupUserHostOpen')){
                                    $rootScope.$broadcast('groupHostFlag:open');
                                  }
                                  if (message.content.name.startsWith('GroupUserHostClose')){
                                    $rootScope.$broadcast('groupHostFlag:close');
                                  }
                                }
                              }

                              $("a[class^='JoinGroupUser']").on('click',function(e){
                                var classInfo = $(e.target).attr("class");
                                var userId = classInfo.split(' ')[0].split('-')[1];
                                $state.go("menu.userDetail",{'userId':userId}) ;
                              });
                            });
                        }else{
                          if (result.result.isClassroom == 0){
                            conversation.unreadMessageCount++;
                          }
                          var extra = message.content.extra.split(' | ');
                          if (extra.length == 3){
                            if (extra[2] == -1 || extra[2] == $rootScope.user.id){
                              conversation.atFlag = true;
                            }
                          }
                        }
                      }else{
                        $rootScope.conversation.conversationList.splice(0, 0, conver);

                        if (conver.targetId == $rootScope.currentConversation.targetId && conver.conversationType == $rootScope.currentConversation.conversationType){
                          var curMsg = rongCloudUtil.resolveMsg(message);
                          UserService.getUserById(message.senderUserId)
                            .then(function(result) {
                              var picture = !!result.result.personalImage ? result.result.personalImage : img.personalImage;
                              curMsg.userPic = picture;
                              $rootScope.currentConversation.messageList.push(curMsg);
                              if (result.result.isClassroom == 0){
                                $rootScope.newmessage.messageCount--;
                              }
                              $ionicScrollDelegate.scrollBottom(true);
                              $rootScope.$apply();

                              RongCloudLibPlugin.clearMessagesUnreadStatus({
                                  conversationType: $rootScope.currentConversation.conversationType,
                                  targetId: $rootScope.currentConversation.targetId
                                },
                                function (ret, err) {
                                  if (err) {
                                  }
                                }
                              );
                            });
                        }else{
                          var extra = message.content.extra.split(' | ');
                          if (extra.length == 3){
                            if (extra[2] == -1 || extra[2] == $rootScope.user.id){
                              conver.atFlag = true;
                            }
                          }
                        }
                      }

                      $rootScope.$apply();
                    })
                }else if(message.conversationType == 'SYSTEM'){
                  $rootScope.newmessage.messageCount++;
                  message.unreadMessageCount = 1;
                  if (!!$rootScope.userConfigs && $rootScope.appShowFlag){
                    for (var i in $rootScope.userConfigs){
                      if ($rootScope.userConfigs[i].configName == 'NewMsgVoiceNotice' && $rootScope.userConfigs[i].defaultValue == '1'){
                        newMessageRec.play({ numberOfLoops: 1 });
                      }
                      if ($rootScope.userConfigs[i].configName == 'NewMsgVibrateNotice' && $rootScope.userConfigs[i].defaultValue == '1'){
                        //navigator.vibrate(100);
                        $cordovaVibration.vibrate(100);
                      }
                    }
                  }
                  //收到其他类型的消息
                  UserService.getUserById(message.targetId)
                    .then(function(result){
                      var name = result.result.nickName;
                      var picture = !!result.result.personalImage ? result.result.personalImage : img.personalImage;
                      target = {name:name,picture:picture};
                      var conver = rongCloudUtil.resolveCon(message, 1, target);

                      var conversation = null;
                      for (var i in $rootScope.conversation.conversationList){
                        var conversationTemp = $rootScope.conversation.conversationList[i];
                        if (conversationTemp.targetId == conver.targetId && conversationTemp.conversationType == 'SYSTEM'){
                          conversation = conversationTemp;
                          break;
                        }
                      }

                      if (!!conversation){
                        conversation.latestMessage = conver.latestMessage;
                        conversation.sentTime = conver.sentTime;

                        if (conversation.targetId == $rootScope.currentConversation.targetId && conversation.conversationType == $rootScope.currentConversation.conversationType){
                          var curMsg = rongCloudUtil.resolveMsg(message);
                          curMsg.userPic = picture;
                          $rootScope.currentConversation.messageList.push(curMsg);
                          $rootScope.newmessage.messageCount--;
                          $ionicScrollDelegate.scrollBottom(true);

                          RongCloudLibPlugin.clearMessagesUnreadStatus({
                              conversationType: $rootScope.currentConversation.conversationType,
                              targetId: $rootScope.currentConversation.targetId
                            },
                            function (ret, err) {
                              if (err) {
                              }
                            }
                          );
                        }else{
                          conversation.unreadMessageCount++;
                        }
                      }else{
                        $rootScope.conversation.conversationList.splice(0, 0, conver);
                      }

                      $rootScope.$apply();
                    })
                }
              }
              if (err) {
                showAlertService.PopAlert("提示信息","消息监听失败.","确认","") ;
              }
            }
          );
        }, 5000);
      }
    }
  })
