angular.module('uploadcase-service',[])
  .factory('uploadCaseService',function($http,$q) {
    var newCase = null;
    var transform = [function (data) {
      /**
       * The workhorse; converts an object to x-www-form-urlencoded serialization.
       * @param obj
       * @returns {string}
       */
      var param = function (obj) {
        var query = '';
        var name, value, fullSubName, subName, subValue, innerObj, i;
        for (name in obj) {
          value = obj[name];
          if (value instanceof Array) {
            for (i = 0; i < value.length; ++i) {
              subValue = value[i];
              fullSubName = name + '[' + i + ']';
              innerObj = {};
              innerObj[fullSubName] = subValue;
              query += param(innerObj) + '&';
            }
          } else if (value instanceof Object) {
            for (subName in value) {
              subValue = value[subName];
              fullSubName = name + '[' + subName + ']';
              innerObj = {};
              innerObj[fullSubName] = subValue;
              query += param(innerObj) + '&';
            }
          } else if (value !== undefined && value !== null) {
            query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
          }
        }
        return query.length ? query.substr(0, query.length - 1) : query;
      };
      return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
    }];
    return{
      // 获取病例
      getDiscussCase: function (discussCaseId) {
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/cases/community/"+discussCaseId,
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });
        return q.promise;
      },

      // 上传病例
      addDiscussCase: function (title, contentMessage, pathology, userId, newFileNames, sex, age, casePurpose, deviceName, bsTag) {
        var q = $q.defer();
        $http({
          method: 'POST',
          url: config.new_url + "/cases",
          data: {
            'title': title,
            'content': contentMessage,
            'pathology': pathology,
            'userId': userId,
            'imageList': newFileNames,
            'sex': sex,
            'age': age,
            'casePurpose':casePurpose,
            'equipTag':deviceName,
            'bsTag':bsTag
          }
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });
        return q.promise;
      },

      // 上传病例
      updateDiscussCase: function (caseId, title, contentMessage, pathology, isPathology, imageNames, sex, age, casePurpose, deviceName, bsTag) {
        var q = $q.defer();
        $http({
          method: 'PUT',
          url: config.new_url + "/cases",
          data: {
            'caseId':caseId,
            'title': title,
            'content': contentMessage,
            'pathology': pathology,
            'imageList': imageNames,
            'sex': sex,
            'age': age,
            'casePurpose':casePurpose,
            'equipTag':deviceName,
            'bsTag':bsTag
          }
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });
        return q.promise;
      },

      // 获取正在创建的病例
      getNewCaseData: function(){
        return newCase;
      },

      // 设置正在创建的病例
      setNewCaseData: function(casedata){
        newCase = casedata;
      }
    }
  })
