/**
 * Created by douhao on 2016/4/26.
 */
angular.module('user-service',[])
  .factory('UserService',function($http,$q,$rootScope,$state,$ionicHistory) {
    var LAreaData = [] ;
    var userAnalyze = "" ;
    var challengeIsActive = true ;
    var challengeRecordsType = 0 ;
    var transform = [function (data) {
      /**
       * The workhorse; converts an object to x-www-form-urlencoded serialization.
       * @param obj
       * @returns {string}
       */
      var param = function (obj) {
        var query = '';
        var name, value, fullSubName, subName, subValue, innerObj, i;
        for (name in obj) {
          value = obj[name];
          if (value instanceof Array) {
            for (i = 0; i < value.length; ++i) {
              subValue = value[i];
              fullSubName = name + '[' + i + ']';
              innerObj = {};
              innerObj[fullSubName] = subValue;
              query += param(innerObj) + '&';
            }
          } else if (value instanceof Object) {
            for (subName in value) {
              subValue = value[subName];
              fullSubName = name + '[' + subName + ']';
              innerObj = {};
              innerObj[fullSubName] = subValue;
              query += param(innerObj) + '&';
            }
          } else if (value !== undefined && value !== null) {
            query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
          }
        }
        return query.length ? query.substr(0, query.length - 1) : query;
      };
      return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
    }];
    return {
      //登录
      login: function (user) {
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/userinfos/login",
          params: {
            'username': window.btoa(user.userName),
            'password': window.btoa(user.password),
          },
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //云影login
      lifeLogin:function(params){
        var q = $q.defer();
        $http({
          method: 'POST',
          url: config.lifeccp_url+"/users/login",
          data:params
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //查询权限
      getConfByType: function(confType){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/configuration/"+confType,
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //获取个人中心数据
      getStatistics: function(userId){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/personalcenter",
          params: {
            'userId': userId
          },
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //获取个人中心好友数据
      getStatisticsUser: function(userId){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/friends/"+userId+"/statistics",
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //获取个人发布的病历
      getMyForumList: function(userId,from,to){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/personalcenter/published",
          params:{
            'userId': userId ,
            'from': from ,
            'to': to
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //删除发布的病历
      deleteMyForum: function(discussCaseId){
        var q = $q.defer();
        $http({
          method: 'DELETE',
          url: config.new_url + "/cases/"+discussCaseId,
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //获取个人收藏的经典病历
      getStoreList: function(userId,from,to){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/personalcenter/classiccases",
          params:{
            'userId': userId ,
            'from': from ,
            'to': to
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //获取个人收藏的社区病历
      getForumStoreList: function(userId,from,to){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/personalcenter/discusscases",
          params:{
            'userId': userId ,
            'from': from ,
            'to': to
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //获取个人收藏的视频
      getLearnStoreList: function(userId,from,to){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/personalcenter/learns",
          params:{
            'userId': userId ,
            'from': from ,
            'to': to
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //取消经典病历收藏
      deleteCaseStore: function(userId,caseId){
        var q = $q.defer();
        $http({
          method: 'POST',
          url: config.new_url + "/social/store/1/"+userId+"/"+caseId+"/1",
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //取消社区收藏
      deleteCommunityStore: function(userId,caseId){
        var q = $q.defer();
        $http({
          method: 'POST',
          url: config.new_url + "/social/store/1/"+userId+"/"+caseId+"/2",
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //取消视频收藏
      deleteVideoStore: function(userId,dataLearnId){
        var q = $q.defer();
        $http({
          method: 'POST',
          url: config.new_url + "/social/store/1/"+userId+"/"+dataLearnId+"/3",
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //判断手机号码是否存在
      getPhoneExist: function(phone){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/register/"+phone+"/exist"
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //注册
      savePhoneRegist: function(registerUser){
        var q = $q.defer();
        $http({
          headers: { 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'},
          transformRequest: transform,
          method: 'POST',
          url: config.new_url + "/register",
          data:{
            'type':0,
            'phone':$rootScope.encode64($rootScope.utf16to8(registerUser.phone)),
            'randomCode':registerUser.randomCode,
            'password':$rootScope.encode64($rootScope.utf16to8(registerUser.password)),
            'name':registerUser.userName,
            'email':registerUser.email,
            'location':registerUser.location,
            'hospital':registerUser.hospital,
            'department':registerUser.department,
            'specialtyPaper':'',
            'wechat':registerUser.wechat,
            'nickName':registerUser.nickName
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //找回密码
      retrievePSD: function(phone){
        var q = $q.defer();
        $http({
          method: 'POST',
          url: config.new_url + "/register/"+phone+"/password"
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //修改个人信息
      updateUserBaseInfo: function(user){
        var q = $q.defer() ;
        $http({
          method:'PUT',
          url: config.new_url + "/userinfos" ,
          data:{
            'id': user.id,
            'name': user.name ,
            'email': user.email,
            'nickName': user.nickName ,
            'location': user.location ,
            'hospital': user.hospital ,
            'department': user.department,
            'introduction':user.introduction,
            'specialtyPaper':user.specialtyPaper
          }
        }).success(function(data,status,headers,config){
          q.resolve(data) ;
        }).error(function(data,status,headers,config){
          q.reject(data) ;
        })

        return q.promise ;
      },

      //获取挑战记录
      getChallengeRecords: function(userId,type,isRight,page,pageSize){
        var q = $q.defer() ;
        $http({
          method:'GET',
          url: config.new_url + "/challenge/records" ,
          params:{
            'userId':userId,
            'type':type,
            'isRight':isRight,
            'page':page,
            'pageSize':pageSize
          }
        }).success(function(data,status,headers,config){
          q.resolve(data) ;
        }).error(function(data,status,headers,config){
          q.reject(data) ;
        })

        return q.promise ;
      },

      //更改头像
      updatePersonalImage: function(id,imgUrl){
        var q = $q.defer() ;
        $http({
          headers: { 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'},
          transformRequest: transform,
          method:'POST',
          url: config.new_url + "/userinfos/"+id+"/image",
          data:{
            'url':encodeURI(imgUrl)
          }
        }).success(function(data,status,headers,config){
          q.resolve(data) ;
        }).error(function(data,status,headers,config){
          q.reject(data) ;
        })

        return q.promise ;
      },

      //裁剪头像
      resizePersonalImage: function(id,imgUrl,imgheight,x,y,w,h){
        var q = $q.defer() ;
        $http({
          headers: { 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'},
          transformRequest: transform,
          method:'POST',
          url: config.new_url + "/userinfos/"+id+"/resizeimage/"+imgheight+"/"+x+"/"+y+"/"+w+"/"+h,
          data:{
            'url':encodeURI(imgUrl)
          }
        }).success(function(data,status,headers,config){
          q.resolve(data) ;
        }).error(function(data,status,headers,config){
          q.reject(data) ;
        })

        return q.promise ;
      },

      //修改密码
      updatePassword: function(userId,oldpassword, newpassword){
        var q = $q.defer() ;
        $http({
          method:'PUT',
          url: config.new_url + "/userinfos/"+userId+"/oldpassword/"+window.btoa(oldpassword)+"/newpassword/"+window.btoa(newpassword)
        }).success(function(data,status,headers,config){
          q.resolve(data) ;
        }).error(function(data,status,headers,config){
          q.reject(data) ;
        })

        return q.promise ;
      },

      //根据手机号修改密码
      updatePhonePassword: function(phone,password){
        var q = $q.defer() ;
        $http({
          method:'PUT',
          url: config.new_url + "/userinfos/phone/"+window.btoa(phone)+"/password/"+window.btoa(password)
        }).success(function(data,status,headers,config){
          q.resolve(data) ;
        }).error(function(data,status,headers,config){
          q.reject(data) ;
        })

        return q.promise ;
      },

      //验证码检查
      randomcodeChec:function(phone,code){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/randomcode/code",
          params:{
            'phone':window.btoa(phone),
            'code':code,
          }
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });

        return q.promise;
      },

      //发送验证码
      sendCode:function(phone){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/randomcode",
          params:{
            'phone':phone,
          }
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });

        return q.promise;
      },

      //增加挑战信息
      ChallengeNum: function(userId,rightNum,errorNum){
      var q = $q.defer() ;
      $http({
        headers: { 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'},
        transformRequest: transform,
        method:'POST',
        url: config.new_url + "/challenge/result" ,
        data:{
          'userId':userId,
          'rightNum':rightNum,
          'errorNum':errorNum
        }
      }).success(function(data,status,headers,config){
        q.resolve(data) ;
      }).error(function(data,status,headers,config){
        q.reject(data) ;
      })

      return q.promise ;
    },

      getAllPicUser: function () {
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/userinfos/picuser",
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });

        return q.promise;
      },

      fuzzySelectUsers: function (para) {
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/userinfos/fuzzySelect?queryPara="+para,
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });

        return q.promise;
      },

      getUserById: function (userid) {
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/userinfos/"+userid,
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });

        return q.promise;
      },

      updateUserPhoneAndName: function (userId, name, phoneNumber) {
        var q = $q.defer();
        $http({
          headers: { 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'},
          transformRequest: transform,
          method: 'POST',
          url: config.new_url + "/userinfos/updateUserPhoneAndName",
          data:{
            'userId': userId ,
            'name': name ,
            'phoneNumber': phoneNumber
          }
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });

        return q.promise;
      },

      getUserScoreSys: function (userId) {
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/scoreinfo/"+userId,
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });

        return q.promise;
      },

      logoutApp: function(){
        $rootScope.user = {
          id:0 ,
          personalImage:img.personalImage,
        }
        $rootScope.statistics= {
          myForumNum:0,
          myStore:0 ,
          myForumStroreNum:0,
          myLearnStroreNum:0,
        } ;
        $ionicHistory.clearCache();
        localStorage.setItem("user", "");
        localStorage.setItem("pwd", "");
        localStorage.setItem("signInTime","");
        localStorage.setItem("userIdentity","");
        $rootScope.newmessage.innerMailCount = 0;
        $rootScope.newmessage.messageCount = 0;
        //清空个人分析数据
        userAnalyze = "" ;

        $http({
          method: 'POST',
          url: config.new_url + "/userinfos/logout",
        });

        $state.go("signin") ;
      },

      addAccessSource: function(){
        var sourceType;
        var isIOS = ionic.Platform.isIOS();
        var isAndroid = ionic.Platform.isAndroid();

        if (isAndroid){
          sourceType = 0;
        }else if (isIOS){
          sourceType = 1;
        }else{
          sourceType = 2;
        }

        var q = $q.defer();
        $http({
          method: 'POST',
          url: config.new_url + "/userinfos/accesssource/0/"+sourceType,
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      addLoginRecord: function(){
          var sourceType;
          var isIOS = ionic.Platform.isIOS();
          var isAndroid = ionic.Platform.isAndroid();
          var device = ionic.Platform.device() ;
          var phoneModel = device.manufacturer==undefined?"未知":device.manufacturer+" "+device.model;
          var browserModel = "" ;
          if(getBrowserInfo() != undefined){
            browserModel = getBrowserInfo().type+" "+getBrowserInfo().version ;
          }
          if (isAndroid){
            sourceType = 0;
          }else if (isIOS){
            sourceType = 1;
          }else{
            sourceType = 2;
          }


          var q = $q.defer();
          $http({
            headers: { 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'},
            transformRequest: transform,
            method: 'POST',
            url: config.new_url + "/userinfos/loginRecord",
            data:{
              'userId':$rootScope.user.id,
              'nickname':$rootScope.user.nickName,
              'loginType':0,
              'phoneType':sourceType,
              'phoneModel':phoneModel,
              'browserModel':browserModel
            }
          }).success(function (data, status, headers, config) {
            // 当相应准备就绪时调用
            q.resolve(data);
          }).error(function (data, status, headers, config) {
            // 当响应以错误状态返回时调用
            q.reject(data);
          });

          return q.promise;
      },



      // 获取个人中心数据
      getUserCenterInfo: function(userId){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/personalcenter",
          params:{
            'userId':userId
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //获取Token
      getToken: function(diagnoseUser){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/userinfos/token",
          params:{
            'diagnoseUser':diagnoseUser
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //云影验证账户
      lifeAutoLogin:function(params){
        var q = $q.defer();
        $http({
          method: 'POST',
          url: config.lifeccp_url+"/users/autoLogin",
          data:params
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //根据unionid获取userinfo
      getUserInfoByUnionid: function(unionid){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/userinfos/unionid",
          params:{
            'unionid':unionid
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //根据code获取unionid
      getUnionid: function(code){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/userinfos/wechat/unionid",
          params:{
            'code':code,
            'type':1
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //根据phone查找用户
      getUserInfoByPhone:function(phone){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/userinfos/phone/"+phone,
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      getWeChatUserInfo:function(accessToken,openid){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/userinfos/wechat/accesstoken",
          params:{
            'accessToken':accessToken,
            'openid':openid
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //绑定unionid跟openid
      boundUnionid:function(userId,unionid,openid){
        var q = $q.defer();
        $http({
          headers: { 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'},
          transformRequest: transform,
          method: 'POST',
          url: config.new_url + "/userinfos/unionid",
          data:{
            'userId':userId,
            'unionid':unionid,
            'openid':openid
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //注册用户
      registerByUnionid:function(unionid,openid,headimgurl,phoneCount,password,nickname){
        var q = $q.defer();
        $http({
          headers: { 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'},
          transformRequest: transform,
          method: 'POST',
          url: config.new_url + "/register",
          data:{
            'type':1,
            'unionid':unionid,
            'openid':openid,
            'headimgurl':headimgurl,
            'phone':window.btoa(phoneCount),
            'password':window.btoa(password),
            'nickName':nickname
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //获取积分规则
      getScoreRule:function(){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/scoreinfo/scorerule",
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //是否签到过
      isSigined:function(userId){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/userinfos/signin/"+userId,
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //获取挑战赛病历信息
      getChallengeCases:function(caseSize,dpTag,equipTag,bsTag,recuitFlag){
        var q = $q.defer();
        var params = {
          'caseSize':caseSize,
          'recuitFlag':recuitFlag
        }
        if(dpTag !== ""){
          params.dpTag = dpTag ;
        }
        if(equipTag != ""){
          params.equipTag = equipTag ;
        }
        if(bsTag != ""){
          params.bsTag = bsTag ;
        }
        $http({
          method: 'GET',
          url: config.new_url + "/challenge/cases",
          params:params
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //获取挑战赛问题信息
      getChallengeQuestions:function(caseIds){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url+"/challenge/questions",
          params:{
            'caseIds':caseIds
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      //挑战赛提交结果
      postChallengeAnswer:function(params){
        var q = $q.defer();
        $http({
          method: 'POST',
          url: config.new_url+"/challenge/answers",
          data:params
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      //获取用户二维码信息
      getPersonaQrcode:function(userId){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url+"/userinfos/"+userId+"/qrcode"
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      //获取地区信息
      getSwfArea:function(){
        var q = $q.defer();
        if(LAreaData == ""){
          $http({
            method: 'GET',
            url: config.new_url+"/userinfos/swfarea",
          }).success(function (data, status, headers, config) {
            // 当相应准备就绪时调用
            LAreaData = data.result;
            q.resolve(data.result);
          }).error(function (data, status, headers, config) {
            // 当响应以错误状态返回时调用
            q.reject(data);
          });
        }else{
          q.resolve(LAreaData);
        }
        return q.promise;
      },

      //获取积分记录
      getScoreLog:function(userid,current,pageSize){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url+"/scorelog",
          params:{
            'userid':userid,
            'current':current,
            'pageSize':pageSize,
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      //获取分析数据
      getAnalyzeData:function(userid){
        var q = $q.defer();
        if(userAnalyze == ""){
          $http({
            method: 'GET',
            url: config.new_url+"/personalcenter/analyze",
            params:{
              'userId':userid,
              'source':1,
            }
          }).success(function (data, status, headers, config) {
            // 当相应准备就绪时调用
            if(data.code == 0){
              userAnalyze = data ;
              q.resolve(userAnalyze);
            }else{
              q.resolve(data);
            }
          }).error(function (data, status, headers, config) {
            // 当响应以错误状态返回时调用
            q.reject(data);
          });
        }else{
          q.resolve(userAnalyze);
        }
        return q.promise;
      },

      //获取其他用户的分析数据
      getAnalyzeDataByUserId:function(userId){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url+"/personalcenter/analyze",
          params:{
            'userId':userId,
            'source':1,
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      getRandomCode:function(phone){
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url+"/randomcode",
          params:{
            'phone':phone,
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      updateUserIdentityToMember:function(userId){
        var q = $q.defer();
        $http({
          method: 'PUT',
          url: config.new_url+"/userinfos/useridentity/"+userId,
          params:{
            'phone':phone,
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });
        return q.promise;
      },

      setChallengeIsActive:function(params){
        challengeIsActive = params ;
      },

      getChallengeIsActive:function(){
        return challengeIsActive ;
      },

      setChallengeRecordsType:function(params){
        challengeRecordsType = params ;
      },

      getChallengeRecordsType:function(){
        return challengeRecordsType ;
      }
    }
  })
