angular.module('validation-service',[])
  .factory('validationService',function($http,$q) {
    var transform = [function (data) {
      /**
       * The workhorse; converts an object to x-www-form-urlencoded serialization.
       * @param obj
       * @returns {string}
       */
      var param = function (obj) {
        var query = '';
        var name, value, fullSubName, subName, subValue, innerObj, i;
        for (name in obj) {
          value = obj[name];
          if (value instanceof Array) {
            for (i = 0; i < value.length; ++i) {
              subValue = value[i];
              fullSubName = name + '[' + i + ']';
              innerObj = {};
              innerObj[fullSubName] = subValue;
              query += param(innerObj) + '&';
            }
          } else if (value instanceof Object) {
            for (subName in value) {
              subValue = value[subName];
              fullSubName = name + '[' + subName + ']';
              innerObj = {};
              innerObj[fullSubName] = subValue;
              query += param(innerObj) + '&';
            }
          } else if (value !== undefined && value !== null) {
            query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
          }
        }
        return query.length ? query.substr(0, query.length - 1) : query;
      };
      return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
    }];
    return{
      //查找所有
      updateQualification: function (id,userId, name,region, hospital,email, department, position,licenseNumber,IDFrontpic, IDBackpic, certificatePic) {
        var q = $q.defer();
        $http({
          headers: { 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'},
          transformRequest: transform,
          method: 'POST',
          url: config.new_url + "/qualification",
          data: {
            'id':id,
            'userId':userId,
            'name':name,
            'region':region,
            'email':email,
            'hospital':hospital,
            'department':department,
            'position':position,
            'licenseNumber':licenseNumber,
            'IDFrontpic':IDFrontpic,
            'IDBackpic':IDBackpic,
            'certificatePic':certificatePic
          }
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });
        return q.promise;
      },

      getQualification: function (userId) {
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/qualification?userId="+userId,
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });
        return q.promise;
      }
    }
  })
